c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
*last modification: 15-Apr-1997

      SUBROUTINE DRWSTA(
     I			LINIT,IETRN 
     O			 )

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'DMA.INC'

      INTEGER IHIS
      DOUBLE PRECISION VMIN,VMAX

***   DRWSTA - DRAWS STATUS WINDOW
*
**    ARGUMENTS
*
*      
*
**    AUTHOR: H.WAGNER 29-MAY-95
*             C.SCHIEBL (MODIFICATIONS)

**    START OF EXECUTABLE CODE
*     ************************

      CHARACTER*128 CDUMM1,CDUMM2,CDUMM3
      CHARACTER*20 XDATE
      CHARACTER*15 XNODE
      CHARACTER*70 ELENAM
      CHARACTER*2  EABR
      CHARACTER*2 CSHELL(MAXSHELL)
      CHARACTER*3 CLINE(10)
      LOGICAL LINIT
      SAVE TCPUO,IETRNO
      DATA TCPUO /0.D0/
      DATA IETRN0 /0/
      PARAMETER YMARG=10.D0,XMARG=20.D0,YDELT=16.D0,XDELT=30.D0
      PARAMETER XXOFF=20.D0,XYOFF=220.D0,XXSTEP=60.D0,XYSTEP=13.D0

      DATA CSHELL / 'K',
     &              'L1','L2','L3',
     &              'M1','M2','M3','M4','M5',
     &              'N1','N2','N3','N4','N5','N6','N7'/

      DATA CLINE  / 'KA1','KA2','KB1','LA1','LA2','LB1',
     &              'LB2','LB3','MA','MB'/
      
*     CLEAR WINDOW

      CALL F_OUTPUTTO(NXSTAT,NS)
      CALL F_SETFONTSIZE(17.D0,NS)
      CALL F_CLEAR(NS)

*     THE AUTHORS
      CALL F_PEN(19,NS)
      CALL F_FILLEDRECTANGLES(0.0D0,YMARG+18.4*YDELT,600.0D0,
     &                        YMARG+21.2*YDELT,NS)
      CALL F_PEN(20,NS)
      CALL F_FILLEDRECTANGLES(0.0D0,YMARG+18.2*YDELT,600.0D0,
     &                        YMARG+18.4*YDELT,NS)
      CALL F_FILLEDRECTANGLES(597.0D0,YMARG+18.2*YDELT,600.0D0,
     &                        YMARG+21.5*YDELT,NS)
C      CALL F_PEN(17,NS)
      CALL F_FILLEDRECTANGLES(0.0D0,YMARG+21.05*YDELT,600.0D0,
     &                        YMARG+21.5*YDELT,NS)
      CALL F_FILLEDRECTANGLES(0.0D0,YMARG+18.2*YDELT,3.0D0,
     &                        YMARG+21.5*YDELT,NS)
      CALL F_PEN(1,NS)
      CALL F_DRAWSTRING(XMARG+37,YMARG+19.5*YDELT,
     &       'C h r i s t i a n   S c h i e b l,  Consultant,' //
     &       '  CAMA_NT,  Hudson/Krems')
      CALL F_DRAWSTRING(XMARG-5,YMARG+20.7*YDELT,
     &       'Horst   W a g n e r,  Arnold   P f e i f f e r, ' //
     &       ' Hannes   S t i p p e l,  Vinod   A m b r o s e')
c      CALL F_DRAWSTRING(XMARG,YMARG+19.5*YDELT,
c     &       'Horst Wagner, CAMA_NT, Wien (up to V1.22)')
c      CALL F_DRAWSTRING(XMARG,YMARG+20.2*YDELT,
c     &       'Arnold Pfeiffer and Hannes Stippel, Wien (up to V1.0)')
c      CALL F_DRAWSTRING(XMARG,YMARG+20.9*YDELT,
c     &       'Vinod Ambrose, CAMA_NT, Hudson')

      IF (LINIT) RETURN

*     JOBNAME

      XNODE='               '
      CALL ZZZNOD(XNODE)
      CDUMM1 = 'JOB : '// JOB(1:IEND(JOB)) //' ON '// XNODE
      CALL F_DRAWSTRING(XMARG,YMARG+1*YDELT,CDUMM1)       
      XDATE='                    '
      CALL ZZZDAT(XDATE)
      CALL F_DRAWSTRING(XMARG+14*XDELT,YMARG+1*YDELT,XDATE)       
       
*     TOTAL NUMBER OF ELECTRONS

      WRITE(CDUMM1,'(SS,F7.0)') E0/1000.
      WRITE(CDUMM2,'(SS,F5.0)') EF
      CDUMM3 = 'ELECTRONS ('//CDUMM1(1:IEND(CDUMM1))//'keV - '//
     .		CDUMM2(1:IEND(CDUMM2)) // 'eV)'
      CALL F_DRAWSTRING(XMARG,YMARG+3*YDELT,CDUMM3)
      WRITE(CDUMM1,'(I7)') NETRN
      WRITE(CDUMM3,'(I7)') IETRN
      WRITE(CDUMM2,'(F5.1)') DBLE(IETRN)/DBLE(NETRN)*100.D0
      CALL F_DRAWSTRING(XMARG+XDELT,YMARG+4*YDELT,'TOTAL:')
      CALL F_DRAWSTRING(XMARG+7*XDELT,YMARG+4*YDELT,CDUMM1)
      CALL F_DRAWSTRING(XMARG+XDELT,YMARG+5*YDELT,'SIMULATED :')
      CALL F_DRAWSTRING(XMARG+7*XDELT,YMARG+5*YDELT,CDUMM3)       
      CALL F_DRAWSTRING(XMARG+9*XDELT,YMARG+5*YDELT,
     .  		CDUMM2(1:IEND(CDUMM2))//' %')

*     BACKSCATTERED AND TRANSMITTED 

      IF (IETRN .GT. 0) THEN
          BF = DBLE(NBACK)/DBLE(IETRN)*100.D0
          WRITE(CDUMM1,'(F5.1)') BF
          WRITE(CDUMM2,'(I7)') NBACK
          CALL F_DRAWSTRING(XMARG+XDELT,YMARG+6*YDELT,'BACKSCATTERED :')       
          CALL F_DRAWSTRING(XMARG+7*XDELT,YMARG+6*YDELT,CDUMM2)       
          CALL F_DRAWSTRING(XMARG+9*XDELT,YMARG+6*YDELT,
     .			   CDUMM1(1:IEND(CDUMM1)) // ' %')       

          TF = DBLE(NTRAN)/DBLE(IETRN)*100.D0
          WRITE(CDUMM1,'(F5.1)') TF
          WRITE(CDUMM2,'(I7)') NTRAN
          CALL F_DRAWSTRING(XMARG+XDELT,YMARG+7*YDELT,'TRANSMITTED   :')       
          CALL F_DRAWSTRING(XMARG+7*XDELT,YMARG+7*YDELT,CDUMM2)       
          CALL F_DRAWSTRING(XMARG+9*XDELT,YMARG+7*YDELT,
     .			   CDUMM1(1:IEND(CDUMM1)) // ' %')       


      ENDIF

*     MEASUREMENT SETUP:
      CALL F_DRAWSTRING(XMARG,YMARG+8.5*YDELT,'MEASUREMENT SETUP :')
      CALL F_DRAWSTRING(XMARG+XDELT,YMARG+9.5*YDELT,'BEAM CURRENT :')
      WRITE(CDUMM1,'(F10.2)') CURRENT
      CALL F_DRAWSTRING(XMARG+7*XDELT,YMARG+9.5*YDELT,
     &                  CDUMM1(1:IEND(CDUMM1)) // ' nA')
      CALL F_DRAWSTRING(XMARG+XDELT,YMARG+10.5*YDELT,'COUNTING TIME :')
      WRITE(CDUMM1,'(F10.2)') MTIME
      CALL F_DRAWSTRING(XMARG+7*XDELT,YMARG+10.5*YDELT,
     &                  CDUMM1(1:IEND(CDUMM1)) // ' sec')
      CALL F_DRAWSTRING(XMARG+XDELT,YMARG+11.5*YDELT,'BEAM TILT :')
      WRITE(CDUMM1,'(F10.2)') EBTILT
      CALL F_DRAWSTRING(XMARG+7*XDELT,YMARG+11.5*YDELT,
     &                  CDUMM1(1:IEND(CDUMM1)) // ' deg')
      CALL F_DRAWSTRING(XMARG+XDELT,YMARG+12.5*YDELT,'BEAM ROTATION :')
      WRITE(CDUMM1,'(F10.2)') EBROT
      CALL F_DRAWSTRING(XMARG+7*XDELT,YMARG+12.5*YDELT,
     &                  CDUMM1(1:IEND(CDUMM1)) // ' deg')



*	CPU TIME

      CALL ZZZSEC(TCPU)
      WRITE(CDUMM1,'(F10.2)') TCPU 
      CALL F_DRAWSTRING(XMARG,YMARG+14.0*YDELT,'USED CPU TIME (sec) :')
      CALL F_DRAWSTRING(XMARG+9*XDELT,YMARG+14.0*YDELT,CDUMM1)   
      IF (IETRN .GT. IETRNO) THEN
       EPCPU = (IETRN-IETRNO)/(TCPU-TCPUO)
       WRITE(CDUMM1,'(F10.2)') EPCPU
       WRITE(CDUMM2,'(F10.2)') (NETRN-IETRN)/EPCPU
       CALL F_DRAWSTRING(XMARG,YMARG+15.0*YDELT,
     &                   'ELECTRONS PER CPU SEC:')
       CALL F_DRAWSTRING(XMARG+9*XDELT,YMARG+15.0*YDELT,CDUMM1)   
       CALL F_DRAWSTRING(XMARG,YMARG+16.0*YDELT,
     & 			 'ESTIMATED CPU TIME LEFT :')
       CALL F_DRAWSTRING(XMARG+9*XDELT,YMARG+16.0*YDELT,CDUMM2)   
       IETRNO=IETRN
       TCPUO = TCPU
      ENDIF   

*     LEGEND OF IONISATION SYMBOLS

      IF (NSHELL .GT. 0) THEN
        CALL F_DRAWSTRING(380.D0,YMARG+3*YDELT,'ION LEGEND')
        XREGW=70
        YREGW=YDELT*(NSHELL+1)
        YREGW=MIN(YREGW,11*YDELT)
        IF (NSHELL.GT.10) XREGW=140
        IF (NSHELL.GT.20) XREGW=210
        CALL F_RECTANGLE(380.D0,YMARG+3*YDELT+5.D0,XREGW,
     .			 YREGW-9.D0,NS)
        XSHPOS1=390
        XSHPOS2=398
        IOFF=0
        DO 100 I=1,NSHELL
          IF (I.EQ.11) THEN
             XSHPOS1=460
             XSHPOS2=468
             IOFF=10
          ELSE IF (I.EQ.21) THEN
             XSHPOS1=530
             XSHPOS2=538
             IOFF=20
          ENDIF
          IELE = ELEMOFSHELL(I)
          ISHELL = SHELLOFSHELL(I)
          CALL DRWION(0,XSHPOS1,YMARG+YDELT*(I-IOFF+3)-1.D0,
     &                0.D0,IELE,ISHELL)
          CALL ELMENT(0,ELENAM,ATNUM(IELE),EABR,RM,FDENS,IER)
      	  CDUMM1 = EABR // ' ' // CSHELL(ISHELL)
          CALL F_DRAWSTRING(XSHPOS2,YMARG+YDELT*(I-IOFF+3)+5,CDUMM1)
100     CONTINUE
      ENDIF

c      CALL F_SETFONTSIZE(17.D0,NS)
c      CALL F_DRAWSTRING(20.D0,215.D0,
c     &                  '*** SeSAME 2.1 , March 1997 ***')
c      CALL F_DRAWSTRING(47.D0,235.D0,
c     &        'Christian Schiebl, Consultant, Krems/Hudson')

C  DRAW BUTTONS

      CALL F_PEN(31,NS)
      CALL F_FILLEDRECTANGLES(DBLE(BUTX1(1)),DBLE(BUTY1(1)),
     .                        DBLE(BUTX2(1)),DBLE(BUTY2(1)),NS)

      CALL F_PEN(2,NS)

      CALL F_FILLEDTRIANGLE(DBLE(BUTX1(1)),DBLE(BUTY1(1)),
     .	   (DBLE(2*BUTX1(1))+DBLE(BUTX2(1)))/3.D0,DBLE(BUTY1(1)),
     .     DBLE(BUTX1(1)),(DBLE(2*BUTY1(1))+DBLE(BUTY2(1)))/3.D0,NS) 	 

      CALL F_FILLEDTRIANGLE(DBLE(BUTX2(1)),DBLE(BUTY1(1)),
     .	   (DBLE(BUTX1(1))+DBLE(2*BUTX2(1)))/3.D0,DBLE(BUTY1(1)),
     .     DBLE(BUTX2(1)),(DBLE(2*BUTY1(1))+DBLE(BUTY2(1)))/3.D0,NS) 	 

      CALL F_FILLEDTRIANGLE(DBLE(BUTX1(1)),DBLE(BUTY2(1)),
     .	   (DBLE(2*BUTX1(1))+DBLE(BUTX2(1)))/3.D0,DBLE(BUTY2(1)),
     .     DBLE(BUTX1(1)),(DBLE(BUTY1(1))+DBLE(2*BUTY2(1)))/3.D0,NS) 	 

      CALL F_FILLEDTRIANGLE(DBLE(BUTX2(1)),DBLE(BUTY2(1)),
     .	   (DBLE(BUTX1(1))+DBLE(2*BUTX2(1)))/3.D0,DBLE(BUTY2(1)),
     .     DBLE(BUTX2(1)),(DBLE(BUTY1(1))+DBLE(2*BUTY2(1)))/3.D0,NS) 	 

      CALL F_PEN(0,NS)

      CALL F_DRAWSTRING(DBLE(BUTX1(1)+5),
     .		 (DBLE(BUTY1(1))+DBLE(2*BUTY2(1)))/3.D0,'STOP')

      CALL F_PEN(1,NS)
      CALL F_RECTANGLES(DBLE(BUTX1(1)),DBLE(BUTY1(1)),
     .                        DBLE(BUTX2(1)),DBLE(BUTY2(1)),NS)


      END

*****************************************************************************

      SUBROUTINE STATXT(
     I			CSTATXT 
     O			 )

       INCLUDE 'TYPE.INC'
       INCLUDE 'PARAM.INC'
       INCLUDE 'COMMON.INC'
       INCLUDE 'GLOBAL.INC'
       INCLUDE 'HIST.INC'
       INCLUDE 'OUTPUT.INC'

       CHARACTER *(*) CSTATXT

***    STATXT - WRITES STATUS TEXT IN STATUS WINDOW OR ON TERMINAL IN BATCH MODE
*
**     ARGUMENTS
*
**     AUTHOR: H.WAGNER 29-JUN-95
*
**     START OF EXECUTABLE CODE
*      ************************

       IF (LSTATW) THEN 
         CALL F_OUTPUTTO(NXSTAT,NS)
         CALL F_SETFONTSIZE(17.D0,NS)
         CALL F_PEN(0,NS)
         CALL F_FILLEDRECTANGLE(20.D0,270.D0,520.D0,30.D0,NS)
         CALL F_PEN(1,NS)
         CALL F_DRAWSTRING(20.D0,290.D0,'STATUS: '//CSTATXT)         
       ELSE
          WRITE(6,'(A)') CSTATXT
       ENDIF
     
       END

*****************************************************************************
*last modification: 14-Mar-1997

      SUBROUTINE DRWXCT(
     I			INIT,IETRN
     O			 )

***    DRWSTA - DRAWS XCHAR-TABLE WINDOW
*
**     ARGUMENTS:
*                INIT  - 1: INITIALIZATION
*                        2: UPDATE
*                IETRN - CURRENT NUMBER OF SIMULATED ELECTRONS
*      
**     AUTHOR: CHRISTIAN SCHIEBL
*              CONSULTANT (FORMER CEC-VIENNA)
*              KREMS/HUDSON, MARCH 1997
*
       INCLUDE 'TYPE.INC'
       INCLUDE 'PARAM.INC'
       INCLUDE 'COMMON.INC'
       INCLUDE 'GLOBAL.INC'
       INCLUDE 'HIST.INC'
       INCLUDE 'OUTPUT.INC'
       INCLUDE 'DMA.INC'

**     START OF EXECUTABLE CODE
*      ************************

       CHARACTER*128 CDUMM1,CDUMM2,CDUMM3

       CHARACTER*70 ELENAM
       CHARACTER*2  EABR
       CHARACTER*3 CLINE(10)

       PARAMETER YMARG=10.D0,XMARG=20.D0,YDELT=16.D0,XDELT=30.D0
       PARAMETER XXOFF=50.D0,XYOFF=70.D0,XXSTEP=75.D0,XYSTEP=17.D0

       DATA CLINE  / 'KA1','KA2','KB1','LA1','LA2','LB1',
     &              'LB2','LB3','MA','MB'/
      
*      CLEAR WINDOW

       CALL F_OUTPUTTO(NXCSTAT,NS)
       CALL F_SETFONTSIZE(17.D0,NS)
       CALL F_PEN(1,NS)
       CALL F_CLEAR(NS)

       CALL CCLEAR(CDUMM1)
       CDUMM1='Element'
       CALL F_DRAWSTRING(XMARG/2,YMARG+3*YDELT+6,CDUMM1)       
       CALL CCLEAR(CDUMM1)
       CDUMM1='Line'
       CALL F_DRAWSTRING(XXOFF+29,YMARG+3*YDELT+6,CDUMM1)       
       CALL CCLEAR(CDUMM1)
       CDUMM1='GEN'
       CALL F_DRAWSTRING(XXOFF+1.2*XXSTEP,YMARG+1*YDELT,CDUMM1)       
       CALL CCLEAR(CDUMM1)
       CDUMM1='(/e/sr)'
       CALL F_DRAWSTRING(XXOFF+1.2*XXSTEP,YMARG+2*YDELT+2,CDUMM1)       
       CALL CCLEAR(CDUMM1)
       CDUMM1='DETECTED'
       CALL F_DRAWSTRING(XXOFF+XXSTEP*(2.5+NXDET),
     &                   YMARG+1*YDELT,CDUMM1)       
       CALL CCLEAR(CDUMM1)
       CDUMM1='(/e/sr)'
       CALL F_DRAWSTRING(XXOFF+(2.1+0.5*NXDET)*XXSTEP,
     &                   YMARG+2*YDELT+3,CDUMM1(1:7))
       CALL CCLEAR(CDUMM1)
       CDUMM1='(cts/sec)'
       CALL F_DRAWSTRING(XXOFF+(3.1+1.5*NXDET)*XXSTEP+3,
     &                   YMARG+2*YDELT+3,CDUMM1(1:9))

       CALL CCLEAR(CDUMM1)
       DO 5 I=0,NXDET
         CDUMM1='Det#'
         WRITE(CDUMM1(5:5),'(I1)')I
         CALL F_DRAWSTRING(XXOFF+9+XXSTEP*(I+2),YMARG+3*YDELT+6,CDUMM1)       
         CALL F_DRAWSTRING(XXOFF+14+XXSTEP*(I+3+NXDET),
     &                     YMARG+3*YDELT+6,CDUMM1)       
 5     CONTINUE

       DO 7 I=1,NXCHAR
          IELE = ELEMOFXCHAR(I)
          IXCHAR=XCHAROFXCHAR(I)
          CALL ELMENT(0,ELENAM,ATNUM(IELE),EABR,RM,FDENS,IER)
          CDUMM1 = EABR
          CALL F_DRAWSTRING(1.5*XMARG,XYOFF+XYSTEP*I,CDUMM1(1:2))
          CDUMM1 = CLINE(IXCHAR)
          CALL F_DRAWSTRING(XXOFF+29,XYOFF+XYSTEP*I,CDUMM1(1:3))
 7     CONTINUE

       CALL F_PEN(1,NS)
       CALL F_MOVE(XXOFF+25,YMARG+2*YDELT+7,NS)
       CALL F_FLINETO(XXOFF+25,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(31,NS)
       CALL F_MOVE(XXOFF+69,YMARG-2,NS)
       CALL F_FLINETO(XXOFF+69,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(1,NS)
       CALL F_MOVE(XXOFF+71,YMARG-2,NS)
       CALL F_FLINETO(XXOFF+71,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(31,NS)
       CALL F_MOVE(XXOFF-3+XXSTEP*2,YMARG-2,NS)
       CALL F_FLINETO(XXOFF-3+XXSTEP*2,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(1,NS)
       CALL F_MOVE(XXOFF-1+XXSTEP*2,YMARG-2,NS)
       CALL F_FLINETO(XXOFF-1+XXSTEP*2,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(31,NS)
       CALL F_MOVE(XXOFF+2+XXSTEP*(3+NXDET),YMARG+1*YDELT+3,NS)
       CALL F_FLINETO(XXOFF+2+XXSTEP*(3+NXDET),
     &                XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(1,NS)
       DO 70 I=1,NXDET
          CALL F_MOVE(XXOFF-1+XXSTEP*(I+2),YMARG+2*YDELT+7,NS)
          CALL F_FLINETO(XXOFF-1+XXSTEP*(I+2),
     &                   XYOFF+XYSTEP*NXCHAR+2,NS)
          CALL F_MOVE(XXOFF+4+XXSTEP*(I+3+NXDET),YMARG+2*YDELT+7,NS)
          CALL F_FLINETO(XXOFF+4+XXSTEP*(I+3+NXDET),
     &                   XYOFF+XYSTEP*NXCHAR+2,NS)
 70    CONTINUE

       CALL F_MOVE(XXOFF+4+XXSTEP*(3+NXDET),YMARG+1*YDELT+3,NS)
       CALL F_FLINETO(XXOFF+4+XXSTEP*(3+NXDET),
     &                XYOFF+XYSTEP*NXCHAR,NS)
       CALL F_PEN(31,NS)
       CALL F_MOVE(0.D0,XYOFF,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),XYOFF,NS)

       CALL F_PEN(1,NS)
       CALL F_MOVE(XXOFF+71,YMARG-1,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),YMARG-1,NS)
       CALL F_MOVE(XXOFF+71,YMARG+1*YDELT+3,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),YMARG+1*YDELT+3,NS)
       CALL F_MOVE(XXOFF-1+XXSTEP*2,YMARG+2*YDELT+7,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),YMARG+2*YDELT+7,NS)
       CALL F_MOVE(0.D0,YMARG+2*YDELT+7,NS)
       CALL F_FLINETO(XXOFF+68,YMARG+2*YDELT+7,NS)
       DO 80 I=0,NXCHAR
          CALL F_MOVE(0.D0,XYOFF+XYSTEP*I+2,NS)
          CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),
     &                   XYOFF+XYSTEP*I+2,NS)
 80    CONTINUE

       CALL F_PEN(31,NS)
       CALL F_MOVE(0.D0,YMARG+2*YDELT+5,NS)
       CALL F_FLINETO(XXOFF+68,YMARG+2*YDELT+5,NS)
       CALL F_MOVE(XXOFF+69,YMARG-3,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),YMARG-3,NS)
       CALL F_MOVE(0.D0,XYOFF+XYSTEP*NXCHAR+4,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),
     &                XYOFF+XYSTEP*NXCHAR+4,NS)
       CALL F_PEN(1,NS)

       IF (INIT.EQ.1) GOTO 99
       DO 10 I=1,NXCHAR
          IF (IETRN.EQ.0) THEN
             WRITE(CDUMM1,'(1P,SS,G8.2)')XGENOFXCHAR(I)
          ELSE
             WRITE(CDUMM1,'(1P,SS,G8.2)')XGENOFXCHAR(I)/IETRN
          ENDIF
          CALL F_DRAWSTRING(XXOFF+XXSTEP,XYOFF+XYSTEP*I,
     .  	            CDUMM1(1:8))
 10    CONTINUE

       DO 30 I=1,NXCHAR
          DO 20 J=0,NXDET
             IXINDX=(I-1)*NDMAXDET+(J+1)
             CALL CHKBND (20,IXINDX,'DRWSTA    ','XDETOFXCHAR')
             IF (IETRN.EQ.0) THEN
CS               WRITE(CDUMM1,'(1P,SS,G8.2)')XDETOFXCHAR(J,I)
       	       WRITE(CDUMM1,'(1P,SS,G8.2)')XDETOFXCHAR(IXINDX)
             ELSE
CS               WRITE(CDUMM1,'(1P,SS,G8.2)')XDETOFXCHAR(J,I)/IETRN
               WRITE(CDUMM1,'(1P,SS,G8.2)')XDETOFXCHAR(IXINDX)/IETRN
             ENDIF
      	     CALL F_DRAWSTRING(XXOFF+5+XXSTEP*(J+2),XYOFF+XYSTEP*I,
     .  		   CDUMM1(1:8))
20	  CONTINUE
30     CONTINUE
       DO 50 I=1,NXCHAR
          DO 40 J=0,NXDET
             IXINDX=(I-1)*NDMAXDET+(J+1)
             CALL CHKBND (20,IXINDX,'DRWSTA    ','XDETOFXCHAR')
             IF (IETRN.EQ.0) THEN
CS                WRITE(CDUMM1,'(1P,SS,G8.2)')XDETOFXCHAR(J,I)
       	        VAL=XDETOFXCHAR(IXINDX)
     .              *6.24219725D9*DSOLIDA(J)*CURRENT
CS                WRITE(6,*)VAL,J,I
                IF ((VAL.GT.999999.0).OR.(VAL.LT.0.1)) THEN
                  WRITE(CDUMM1,'(1P,SS,G8.2)')VAL
                ELSE IF (VAL.LT.10) THEN
                  WRITE(CDUMM1,'(F8.3)')VAL
                ELSE
     	          WRITE(CDUMM1,'(F8.1)')VAL
                ENDIF
              ELSE
CS                WRITE(CDUMM1,'(1P,SS,G8.2)')XDETOFXCHAR(J,I)/IETRN
        	VAL=XDETOFXCHAR(IXINDX)
     .              *6.24219725D9*DSOLIDA(J)*CURRENT/IETRN
CS                WRITE(6,*)VAL,J,I
                IF ((VAL.GT.999999.0).OR.(VAL.LT.0.1)) THEN
                  WRITE(CDUMM1,'(1P,SS,G8.2)')VAL
                ELSE IF (VAL.LT.10) THEN
                  WRITE(CDUMM1,'(F8.3)')VAL
                ELSE
                  WRITE(CDUMM1,'(F8.1)')VAL
                ENDIF
             ENDIF
      	     CALL F_DRAWSTRING(XXOFF+10+XXSTEP*(J+3+NXDET),
     .                         XYOFF+XYSTEP*I,CDUMM1(1:8))
40	  CONTINUE
50     CONTINUE

99     CALL F_FSHOW(NS)


       RETURN
       END

*****************************************************************************
*last modification: 15-Apr-1997

       SUBROUTINE DRWXKT(
     I			INIT,IETRN
     O			 )

***    DRWXKT - DRAWS PEAK-TO-BACKGROUND WINDOW
*
**     ARGUMENTS:
*                INIT  - 1: INITIALIZATION
*                        2: UPDATE
*                IETRN - CURRENT NUMBER OF SIMULATED ELECTRONS
*      
**     AUTHOR: CHRISTIAN SCHIEBL
*              CONSULTANT (FORMER CEC-VIENNA)
*              KREMS/HUDSON, MARCH 1997
*
       INCLUDE 'TYPE.INC'
       INCLUDE 'PARAM.INC'
       INCLUDE 'COMMON.INC'
       INCLUDE 'GLOBAL.INC'
       INCLUDE 'HIST.INC'
       INCLUDE 'OUTPUT.INC'
       INCLUDE 'DMA.INC'

**     START OF EXECUTABLE CODE
*      ************************

       CHARACTER*128 CDUMM1,CDUMM2,CDUMM3

       CHARACTER*70 ELENAM
       CHARACTER*2  EABR
       CHARACTER*3 CLINE(10)

       PARAMETER YMARG=10.D0,XMARG=20.D0,YDELT=16.D0,XDELT=30.D0
       PARAMETER XXOFF=50.D0,XYOFF=70.D0,XXSTEP=75.D0,XYSTEP=17.D0

       DATA CLINE  / 'KA1','KA2','KB1','LA1','LA2','LB1',
     &              'LB2','LB3','MA','MB'/
      
*      CLEAR WINDOW

       CALL F_OUTPUTTO(NXKSTAT,NS)
       CALL F_SETFONTSIZE(17.D0,NS)
       CALL F_PEN(1,NS)
       CALL F_CLEAR(NS)

       CALL CCLEAR(CDUMM1)
       DO 30 I=1,NXCHAR
          IF (IXCHAROFXCONT(I).LE.0) GOTO 30
          DO 20 J=0,NXDET
             INDX=NDMAXDET*(IXCHAROFXCONT(I)-1)+(J+1)
             CALL CHKBND (13,INDX,'DRWXKA','XDETOFXCONT')
             IXINDX=(I-1)*NDMAXDET+(J+1)
             CALL CHKBND (20,IXINDX,'DRWXKA    ','XDETOFXCHAR')
*            FIORI FACTOR: FULL PEAK OVER A CONSTANT BACKGROUND
*            OF 10 eV ENERGY RANGE, 5 eV AT BOTH SIDES OF CHARACTERISTIC
*            ENERGY OF ACTUAL PEAK MAXIMUM
             IF (XDETOFXCONT(INDX).LE.0) GOTO 20
             XFIORIFACT(IXINDX)=XDETOFXCHAR(IXINDX)/10/
     &                          XDETOFXCONT(INDX)
             VAL=XFIORIFACT(IXINDX)*10
             IF ((VAL.GT.999999.0).OR.(VAL.LT.0.1)) THEN
                WRITE(CDUMM1,'(1P,SS,G8.2)')VAL
             ELSE IF (VAL.LT.10) THEN
                WRITE(CDUMM1,'(F8.3)')VAL
             ELSE
                WRITE(CDUMM1,'(F8.1)')VAL
             ENDIF
      	     CALL F_DRAWSTRING(XXOFF+5+XXSTEP*(J+2),XYOFF+XYSTEP*I,
     .  		   CDUMM1(1:8))
20	  CONTINUE
30     CONTINUE
       DO 50 I=1,NXCHAR
          DO 40 J=0,NXDET
             INDX=NDMAXDET*(IXCHAROFXCONT(I)-1)+(J+1)
             CALL CHKBND (13,INDX,'DRWXKT','XDETOFXCONT')
             IXINDX=(I-1)*NDMAXDET+(J+1)
             CALL CHKBND (20,IXINDX,'DRWSTA    ','XDETOFXCHAR')
             IF (DXDTYPE(J).EQ.'WD') THEN
*               PEAK MEASURED AT PEAK MAXIMUM
*               PEAK-TO-BACKGROUND IS THEN SIMPLY THE PEAK HIGHT AT
*               PEAK MAXIMUM DEVIDED BY BACKGROUND AT SAME ENERGY
                IF (XDETOFXCONT(INDX).LE.0) GOTO 40
CS                IF (DFWHM(J).GT.100) DFWHM(J)=10
                XINTST=XDETOFXCHAR(IXINDX)*0.93944/DFWHM(J)
                XPEAKTOBACK(IXINDX)=XINTST/XDETOFXCONT(INDX)
*               DETERMINE WHETHER THE CURRENT PEAK WOULD BE DETECTABLE
*               WITH THE CURRENT DETECTOR CONFIGURATION
                PEAKCNTS=XINTST*6.24219725D9*DSOLIDA(J)*
     &                   CURRENT*MTIME/DBLE(IETRN)
                BACKCNTS=XDETOFXCONT(INDX)*6.24219725D9*DSOLIDA(J)*
     &                   CURRENT*MTIME/DBLE(IETRN)
                SDOFBACKCNTS=DSQRT(BACKCNTS)
CS              WRITE(6,'(2I4,3D15.5)')J,I,PEAKCNTS,BACKCNTS,SDOFBACKCNTS
                IF (PEAKCNTS.LT.SDOFBACKCNTS) THEN
                   IDETABLE=2
                ELSE IF (PEAKCNTS.LT.3*SDOFBACKCNTS) THEN
                   IDETABLE=1
                ELSE
                   IDETABLE=0
                ENDIF
             ELSE
                IF (XDETOFXCONT(INDX).LE.0) GOTO 40
*               ACTUAL FWHM AT ENERGY OF CHARACTERISTIC X-RAY LINE
CS                XFWHM=DSQRT(2.5*(ENEROFXCHAR(I)-DENFWHM(J))+DFWHM(J)**2)
                XFWHM=FWHMOFXCHAR(IXINDX)
*               TAKE 3 SIGMA RANGE
                ENINTV=6*XFWHM/2.355
*               TAKE FULL PEAK SIGNAL DEVIDED BY A CONSTANT BACKGROUND
*               OF A 3 SIGMA ENERGY RANGE
                XPEAKTOBACK(IXINDX)=XDETOFXCHAR(IXINDX)/ENINTV/
     &                             XDETOFXCONT(INDX)
*               DETERMINE WHETHER THE CURRENT PEAK WOULD BE DETECTABLE
*               WITH THE CURRENT DETECTOR CONFIGURATION
                PEAKCNTS=XDETOFXCHAR(IXINDX)*6.24219725D9*DSOLIDA(J)*
     &                   CURRENT*MTIME/DBLE(IETRN)
                BACKCNTS=XDETOFXCONT(INDX)*ENINTV*6.24219725D9*
     &                   DSOLIDA(J)*MTIME/DBLE(IETRN)
                SDOFBACKCNTS=DSQRT(BACKCNTS)
CS              WRITE(6,'(2I4,3D15.5)')J,I,PEAKCNTS,BACKCNTS,SDOFBACKCNTS
                IF (PEAKCNTS.LT.SDOFBACKCNTS) THEN
                   IDETABLE=2
                ELSE IF (PEAKCNTS.LT.3*SDOFBACKCNTS) THEN
                   IDETABLE=1
                ELSE
                   IDETABLE=0
                ENDIF
             ENDIF
             IF (IDETABLE.GT.0) THEN
                IF (IDETABLE.EQ.1) THEN
                   CALL F_PEN(19,NS)
                ELSE
                   CALL F_PEN(31,NS)
                ENDIF
                CALL F_FILLEDRECTANGLE(XXOFF+5+XXSTEP*(J+3+NXDET),
     &                                 XYOFF+XYSTEP*(I-1)+3,
     &                                 XXSTEP,XYSTEP,NS)
                CALL F_PEN(1,NS)
             ENDIF
             VAL=XPEAKTOBACK(IXINDX)
             IF ((VAL.GT.999999.0).OR.(VAL.LT.0.1)) THEN
                WRITE(CDUMM1,'(1P,SS,G8.2)')VAL
             ELSE IF (VAL.LT.10) THEN
                WRITE(CDUMM1,'(F8.3)')VAL
             ELSE
                WRITE(CDUMM1,'(F8.1)')VAL
             ENDIF
             IF (IDETABLE.EQ.2) CALL F_PEN(0,NS)
      	     CALL F_DRAWSTRING(XXOFF+10+XXSTEP*(J+3+NXDET),
     .                         XYOFF+XYSTEP*I,CDUMM1(1:8))
             CALL F_PEN(1,NS)
40	  CONTINUE
50     CONTINUE

       CALL CCLEAR(CDUMM1)
       CDUMM1='Element'
       CALL F_DRAWSTRING(XMARG/2,YMARG+3*YDELT+6,CDUMM1)       
       CALL CCLEAR(CDUMM1)
       CDUMM1='Line'
       CALL F_DRAWSTRING(XXOFF+29,YMARG+3*YDELT+6,CDUMM1)       
       CALL CCLEAR(CDUMM1)
       CDUMM1='Energy'
       CALL F_DRAWSTRING(XXOFF+1.2*XXSTEP,YMARG+3*YDELT+6,CDUMM1)       
       CALL CCLEAR(CDUMM1)
CS       CDUMM1='(/e/sr)'
CS       CALL F_DRAWSTRING(XXOFF+1.2*XXSTEP,YMARG+2*YDELT+2,CDUMM1)       
CS       CALL CCLEAR(CDUMM1)
       CDUMM1='PEAK/BACK'
       CALL F_DRAWSTRING(XXOFF+XXSTEP*(2.5+NXDET),
     &                   YMARG+1*YDELT,CDUMM1)       
       CALL CCLEAR(CDUMM1)
       CDUMM1='(P/1eV B)'
       CALL F_DRAWSTRING(XXOFF+(2.1+0.5*NXDET)*XXSTEP,
     &                   YMARG+2*YDELT+3,CDUMM1(1:9))
       CALL CCLEAR(CDUMM1)
       CDUMM1='(P/3s B)'
       CALL F_DRAWSTRING(XXOFF+(3.1+1.5*NXDET)*XXSTEP+3,
     &                   YMARG+2*YDELT+3,CDUMM1(1:8))

       CALL CCLEAR(CDUMM1)
       DO 5 I=0,NXDET
         CDUMM1='Det#'
         WRITE(CDUMM1(5:5),'(I1)')I
         CALL F_DRAWSTRING(XXOFF+9+XXSTEP*(I+2),YMARG+3*YDELT+6,CDUMM1)       
         CALL F_DRAWSTRING(XXOFF+14+XXSTEP*(I+3+NXDET),
     &                     YMARG+3*YDELT+6,CDUMM1)       
 5     CONTINUE

       DO 7 I=1,NXCHAR
          IELE = ELEMOFXCHAR(I)
          IXCHAR=XCHAROFXCHAR(I)
          CALL ELMENT(0,ELENAM,ATNUM(IELE),EABR,RM,FDENS,IER)
          CDUMM1 = EABR
          CALL F_DRAWSTRING(1.5*XMARG,XYOFF+XYSTEP*I,CDUMM1(1:2))
          CDUMM1 = CLINE(IXCHAR)
          CALL F_DRAWSTRING(XXOFF+29,XYOFF+XYSTEP*I,CDUMM1(1:3))
 7     CONTINUE

       DO 10 I=1,NXCHAR
          WRITE(CDUMM1,'(F8.3)')ENEROFXCHAR(I)/1000
          CALL F_DRAWSTRING(XXOFF+XXSTEP,XYOFF+XYSTEP*I,
     .  	            CDUMM1(1:8))
 10    CONTINUE

       CALL F_PEN(1,NS)
       CALL F_MOVE(XXOFF+25,YMARG+2*YDELT+7,NS)
       CALL F_FLINETO(XXOFF+25,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(31,NS)
       CALL F_MOVE(XXOFF+69,YMARG+2*YDELT+7,NS)
       CALL F_FLINETO(XXOFF+69,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(1,NS)
       CALL F_MOVE(XXOFF+71,YMARG+2*YDELT+7,NS)
       CALL F_FLINETO(XXOFF+71,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(31,NS)
       CALL F_MOVE(XXOFF-3+XXSTEP*2,YMARG-2,NS)
       CALL F_FLINETO(XXOFF-3+XXSTEP*2,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(1,NS)
       CALL F_MOVE(XXOFF-1+XXSTEP*2,YMARG-2,NS)
       CALL F_FLINETO(XXOFF-1+XXSTEP*2,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(31,NS)
       CALL F_MOVE(XXOFF+2+XXSTEP*(3+NXDET),YMARG+1*YDELT+3,NS)
       CALL F_FLINETO(XXOFF+2+XXSTEP*(3+NXDET),
     &                XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(1,NS)
       DO 70 I=1,NXDET
          CALL F_MOVE(XXOFF-1+XXSTEP*(I+2),YMARG+2*YDELT+7,NS)
          CALL F_FLINETO(XXOFF-1+XXSTEP*(I+2),
     &                   XYOFF+XYSTEP*NXCHAR+2,NS)
          CALL F_MOVE(XXOFF+4+XXSTEP*(I+3+NXDET),YMARG+2*YDELT+7,NS)
          CALL F_FLINETO(XXOFF+4+XXSTEP*(I+3+NXDET),
     &                   XYOFF+XYSTEP*NXCHAR+2,NS)
 70    CONTINUE

       CALL F_MOVE(XXOFF+4+XXSTEP*(3+NXDET),YMARG+1*YDELT+3,NS)
       CALL F_FLINETO(XXOFF+4+XXSTEP*(3+NXDET),
     &                XYOFF+XYSTEP*NXCHAR,NS)
       CALL F_PEN(31,NS)
       CALL F_MOVE(0.D0,XYOFF,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),XYOFF,NS)

       CALL F_PEN(1,NS)
       CALL F_MOVE(XXOFF-1+XXSTEP*2,YMARG-1,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),YMARG-1,NS)
       CALL F_MOVE(XXOFF-1+XXSTEP*2,YMARG+1*YDELT+3,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),YMARG+1*YDELT+3,NS)
       CALL F_MOVE(XXOFF-1+XXSTEP*2,YMARG+2*YDELT+7,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),YMARG+2*YDELT+7,NS)
       CALL F_MOVE(0.D0,YMARG+2*YDELT+7,NS)
CS       CALL F_FLINETO(XXOFF+68,YMARG+2*YDELT+7,NS)
       CALL F_FLINETO(XXOFF-1+XXSTEP*2,YMARG+2*YDELT+7,NS)
       DO 80 I=0,NXCHAR
          CALL F_MOVE(0.D0,XYOFF+XYSTEP*I+2,NS)
          CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),
     &                   XYOFF+XYSTEP*I+2,NS)
 80    CONTINUE

       CALL F_PEN(31,NS)
       CALL F_MOVE(0.D0,YMARG+2*YDELT+5,NS)
CS       CALL F_FLINETO(XXOFF+68,YMARG+2*YDELT+5,NS)
       CALL F_FLINETO(XXOFF-1+XXSTEP*2,YMARG+2*YDELT+5,NS)
CS       CALL F_MOVE(XXOFF+69,YMARG-3,NS)
       CALL F_MOVE(XXOFF-2+XXSTEP*2,YMARG-3,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),YMARG-3,NS)
       CALL F_MOVE(0.D0,XYOFF+XYSTEP*NXCHAR+4,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),
     &                XYOFF+XYSTEP*NXCHAR+4,NS)
       CALL F_PEN(1,NS)

       CALL F_FSHOW(NS)


       RETURN
       END

******************************************************************************
*last modification: 06-May-1997

       SUBROUTINE DRWXDET(
     I			 INIT,IETRN
     O			 )

***    DRWXDET - DRAWS X-RAY DETECTOR WINDOW
*
**     ARGUMENTS:
*                INIT  - 1: INITIALIZATION
*                        2: UPDATE
*                IETRN - CURRENT NUMBER OF SIMULATED ELECTRONS
*      
**     AUTHOR: CHRISTIAN SCHIEBL
*              CONSULTANT (FORMER CEC-VIENNA)
*              KREMS/HUDSON, MARCH 1997
*
       INCLUDE 'TYPE.INC'
       INCLUDE 'PARAM.INC'
       INCLUDE 'COMMON.INC'
       INCLUDE 'GLOBAL.INC'
       INCLUDE 'HIST.INC'
       INCLUDE 'OUTPUT.INC'
       INCLUDE 'DMA.INC'

**     START OF EXECUTABLE CODE
*      ************************

       CHARACTER*128 CDUMM1,CDUMM2,CDUMM3

       CHARACTER*70 ELENAM
       CHARACTER*2  EABR
       CHARACTER*3 CLINE(10)

       PARAMETER YMARG=10.D0,XMARG=20.D0,YDELT=16.D0,XDELT=30.D0
       PARAMETER XXOFF=50.D0,XYOFF=70.D0,XXSTEP=75.D0,XYSTEP=17.D0

       DATA CLINE  / 'KA1','KA2','KB1','LA1','LA2','LB1',
     &              'LB2','LB3','MA','MB'/
      
*      CLEAR WINDOW

       CALL F_OUTPUTTO(NXDSTAT,NS)
       CALL F_SETFONTSIZE(17.D0,NS)
       CALL F_PEN(1,NS)
       CALL F_CLEAR(NS)

       CALL CCLEAR(CDUMM1)
       CDUMM1='Element'
       CALL F_DRAWSTRING(XMARG/2,YMARG+3*YDELT+6,CDUMM1)       
       CALL CCLEAR(CDUMM1)
       CDUMM1='Line'
       CALL F_DRAWSTRING(XXOFF+29,YMARG+3*YDELT+6,CDUMM1)       
       CALL CCLEAR(CDUMM1)
       CDUMM1='Energy'
       CALL F_DRAWSTRING(XXOFF+1.2*XXSTEP,YMARG+3*YDELT+6,CDUMM1)       
       CALL CCLEAR(CDUMM1)
       IF (NXDET.EQ.0) THEN
          CDUMM1='FWHM'
       ELSE
          CDUMM1='FWHM [eV]'
       ENDIF
       CALL F_DRAWSTRING(XXOFF+(2.1+0.5*NXDET)*XXSTEP,
     &                   YMARG+1*YDELT,CDUMM1)       
       CALL CCLEAR(CDUMM1)
       CDUMM1='transm.[%]'
       CALL F_DRAWSTRING(XXOFF+(3.1+1.5*NXDET)*XXSTEP,
     &                   YMARG+1*YDELT,CDUMM1)       
 
       DO 5 I=0,NXDET
         CALL CCLEAR(CDUMM1)
         CDUMM1(4:5)=XDTYPE(I)
         CALL F_DRAWSTRING(XXOFF+9+XXSTEP*(I+2),
     &                     YMARG+2*YDELT+3,CDUMM1(1:8))
         CALL F_DRAWSTRING(XXOFF+14+XXSTEP*(I+3+NXDET),
     &                     YMARG+2*YDELT+3,CDUMM1(1:8))
         CALL CCLEAR(CDUMM1)
         CDUMM1='Det#'
         WRITE(CDUMM1(5:5),'(I1)')I
         CALL F_DRAWSTRING(XXOFF+9+XXSTEP*(I+2),YMARG+3*YDELT+6,CDUMM1)       
         CALL F_DRAWSTRING(XXOFF+14+XXSTEP*(I+3+NXDET),
     &                     YMARG+3*YDELT+6,CDUMM1)       
 5     CONTINUE

       DO 7 I=1,NXCHAR
          IELE = ELEMOFXCHAR(I)
          IXCHAR=XCHAROFXCHAR(I)
          CALL ELMENT(0,ELENAM,ATNUM(IELE),EABR,RM,FDENS,IER)
          CDUMM1 = EABR
          CALL F_DRAWSTRING(1.5*XMARG,XYOFF+XYSTEP*I,CDUMM1(1:2))
          CDUMM1 = CLINE(IXCHAR)
          CALL F_DRAWSTRING(XXOFF+29,XYOFF+XYSTEP*I,CDUMM1(1:3))
 7     CONTINUE

       DO 10 I=1,NXCHAR
          WRITE(CDUMM1,'(F8.3)')ENEROFXCHAR(I)/1000
          CALL F_DRAWSTRING(XXOFF+XXSTEP,XYOFF+XYSTEP*I,
     .  	            CDUMM1(1:8))
 10    CONTINUE

       DO 30 I=1,NXCHAR
          DO 20 J=0,NXDET
             INDX=NDMAXDET*(I-1)+(J+1)
             VAL=FWHMOFXCHAR(INDX)
             IF ((VAL.GT.999999.0).OR.(VAL.LT.0.1)) THEN
                WRITE(CDUMM1,'(1P,SS,G8.2)')VAL
             ELSE
                WRITE(CDUMM1,'(F8.2)')VAL
             ENDIF
      	     CALL F_DRAWSTRING(XXOFF+5+XXSTEP*(J+2),XYOFF+XYSTEP*I,
     .  		   CDUMM1(1:8))
20	  CONTINUE
30     CONTINUE
       DO 50 I=1,NXCHAR
          DO 40 J=0,NXDET
             INDX=NDMAXDET*(I-1)+(J+1)
             VAL=XDETEFFOFXCHAR(INDX)*100
             IF ((VAL.GT.999999.0).OR.(VAL.LT.0.1)) THEN
                WRITE(CDUMM1,'(1P,SS,G8.2)')VAL
             ELSE
                WRITE(CDUMM1,'(F8.2)')VAL
             ENDIF
      	     CALL F_DRAWSTRING(XXOFF+10+XXSTEP*(J+3+NXDET),
     .                         XYOFF+XYSTEP*I,CDUMM1(1:8))
40	  CONTINUE
50     CONTINUE

       CALL F_PEN(1,NS)
       CALL F_MOVE(XXOFF+25,YMARG+2*YDELT+7,NS)
       CALL F_FLINETO(XXOFF+25,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(31,NS)
       CALL F_MOVE(XXOFF+69,YMARG+2*YDELT+7,NS)
       CALL F_FLINETO(XXOFF+69,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(1,NS)
       CALL F_MOVE(XXOFF+71,YMARG+2*YDELT+7,NS)
       CALL F_FLINETO(XXOFF+71,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(31,NS)
       CALL F_MOVE(XXOFF-3+XXSTEP*2,YMARG-2,NS)
       CALL F_FLINETO(XXOFF-3+XXSTEP*2,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(1,NS)
       CALL F_MOVE(XXOFF-1+XXSTEP*2,YMARG-2,NS)
       CALL F_FLINETO(XXOFF-1+XXSTEP*2,XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(31,NS)
CS       CALL F_MOVE(XXOFF+2+XXSTEP*(3+NXDET),YMARG+1*YDELT+3,NS)
       CALL F_MOVE(XXOFF+2+XXSTEP*(3+NXDET),YMARG-2,NS)
       CALL F_FLINETO(XXOFF+2+XXSTEP*(3+NXDET),
     &                XYOFF+XYSTEP*NXCHAR+2,NS)
       CALL F_PEN(1,NS)
       DO 70 I=1,NXDET
CS          CALL F_MOVE(XXOFF-1+XXSTEP*(I+2),YMARG+2*YDELT+7,NS)
          CALL F_MOVE(XXOFF-1+XXSTEP*(I+2),YMARG+1*YDELT+3,NS)
          CALL F_FLINETO(XXOFF-1+XXSTEP*(I+2),
     &                   XYOFF+XYSTEP*NXCHAR+2,NS)
CS          CALL F_MOVE(XXOFF+4+XXSTEP*(I+3+NXDET),YMARG+2*YDELT+7,NS)
          CALL F_MOVE(XXOFF+4+XXSTEP*(I+3+NXDET),YMARG+1*YDELT+3,NS)
          CALL F_FLINETO(XXOFF+4+XXSTEP*(I+3+NXDET),
     &                   XYOFF+XYSTEP*NXCHAR+2,NS)
 70    CONTINUE

CS       CALL F_MOVE(XXOFF+4+XXSTEP*(3+NXDET),YMARG+1*YDELT+3,NS)
       CALL F_MOVE(XXOFF+4+XXSTEP*(3+NXDET),YMARG-2,NS)
       CALL F_FLINETO(XXOFF+4+XXSTEP*(3+NXDET),
     &                XYOFF+XYSTEP*NXCHAR,NS)
       CALL F_PEN(31,NS)
       CALL F_MOVE(0.D0,XYOFF,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),XYOFF,NS)

       CALL F_PEN(1,NS)
       CALL F_MOVE(XXOFF-1+XXSTEP*2,YMARG-1,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),YMARG-1,NS)
       CALL F_MOVE(XXOFF-1+XXSTEP*2,YMARG+1*YDELT+3,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),YMARG+1*YDELT+3,NS)
       CALL F_MOVE(XXOFF-1+XXSTEP*2,YMARG+2*YDELT+7,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),YMARG+2*YDELT+7,NS)
       CALL F_MOVE(0.D0,YMARG+2*YDELT+7,NS)
CS       CALL F_FLINETO(XXOFF+68,YMARG+2*YDELT+7,NS)
       CALL F_FLINETO(XXOFF-1+XXSTEP*2,YMARG+2*YDELT+7,NS)
       DO 80 I=0,NXCHAR
          CALL F_MOVE(0.D0,XYOFF+XYSTEP*I+2,NS)
          CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),
     &                   XYOFF+XYSTEP*I+2,NS)
 80    CONTINUE

       CALL F_PEN(31,NS)
       CALL F_MOVE(0.D0,YMARG+2*YDELT+5,NS)
CS       CALL F_FLINETO(XXOFF+68,YMARG+2*YDELT+5,NS)
       CALL F_FLINETO(XXOFF-1+XXSTEP*2,YMARG+2*YDELT+5,NS)
CS       CALL F_MOVE(XXOFF+69,YMARG-3,NS)
       CALL F_MOVE(XXOFF-2+XXSTEP*2,YMARG-3,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),YMARG-3,NS)
       CALL F_MOVE(0.D0,XYOFF+XYSTEP*NXCHAR+4,NS)
       CALL F_FLINETO(XXOFF+10+XXSTEP*(2*NXDET+4),
     &                XYOFF+XYSTEP*NXCHAR+4,NS)
       CALL F_PEN(1,NS)

       CALL F_FSHOW(NS)


       RETURN
       END

******************************************************************************
*last modification: 07-Jan-1998

       SUBROUTINE COLLEG(E0,EF)

***    COLLEG - DRAWS LEGEND FOR COLORED TRAJECTORY OUTPUT TO APPROPRIATE
*               WINDOWS ON SCREEN
*
**     ARGUMENTS:
*      
**     AUTHOR: CHRISTIAN SCHIEBL
*              CONSULTANT (FORMER CEC-VIENNA)
*              KREMS/HUDSON, JANUARY 1998
*
       INCLUDE 'TYPE.INC'
       INCLUDE 'PARAM.INC'
       INCLUDE 'HIST.INC'
       INCLUDE 'OUTPUT.INC'

*      NUMBER OF DIFFERENT COLORS FOR ELECTRON TRAJECTORIES
       PARAMETER(NCOLTRJ = 10)
       INTEGER ICOLTRJ(NCOLTRJ)
       CHARACTER*11 CCOLEN(NCOLTRJ)
       DATA ICOLTRJ / 1,5,4,8,7,14,21,23,28,31 /


**     START OF EXECUTABLE CODE
*      ************************

       DO 10 I=1,NCOLTRJ
          ENCOL1=EF+(I-1)*(E0-EF)/NCOLTRJ
          ENCOL2=EF+I*(E0-EF)/NCOLTRJ
          CALL CCLEAR(CCOLEN(I))
          WRITE(CCOLEN(I),'(F5.1,A,F5.1)')ENCOL1/1000,'-',ENCOL2/1000
 10    CONTINUE

       IF (NLOCOUT(1) .GT. 0) THEN 
          DO 20 I=ILOCST(1),NLOCOUT(1)
             ILOC = LOCOUT(1,I)
             NWIDTH=SCXSIZ(ILOC)
             NHEIGHT=SCYSIZ(ILOC)
             DHEIGHT=DBLE(NHEIGHT/(NCOLTRJ+2))
             DWIDTH=DBLE(NWIDTH-75)
             CALL F_OUTPUTTO(NXLOC(ILOC),NS)
             CALL F_SETFONTSIZE(12.D0,NS)
             CALL F_PEN(0,NS)
             CALL F_FILLEDRECTANGLE(DWIDTH-1,DHEIGHT-1,
     &                              105.D0,15.D0,NS)
             CALL F_PEN(1,NS)
             CALL F_DRAWSTRING(DWIDTH+25,DHEIGHT+11,'keV')
             DO 15 J=NCOLTRJ,1,-1
                JI=NCOLTRJ-J+2
                CALL F_PEN(0,NS)
                CALL F_FILLEDRECTANGLE(DWIDTH-1,DHEIGHT*JI-1,
     &                                 105.D0,15.D0,NS)
                CALL F_PEN(ICOLTRJ(J),NS)
                CALL F_FILLEDRECTANGLE(DWIDTH,DHEIGHT*JI,20.D0,13.D0,NS)
                CALL F_PEN(1,NS)
                CALL F_DRAWSTRING(DWIDTH+20,DHEIGHT*JI+11,CCOLEN(J))
 15          CONTINUE
 20       CONTINUE
       ENDIF

       RETURN
       END

******************************************************************************
