/*****************************************************************************/
/*     Copyright (c) 2000, Compaq Computer Corporation                       */
/*                                                                           */
/*  See the file "license.terms" for information on usage and redistribution */
/*  of this file, and for a DISCLAIMER OF ALL WARRANTIES.                    */
/*****************************************************************************/
/*
                          promis / imsil / src
                          --------------------
                              imtestquad.h

  Header file for the test routines for the quadtree.

  AUTHORS:   HS  Hannes Stippel, CEC Vienna, Digital Equipment Corporation

  who when        what
  ---------------------------------------------------------------------------
  HS  1994-05-20  new from scratch
  ===========================================================================*/

/* --------------------------------------------------------------------------*/

/* constants 
   ========= */

/* --------------------------------------------------------------------------*/

/* structures and type declarations 
   ================================ */

/* --------------------------------------------------------------------------*/

/* function prototypes 
   =================== */

void testQuadMain (
		   QuadNode *quadTree,
		   long      numFaces,
		   long      faceEndIndex[],
		   long      lineIndex[],
		   int       numLines,
		   LineType  pointIndex[],
		   int       borderLine[],
		   long      numPoints,
		   int       pointEndIndex[],
		   int       pointIsInLine[],
		   double    pcoord[],
		   double    rootSideX,
		   double    rootSideZ,
		   double    quadResolutionX,
		   double    quadResolutionZ,
		   double    epsma,
		   double    minX,
		   double    maxX,
		   double    minZ,
		   double    maxZ,
		   Point     rootCenter,
		   int       numAmbients,
		   int       ambientBorder[],
		   double    overshoot);
