c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
*last modification: CS 01-May-1997

      PROGRAM SESAME

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'DMA.INC'
      INCLUDE 'BREMS.INC'

      LOGICAL LSTWOPEN
      CHARACTER*10 CBL
      CHARACTER*64 CDUMMY
      INTEGER EDLIMT(MAXSHELL,2),ECLIMT(MAXXCHAR,2)
      DOUBLE PRECISION VALION(1)
      POINTER (P2VALION,VALION)
      DOUBLE PRECISION VALBREMS(1)
      POINTER (P2VALBREMS,VALBREMS)
      DOUBLE PRECISION XCABS(1)
      POINTER (P2XCABS,XCABS)
      DOUBLE PRECISION BREMSSPEC(1)
      POINTER (P2BREMSSPEC,BREMSSPEC)
      DOUBLE PRECISION BREMSANGLE(1)
      POINTER (P2BREMSANGLE,BREMSANGLE)

      PARAMETER (MINDIM=1)

c     MAXELE "RANDOM" COLORS
      DATA IONCOL /31,4,22,12,15,19,3,5,29,28,27,
     .             26,7,8,18,17,16,14,13,10/

      DATA E_SHELL / 2,2,2,4,2,2,4,4,6,2,2,4,4,6,6,8 /

      DATA EDLIMT /  1,  8,  5,  5, 17, 17, 17, 21, 21,
     . 		    58, 58, 58, 58, 58, 58, 58,
     .             100,100,100,100,100,100,100,100,100,
     .             100,100,100,100,100,100,100/
      DATA ECLIMT /  3, 5 , 10, 20, 20, 20, 39, 21, 57, 57,
     .              98, 98, 98, 98, 98, 98, 98, 95, 94, 94 /

      DATA VELENER / 1,1.5,2,2.5,3,3.5,4,4.5,5,5.5,6,6.5,7,7.5,8,
     .               8.5,9,9.5,10,11,12,13,14,15,16,17,18,19,20,21,
     .               22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,
     .               37,38,39,40,42,44,46,48,50,52,54,56,58,60,63,
     .               66,69,72,75,78,81,84,87,90,95,
     .               100,105,110,120,130,140,150,160,170,180,
     .               190,200,220,240,260,280,300,320,340,360,
     .               380,400,420,440,460,480,500 /

      DATA VEPHEEL / 0,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,0.95,1 /

*** START OF EXECUTABLE CODE
*****************************

CS    CALL STATISTICS ROUTINE FOR MONITORING
C     CALL SEGF$STATISTICS_START

      IDMAFLAG=0
      CBL='          '
      LSTWOPEN=.FALSE.

*     GET NAME OF INPUT AND OUTPUT FILE
      INFILE ='    '//CBL//CBL//CBL//CBL//CBL//CBL//CBL//CBL//CBL//CBL
      OUTFILE='    '//CBL//CBL//CBL//CBL//CBL//CBL
      NARG = IARGC()
      IF (NARG .LT. 1) THEN
         WRITE(*,'(A)')' ENTER NAME OF INPUT FILE : '
         WRITE(*,'(A)')' DEFAULT EXTENSION IS "INP"'
         READ (*,'(A)') INFILE
      ELSE
         IARG = 1
         CALL GETARG(IARG,INFILE)
      ENDIF
      IF (NARG .LT. 2) THEN
         IE=IEND(INFILE)
         CALL FIND (INFILE,'.',1,IE,IFPOS,IFD)
         CDUMMY='    '//CBL//CBL//CBL//CBL//CBL//CBL
         IF (IFD.EQ.1) THEN
            CDUMMY(1:IFPOS+3)=INFILE(1:IFPOS)//'OUT'
         ELSE
            CDUMMY(1:IE+4)=INFILE(1:IE)//'.OUT'
         ENDIF
         WRITE(*,'(A)')' ENTER NAME OF OUTPUT FILE:'
         WRITE(*,'(2A)')' DEFAULT OUTPUT FILE NAME IS: ',
     &                    CDUMMY(1:IEND(CDUMMY))
         READ (*,'(A)') OUTFILE
         IF (OUTFILE(1:1).EQ.' ')
     &      OUTFILE(1:IEND(CDUMMY))=CDUMMY(1:IEND(CDUMMY))
      ELSE
         IARG = 2
         CALL GETARG(IARG,OUTFILE)
      ENDIF
      I1=1
      I2=64
      IP=0
      CDUMMY='    '//CBL//CBL//CBL//CBL//CBL//CBL
      CDUMMY(1:IEND(INFILE))=INFILE(1:IEND(INFILE))
      CALL FIND (CDUMMY,']',I1,I2,IFPOS,IFD)
      IF (IFD.EQ.1) I1=IFPOS+1
 3    CALL FIND (CDUMMY,'.',I1,I2,IFPOS,IFD)
      IF (IFD.EQ.1) THEN
         IP=IFPOS
         I1=IP+1
         GOTO 3
      ENDIF
      IF (IP.EQ.0) THEN
         INFILE=INFILE(1:IEND(INFILE))//'.INP'
      ELSE
         IF (INFILE(IP+1:IP+1).NE.' ') THEN
            INFILE=INFILE
         ELSE
            INFILE=INFILE(1:IP)//'INP'
         ENDIF
      ENDIF
      I1=1
      I2=64
      IP=0
      CDUMMY='    '//CBL//CBL//CBL//CBL//CBL//CBL
      CDUMMY(1:IEND(OUTFILE))=OUTFILE(1:IEND(OUTFILE))
      CALL FIND (CDUMMY,']',I1,I2,IFPOS,IFD)
      IF (IFD.EQ.1) I1=IFPOS+1
 4    CALL FIND (CDUMMY,'.',I1,I2,IFPOS,IFD)
      IF (IFD.EQ.1) THEN
         IP=IFPOS
         I1=IP+1
         GOTO 4
      ENDIF
      IF (IP.EQ.0) THEN
         OUTFILE=OUTFILE(1:IEND(OUTFILE))//'.OUT'
      ELSE
         IF (OUTFILE(IP+1:IP+1).NE.' ') THEN
            OUTFILE=OUTFILE
         ELSE
            OUTFILE=OUTFILE(1:IP)//'OUT'
         ENDIF
      ENDIF

*     DETERMINE ARRAY SIZES FOR DYNAMIC MEMORY ALLOCATION
      CALL GETSIZ(
     I            INFILE,NHINT,EDLIMT,ECLIMT,
     V            NQUADS,IER)

      IF (IER.NE.0) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' *** FATAL ERROR ***'
         WRITE(6,'(2A)')' FAILED DETERMINING ARRAY SIZES FOR',
     &                  ' DYNAMIC ALLOCATION OF MEMORY !'
         STOP
      ENDIF

****  MEMORY ALLOCATION:
*
 8    CALL SHOMEM()

      IF (NDMAXDET.LT.1) NDMAXDET=1
      IF ((NDMAXGRID.GT.0).AND.(NDMAYGRID.GT.0).AND.
     &   (NDMAZGRID.GT.0)) THEN
         IF (NDMASHELL.GT.0) THEN
            N=NDMASHELL*NDMAXGRID*NDMAYGRID*NDMAZGRID
            P2VALION=MALLOC(SIZEOF(VALION(1))*N)
            IF (P2VALION.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(A)')' Could not allocate memory for VALION !'
               STOP
            ENDIF
            DO 10 I=1,N
               VALION(I)=0.
 10         CONTINUE
         ENDIF
         N=NDMAXGRID*NDMAZGRID*NDMAYGRID
         IF (N.GT.1) THEN
            P2WGTGRD=MALLOC(SIZEOF(WGTGRD(1))*N)
            IF (P2WGTGRD.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(A)')' Could not allocate memory for WGTGRD !'
               STOP
            ENDIF
            DO 11 I=1,N
               WGTGRD(I)=0.
 11         CONTINUE
            IF (NDMAXGRID.GT.0) THEN
               P2XGRIDL=MALLOC(SIZEOF(XGRIDL(1))*NDMAXGRID)
               IF (P2XGRIDL.EQ.0) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' *** ERROR ***'
                  WRITE(6,'(2A)')' Could not allocate memory',
     &                           ' for XGRIDL !'
                  STOP
               ENDIF
               DO 12 I=1,NDMAXGRID
                 XGRIDL(I)=0.
 12            CONTINUE
            ENDIF
            IF (NDMAZGRID.GT.0) THEN
               P2ZGRIDL=MALLOC(SIZEOF(ZGRIDL(1))*NDMAZGRID)
               IF (P2ZGRIDL.EQ.0) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' *** ERROR ***'
                  WRITE(6,'(2A)')' Could not allocate memory',
     &                           ' for ZGRIDL !'
                  STOP
               ENDIF
               DO 13 I=1,NDMAZGRID
                 ZGRIDL(I)=0.
 13            CONTINUE
            ENDIF
            IF (NDMAYGRID.GT.0) THEN
               P2YGRIDL=MALLOC(SIZEOF(YGRIDL(1))*NDMAYGRID)
               IF (P2YGRIDL.EQ.0) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' *** ERROR ***'
                  WRITE(6,'(2A)')' Could not allocate memory',
     &                           ' for YGRIDL !'
                  STOP
               ENDIF
               DO 14 I=1,NDMAYGRID
                 YGRIDL(I)=0.
 14            CONTINUE
            ENDIF
         ENDIF
      ENDIF

      IF (NDMASHELL.GT.0) THEN
         P2ENEROFSHELL=MALLOC(SIZEOF(ENEROFSHELL(1))*NDMASHELL)
         IF (P2ENEROFSHELL.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for ENEROFSHELL !'
            STOP
         ENDIF
         P2IONINTOFSHELL=MALLOC(SIZEOF(IONINTOFSHELL(1))*NDMASHELL)
         IF (P2IONINTOFSHELL.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for IONINTOFSHELL !'
            STOP
         ENDIF
         P2ELEMOFSHELL=MALLOC(SIZEOF(ELEMOFSHELL(1))*NDMASHELL)
         IF (P2ELEMOFSHELL.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for ELEMOFSHELL !'
            STOP
         ENDIF
         P2SHELLOFSHELL=MALLOC(SIZEOF(SHELLOFSHELL(1))*NDMASHELL)
         IF (P2SHELLOFSHELL.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for SHELLOFSHELL !'
            STOP
         ENDIF
         P2HISTOFION=MALLOC(SIZEOF(HISTOFION(1))*NDMASHELL)
         IF (P2HISTOFION.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for HISTOFION !'
            STOP
         ENDIF
         P2NSCROFSHELL=MALLOC(SIZEOF(NSCROFSHELL(1))*NDMASHELL)
         IF (P2NSCROFSHELL.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for NSCROFSHELL !'
            STOP
         ENDIF
         P2NSCROFION=MALLOC(SIZEOF(NSCROFION(1))*NDMASHELL)
         IF (P2NSCROFION.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for NSCROFION !'
            STOP
         ENDIF
         P2NPSMINOFION=MALLOC(SIZEOF(NPSMINOFION(1))*NDMASHELL)
         IF (P2NPSMINOFION.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for NPSMINOFION !'
            STOP
         ENDIF
         P2NIONHIST=MALLOC(SIZEOF(NIONHIST(1))*NDMASHELL)
         IF (P2NIONHIST.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for NIONHIST !'
            STOP
         ENDIF
         P2NXCHAROFSHELL=MALLOC(SIZEOF(NXCHAROFSHELL(1))*NDMASHELL)
         IF (P2NXCHAROFSHELL.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for NXCHAROFSHELL !'
            STOP
         ENDIF
         IF (NDMAREG.GT.0) THEN
            N=NDMAREG*NDMASHELL
            P2SHELLOFREG=MALLOC(SIZEOF(SHELLOFREG(1))*N)
            IF (P2SHELLOFREG.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for SHELLOFREG !'
               STOP
            ENDIF
         ENDIF
         IF ((NDMASCRN+NDMAPS).GT.0) THEN
            N=(NDMASCRN+NDMAPS)*NDMASHELL
            P2SCROFSHELL=MALLOC(SIZEOF(SCROFSHELL(1))*N)
            IF (P2SCROFSHELL.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for SCROFSHELL !'
               STOP
            ENDIF
            P2SCROFION=MALLOC(SIZEOF(SCROFION(1))*N)
            IF (P2SCROFION.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for SCROFION !'
               STOP
            ENDIF
            P2IONTOSCR=MALLOC(SIZEOF(IONTOSCR(1))*N)
            IF (P2IONTOSCR.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for IONTOSCR !'
               STOP
            ENDIF
         ENDIF
         IF (NDMAPM.GT.0) THEN
            N=NDMAPM*NDMASHELL
            P2PSMINOFION=MALLOC(SIZEOF(PSMINOFION(1))*N)
            IF (P2PSMINOFION.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for PSMINOFION !'
               STOP
            ENDIF
            P2IONTOPM=MALLOC(SIZEOF(IONTOPM(1))*N)
            IF (P2IONTOPM.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for IONTOPM !'
               STOP
            ENDIF
         ENDIF
         IF (NDMAHIST.GT.0) THEN
            N=NDMAHIST*NDMASHELL
            P2IONHIST=MALLOC(SIZEOF(IONHIST(1))*N)
            IF (P2IONHIST.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for IONHIST !'
               STOP
            ENDIF
         ENDIF
         IF (NDMAXCHAR.GT.0) THEN
            N=NDMAXCHAR*NDMASHELL
            P2XCHAROFSHELL=MALLOC(SIZEOF(XCHAROFSHELL(1))*N)
            IF (P2XCHAROFSHELL.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XCHAROFSHELL !'
               STOP
            ENDIF
         ENDIF
      ENDIF

      IF (NDMAXCHAR.GT.0) THEN
         P2ENEROFXCHAR=MALLOC(SIZEOF(ENEROFXCHAR(1))*NDMAXCHAR)
         IF (P2ENEROFXCHAR.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for ENEROFXCHAR !'
            STOP
         ENDIF
         P2XGENOFXCHAR=MALLOC(SIZEOF(XGENOFXCHAR(1))*NDMAXCHAR)
         IF (P2XGENOFXCHAR.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for XGENOFXCHAR !'
            STOP
         ENDIF
         P2FYIELDOFXCHAR=MALLOC(SIZEOF(FYIELDOFXCHAR(1))*NDMAXCHAR)
         IF (P2FYIELDOFXCHAR.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for FYIELDOFXCHAR !'
            STOP
         ENDIF
         P2FRELINTOFXCHAR=MALLOC(SIZEOF(FRELINTOFXCHAR(1))*NDMAXCHAR)
         IF (P2FRELINTOFXCHAR.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for FRELINTOFXCHAR !'
            STOP
         ENDIF
         P2FFUDGEOFXCHAR=MALLOC(SIZEOF(FFUDGEOFXCHAR(1))*NDMAXCHAR)
         IF (P2FFUDGEOFXCHAR.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for FFUDGEOFXCHAR !'
            STOP
         ENDIF
         P2NSCROFXCG=MALLOC(SIZEOF(NSCROFXCG(1))*NDMAXCHAR)
         IF (P2NSCROFXCG.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for NSCROFXCG !'
            STOP
         ENDIF
         P2NSCROFXCD=MALLOC(SIZEOF(NSCROFXCD(1))*NDMAXCHAR)
         IF (P2NSCROFXCD.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for NSCROFXCD !'
            STOP
         ENDIF
         P2NPSMINOFXCG=MALLOC(SIZEOF(NPSMINOFXCG(1))*NDMAXCHAR)
         IF (P2NPSMINOFXCG.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for NPSMINOFXCG !'
            STOP
         ENDIF
         P2NPSMINOFXCD=MALLOC(SIZEOF(NPSMINOFXCD(1))*NDMAXCHAR)
         IF (P2NPSMINOFXCD.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for NPSMINOFXCD !'
            STOP
         ENDIF
         P2NXCHIS=MALLOC(SIZEOF(NXCHIS(1))*NDMAXCHAR)
         IF (P2NXCHIS.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for NXCHIS !'
            STOP
         ENDIF
         P2IXCHAROFXCONT=MALLOC(SIZEOF(IXCHAROFXCONT(1))*NDMAXCHAR)
         IF (P2IXCHAROFXCONT.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for IXCHAROFXCONT !'
            STOP
         ENDIF
         P2ELEMOFXCHAR=MALLOC(SIZEOF(ELEMOFXCHAR(1))*NDMAXCHAR)
         IF (P2ELEMOFXCHAR.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for ELEMOFXCHAR !'
            STOP
         ENDIF
         P2XCHAROFXCHAR=MALLOC(SIZEOF(XCHAROFXCHAR(1))*NDMAXCHAR)
         IF (P2XCHAROFXCHAR.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for XCHAROFXCHAR !'
            STOP
         ENDIF
         P2SHELLOFXCHAR=MALLOC(SIZEOF(SHELLOFXCHAR(1))*NDMAXCHAR)
         IF (P2SHELLOFXCHAR.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for SHELLOFXCHAR !'
            STOP
         ENDIF
         IF (NDMAXDET.GT.0) THEN
            N=NDMAXDET*NDMAXCHAR
            P2XDETOFXCHAR=MALLOC(SIZEOF(XDETOFXCHAR(1))*N)
            IF (P2XDETOFXCHAR.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XDETOFXCHAR !'
               STOP
            ENDIF
            P2XPEAKTOBACK=MALLOC(SIZEOF(XPEAKTOBACK(1))*N)
            IF (P2XPEAKTOBACK.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XPEAKTOBACK !'
               STOP
            ENDIF
            P2XFIORIFACT=MALLOC(SIZEOF(XFIORIFACT(1))*N)
            IF (P2XFIORIFACT.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XFIORIFACT !'
               STOP
            ENDIF
         ENDIF
         IF ((NDMASCRN+NDMAPS).GT.0) THEN
            N=(NDMASCRN+NDMAPS)*NDMAXCHAR
            P2SCROFXCG=MALLOC(SIZEOF(SCROFXCG(1))*N)
            IF (P2SCROFXCG.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for SCROFXCG !'
               STOP
            ENDIF
            P2XCGTOSCR=MALLOC(SIZEOF(XCGTOSCR(1))*N)
            IF (P2XCGTOSCR.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XCGTOSCR !'
               STOP
            ENDIF
            P2SCROFXCD=MALLOC(SIZEOF(SCROFXCD(1))*N)
            IF (P2SCROFXCD.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for SCROFXCD !'
               STOP
            ENDIF
            P2XDETSCROFXCD=MALLOC(SIZEOF(XDETSCROFXCD(1))*N)
            IF (P2XDETSCROFXCD.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XDETSCROFXCD !'
               STOP
            ENDIF
            P2XCDTOSCR=MALLOC(SIZEOF(XCDTOSCR(1))*N)
            IF (P2XCDTOSCR.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XCDTOSCR !'
               STOP
            ENDIF
            P2XDETSCR=MALLOC(SIZEOF(XDETSCR(1))*N)
            IF (P2XDETSCR.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XDETSCR !'
               STOP
            ENDIF
         ENDIF
         IF (NDMAPM.GT.0) THEN
            N=NDMAPM*NDMAXCHAR
            P2PSMINOFXCG=MALLOC(SIZEOF(PSMINOFXCG(1))*N)
            IF (P2PSMINOFXCG.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for PSMINOFXCG !'
               STOP
            ENDIF
            P2XCGTOPM=MALLOC(SIZEOF(XCGTOPM(1))*N)
            IF (P2XCGTOPM.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XCGTOPM !'
               STOP
            ENDIF
            P2PSMINOFXCD=MALLOC(SIZEOF(PSMINOFXCD(1))*N)
            IF (P2PSMINOFXCD.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for PSMINOFXCD !'
               STOP
            ENDIF
            P2XDETPSMINOFXCD=MALLOC(SIZEOF(XDETPSMINOFXCD(1))*N)
            IF (P2XDETPSMINOFXCD.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XDETPSMINOFXCD !'
               STOP
            ENDIF
            P2XCDTOPM=MALLOC(SIZEOF(XCDTOPM(1))*N)
            IF (P2XCDTOPM.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XCDTOPM !'
               STOP
            ENDIF
            P2XDETPM=MALLOC(SIZEOF(XDETPM(1))*N)
            IF (P2XDETPM.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XDETPM !'
               STOP
            ENDIF
         ENDIF
         IF (NDMAHIST.GT.0) THEN
            N=NDMAHIST*NDMAXCHAR
            P2XDETXCHIS=MALLOC(SIZEOF(XDETXCHIS(1))*N)
            IF (P2XDETXCHIS.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XDETXCHIS !'
               STOP
            ENDIF
            P2XCHIS=MALLOC(SIZEOF(XCHIS(1))*N)
            IF (P2XCHIS.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XCHIS !'
               STOP
            ENDIF
            P2XCHISWINFRAC=MALLOC(SIZEOF(XCHISWINFRAC(1))*N)
            IF (P2XCHISWINFRAC.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XCHISWINFRAC !'
               STOP
            ENDIF
         ENDIF
         IF (NDMAELEM.GT.0) THEN
            N=NDMAELEM*MAXSHELL*NDMAXCHAR
            P2XCHTABINDX=MALLOC(SIZEOF(XCHTABINDX(1))*N)
            IF (P2XCHTABINDX.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XCHTABINDX !'
               STOP
            ENDIF
         ENDIF
         IF (NDMAREG.GT.0) THEN
            N=NDMAREG*NDMAXCHAR
            P2XCHAROFREG=MALLOC(SIZEOF(XCHAROFREG(1))*N)
            IF (P2XCHAROFREG.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XCHAROFREG !'
               STOP
            ENDIF
         ENDIF
      ENDIF

      IF (NDMAXCONT.GT.0) THEN
         IF ((NDMAXGRID.GT.0).AND.
     &       (NDMAZGRID.GT.0).AND.(NDMAYGRID.GT.0)) THEN
            N=NDMAXCONT*NDMAXGRID*NDMAYGRID*NDMAZGRID*NDMAXDET
            P2VALBREMS=MALLOC(SIZEOF(VALBREMS(1))*N)
            IF (P2VALBREMS.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for VALBREMS !'
               STOP
            ENDIF
         ELSE
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** WARNING ***'
            WRITE(6,'(2A)')' NO GRID SPECIFIED ALTHOUGH BREMS',
     &                     'STRAHLUNG SHOULD BE CALCULATED !'
         ENDIF
         N=NDMAXDET*NDMAXCONT
         P2XDETOFXCONT=MALLOC(SIZEOF(XDETOFXCONT(1))*N)
         IF (P2XDETOFXCONT.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for XDETOFXCONT !'
            STOP
         ENDIF
         P2ENEROFXCONT=MALLOC(SIZEOF(ENEROFXCONT(1))*NDMAXCONT)
         IF (P2ENEROFXCONT.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for ENEROFXCONT !'
            STOP
         ENDIF
         P2IXCONTOFXCHAR=MALLOC(SIZEOF(IXCONTOFXCHAR(1))*NDMAXCONT)
         IF (P2IXCONTOFXCHAR.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for IXCONTOFXCHAR !'
            STOP
         ENDIF
         P2NXKHIS=MALLOC(SIZEOF(NXKHIS(1))*NDMAXCONT)
         IF (P2NXKHIS.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for NXKHIS !'
            STOP
         ENDIF
         IF (NDMAHIST.GT.0) THEN
            N=NDMAHIST*NDMAXCONT
            P2XDETXKHIS=MALLOC(SIZEOF(XDETXKHIS(1))*N)
            IF (P2XDETXKHIS.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XDETXKHIS !'
               STOP
            ENDIF
            P2XKHIS=MALLOC(SIZEOF(XKHIS(1))*N)
            IF (P2XKHIS.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XKHIS !'
               STOP
            ENDIF
         ENDIF
      ENDIF

      IF (MAX(NDMAXCHAR,NDMAXCONT).GT.0) THEN
CS         N=NDMAXDET*MAX(NDMAXCHAR,NDMAXCONT)
         N=NDMAXDET*(NDMAXCONT+NDMAXCHAR-NDMAPTOB)
         P2XDETEFFOFXCHAR=MALLOC(SIZEOF(XDETEFFOFXCHAR(1))*N)
         IF (P2XDETEFFOFXCHAR.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for XDETEFFOFXCHAR !'
            STOP
         ENDIF
         P2FWHMOFXCHAR=MALLOC(SIZEOF(FWHMOFXCHAR(1))*N)
         IF (P2FWHMOFXCHAR.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' Could not allocate memory',
     &                     ' for FWHMOFXCHAR !'
            STOP
         ENDIF
         IF ((NDMAXGRID.GT.0).AND.
     &       (NDMAZGRID.GT.0).AND.(NDMAYGRID.GT.0)) THEN
            N=NDMAXDET*(NDMAXCONT+NDMAXCHAR-NDMAPTOB)*
     &        NDMAXGRID*NDMAYGRID*NDMAZGRID
CS            N=NDMAXDET*MAX(NDMAXCONT,NDMAXCHAR)*
CS     &        NDMAXGRID*NDMAYGRID*NDMAZGRID
            P2XCABS=MALLOC(SIZEOF(XCABS(1))*N)
            IF (P2XCABS.EQ.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')' Could not allocate memory',
     &                        ' for XCABS !'
               STOP
            ENDIF
         ELSE
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** WARNING ***'
            WRITE(6,'(2A)')' NO GRID SPECIFIED ALTHOUGH X-RAYS',
     &                     ' SHOULD BE CALCULATED !'
         ENDIF
      ENDIF

      IF ((NDMAHIST.GT.0).AND.(NDMAVHIS.GT.0)) THEN
         P2VALHIS=MALLOC(SIZEOF(VALHIS(1))*NDMAVHIS)
         IF (P2VALHIS.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(A)')' Could not allocate memory for VALHIS !'
            STOP
         ENDIF
         DO 20 I=1,NDMAVHIS
            VALHIS(I)=0.
 20      CONTINUE  
      ENDIF

      IF (NDMAEENER.GT.0) THEN
         N=NDMAEENER*MAXPHENER*NDMAREG
         P2BREMSSPEC=MALLOC(SIZEOF(BREMSSPEC(1))*N)
         IF (P2BREMSSPEC.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(A)')' Could not allocate memory for BREMSSPEC !'
            STOP
         ENDIF
         DO 21 I=1,N
            BREMSSPEC(I)=0
 21      CONTINUE
         N=NDMAEENER*MAXPHENER*MAXANGLES*NDMAREG
         P2BREMSANGLE=MALLOC(SIZEOF(BREMSANGLE(1))*N)
         IF (P2BREMSANGLE.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(A)')' Could not allocate memory for BREMSANGLE !'
            STOP
         ENDIF
         DO 22 I=1,N
            BREMSANGLE(I)=0
 22      CONTINUE
      ENDIF
*
****  END OF MEMORY ALLOCATION

*     SET ARRAY BOUNDARIES FOR BOUNDARY CHECK
      CALL SETBND ()

      CALL SESAME1(IDMAFLAG,LSTWOPEN,EDLIMT,ECLIMT,
     1             VALION,VALBREMS,XCABS,
     2             BREMSSPEC,BREMSANGLE )

      IF (IDMAFLAG.NE.0) THEN
*        THE ALLOCATED MEMORY WAS NOT LARGE ENOUGH (OR TOO LARGE)
         IDMAFLAG=0
         WRITE(6,'(A)')'      '
         WRITE(6,'(A)')' *** MESSAGE'
         IF (IDMAFLAG.LT.0) THEN
            WRITE(6,'(A)')'     ALLOCATED MEMORY TOO LARGE  !'
            WRITE(6,'(2A)')'     SeSAME WILL REALLOCATE THE',
     &                     ' MEMORY !'
         ELSE
            WRITE(6,'(A)')'     ALLOCATED MEMORY NOT LARGE ENOUGH !'
            WRITE(6,'(2A)')'     DO NOT PANIC - SeSAME WILL',
     &                     ' TRY IT AGAIN !'
         ENDIF
*        FREE ALL ALLOCATED MEMORY
         IF ((NDMAXGRID.GT.0).AND.(NDMAYGRID.GT.0).AND.
     &       (NDMAZGRID.GT.0)) THEN
            IF (NDMASHELL.GT.0) THEN
               CALL FREE(P2VALION)
            ENDIF
            IF (NDMAXCONT.GT.0) THEN
               CALL FREE(P2VALBREMS)
            ENDIF
            N=NDMAXGRID*NDMAYGRID*NDMAZGRID
            IF (N.GT.1) THEN
               CALL FREE(P2WGTGRD)
               IF (NDMAXGRID.GT.1) CALL FREE(P2XGRIDL)
               IF (NDMAZGRID.GT.1) CALL FREE(P2ZGRIDL)
               IF (NDMAYGRID.GT.1) CALL FREE(P2YGRIDL)
            ENDIF
         ENDIF
         IF ((NDMAHIST.GT.0).AND.(NDMAVHIS.GT.0)) THEN
            CALL FREE(P2VALHIS)
         ENDIF
         IF (MAX(NDMAXCHAR,NDMAXCONT).GT.0) THEN
            CALL FREE(P2XDETEFFOFXCHAR)
            CALL FREE(P2FWHMOFXCHAR)
            IF ((NDMAXGRID.GT.0).AND.
     &          (NDMAZGRID.GT.0).AND.(NDMAYGRID.GT.0)) THEN
               CALL FREE(P2XCABS)
            ENDIF
         ENDIF
         IF (NDMAXCONT.GT.0) THEN
            CALL FREE(P2XDETOFXCONT)
            CALL FREE(P2ENEROFXCONT)
            CALL FREE(P2IXCONTOFXCHAR)
         ENDIF
*        SET DMA VARIABLES ACCORDING TO THE CORRESPONDING VARIABLES
         IF (IDMAFLAG.EQ.2) THEN
            NDMAXGRID=NGRIDX
            NDMAYGRID=NGRIDY
            NDMAZGRID=NGRIDZ
         ELSE
            NDMAXGRID=NGRIDX
            NDMAYGRID=NGRIDY
            NDMAZGRID=NGRIDZ
            NDMASHELL=NSHELL
            NDMAXCHAR=NXCHAR
            NDMAXCONT=NXCONT
            NDMAXDET=NXDET
            NDMAEDET=NEDET
            NDMAELEM=NELEM
            NDMAREG=NREG
            NDMAVHIS=NVTOT
            NDMAHIST=NHIST
            NDMASCRN=NSCRN
            NDMAPS=NPS
            NDMAPM=NPM
         ENDIF
*        GO BACK AND ALLOCATE MEMORY AGAIN
         GOTO 8
      ENDIF

CS    CALL STATISTICS ROUTINE FOR MONITORING
C     CALL SEGF$STATISTICS_FINISH('SeSAME','V2.1-1997',
C    1     'devprosim@subpac.enet.dec.com,schiebl@subpac.enet.dec.com',
C    2     ISTATUS)

      END
       
****************************************************************************
*last modification: 07-January-1998

      SUBROUTINE SESAME1(IDMAFLAG,LSTWOPEN,EDLIMT,ECLIMT,
     1                   VALION,VALBREMS,XCABS,
     2                   BREMSSPEC,BREMSANGLE )

***   SESAME1 - PERFORMS MONTE CARLO SIMULATION OF ELECTRON INTERACTIONS
*               IN MATTER
*
**    REMARKS
*
*     1) NO REMARKS PRESENTLY
*
**    AUTHOR:  C.SCHIEBL   JUNE 1994
*              A.PFEIFFER  JUNE 1994
*              H.WAGNER    JUNE 1994
*
      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'DMA.INC'
      INCLUDE 'BREMS.INC'

CS*     ARRAYS FOR A DISTRIBUTION
CS      DIMENSION IW((NXM-1)*(NZM-1)), W(NXM*NZM)

*     HISTOGRAM FOR IONISATIONS
      DOUBLE PRECISION VALION(NDMASHELL,NDMAXGRID,NDMAZGRID,NDMAYGRID)
*     BREMSSTRAHLUNG (CONTINUUM X-RAY) ARRAY
      DOUBLE PRECISION VALBREMS(NDMAXCONT,NDMAXGRID,NDMAZGRID,
     &                          NDMAYGRID,0:NDMAXDET-1)
*     ABSORPTION FACTORS (FOR CHARACTERISTIC AND BACKGROUND RADIATION)
      DOUBLE PRECISION XCABS(0:NDMAXDET-1,NDMAXCONT+NDMAXCHAR-NDMAPTOB,
     &                       NDMAXGRID,NDMAZGRID,NDMAYGRID)
*     BREMSSTRAHLUNG CROSS SECTIONS
      DOUBLE PRECISION BREMSSPEC(NDMAREG,NDMAEENER,MAXPHENER)
      DOUBLE PRECISION BREMSANGLE(NDMAREG,NDMAEENER,MAXPHENER,
     &                            MAXANGLES)

      LOGICAL      LISSUFF,LSTWOPEN
      LOGICAL      ONLYF,ONLYZ,INTEXT,LSCRBK
      CHARACTER*80 BUFFER
      CHARACTER*64 CDUMMY
      CHARACTER*60 CDUMM1
      CHARACTER*70 CD70
      CHARACTER*10 CBL
      CHARACTER*1  CEND
 
      DOUBLE PRECISION RHELP(1)
      POINTER (P2RHELP,RHELP)
      DOUBLE PRECISION D(0:100)     
      DOUBLE PRECISION XPREFC(MAXSCAN),YPREFC(MAXSCAN)
      DOUBLE PRECISION DFRAC(0:MAXEDET)
      DOUBLE PRECISION FDUMMY(2)
      INTEGER*4 IARGC,IARG,NARG
      EXTERNAL IARGC,GETARG
      INTEGER EDLIMT(MAXSHELL,2),ECLIMT(MAXXCHAR,2)
      INTEGER TESTRAN(0:100)
      INTEGER ICUT(20)
      INTEGER AUGERXYZ(3,3)

      DATA AUGERXYZ /1,4,9,3,7,10,4,8,10/

      DATA CTOSCR / 'PET','BET','TET','SET','AET','ION',
     1		    'BEE','TEE','SEE','BEA','TEA','SEA',
     2		    'AEA','BEP','TEP','SEP','AEP','XCS',
     3		    'XKS','XRS','AES','BEY','SEY','TEY',
     4              'AEY','XCY','XKY','XRY','AGD','ADD',
     5              'XGD','XDD','IOD','DEY','AEE','DEE',
     6              'IOV','IOL','TEB','PEB' /

      DATA CTOPST / 'PET','BET','TET','SET','AET','PEB',
     1              'ION','IOD','XGD','XDD','AGD','ADD' /

 
      DATA BUTX1 / 550 /
      DATA BUTX2 / 590 /
      DATA BUTY1 / 250 /
      DATA BUTY2 / 290 /
 

**    START OF EXECUTABLE CODE
*     ************************

      CBL='          '
      LISSUFF=.TRUE.


* INITIALIZATION:
* ===============

*     ---WRITE HEADER OF OUTPUT FILE
      CALL WROUT(
     I           1,IDUMMY)

*     ---READ INPUT AND INITIALIZE COMMON BLOCKS
      WRITE(6,'(A)')'   '
      WRITE(6,'(A)')' READING INPUT FILE'
      CALL INITSE (1)

*     ---READ FROM BACKUP FILE IF SPECIFIED
      IF (LUSEBK) CALL INITSE (2)

*     ---READ ELECTRON DETECTOR TRANSMISSION
      CALL GETEDE

*     ---READ THE GEOMETRY FROM THE SPECIFIED FILE
      REPSMA=EPSMA
      CALL RDGEO (
     I            CGFILE,XSCALE,TILT,ROTAT,REPSMA,
     D            NPTM,NRM,NR,NDMAXGRID,NDMAZGRID,NDMAYGRID,
     O            NPTS,NFCS,NGRIDX,NGRIDZ,NGRIDY,
     O            PCOORD,ILINES,IENDIX,ISGMNT,
     O            NSGMNT,XGRIDL,ZGRIDL,YGRIDL,
     O            XMIN,XMAX,ZMIN,ZMAX,XW1,XW2,ZW,
     O            IER)

      IF (IER.NE.0) THEN
	 WRITE (*,*) ' '
	 WRITE (*,*) ' '
	 WRITE (*,*) '***** ERROR: OCCURED IN RDGEO! *****'
	 WRITE (*,*) ' '
	 WRITE (*,*) ' '
	 STOP
      ENDIF
      
      X_MIN = XMIN
      X_MAX = XMAX
      Z_MIN = ZMIN
      Z_MAX = ZMAX

*     ---CHECK ALL INPUT PARAMETERS FOR CONSISTENCY
      CALL CHKINI (XMIN,XMAX,ZMIN,ZMAX)

*     ---CALCULATE ALL AUGER PEAK ENERGIES
      IF (LEAUG) THEN
         DO 6 I=1,NELEM
            DO 5 J=1,MXAUGP
C              CALCULATE APPROX. AUGER ENERGIES /CHUNG AND JENKINS/
               CALL GETAUG(2,J,ATNUM(I),EAUG,IERROR)
               IF (IERROR.GT.0) THEN
                  AUGPKENER(J,I)=-1
               ELSE
                  AUGPKENER(J,I)=EAUG
               ENDIF
 5          CONTINUE
 6       CONTINUE
      ENDIF

*     ---INITIALIZE ALL OUTPUT PARAMETERS
      WRITE(6,'(A)')'   '
      WRITE(6,'(A)')' INITIALIZING ALL OUTPUT PARAMETERS'
      CALL INIOUT (NELEM,XMIN,XMAX,ZMIN,ZMAX,E0,NHISXCONT)

*     ---MAKE SURE THAT SECONDARIES ARE SIMULATED IF NEEDED
      IF (LESEC.OR.LSE) LSECON=.TRUE.

*     ---INITIALIZE THE GRAPHICS

      IF (LSCRN) THEN

*        INITIALIZE ALL SCREENS 

	 DO 11 I=1,NSCL
*           ADD JOB NAME TO SCREEN TITLE
            ISCTIT=IEND(SCRTITLE(I))
            NJOBN=MIN(20,IEND(JOB))
            SCRTITLE(I)(ISCTIT+1:MIN(60,ISCTIT+23))=' - '//JOB(1:NJOBN)
*	    OPEN LOCATION DEPENDENT SCREENS
	    CALL F_OPENX(SCXSIZ(I),SCYSIZ(I),SCXOFF(I),SCYOFF(I),
     .                   SCRTITLE(I),'LOC',0,NXLOC(I))
            TRNMAT(1,I) = SCXSIZ(I)/(SCMNMX(2,I)-SCMNMX(1,I))
            TRNMAT(2,I) = 0
            TRNMAT(3,I) = 0
            TRNMAT(4,I) = 0
            TRNMAT(5,I) = 0
            TRNMAT(6,I) = SCYSIZ(I)/(SCMNMX(4,I)-SCMNMX(3,I))
            TRNMAT(7,I) = SCMNMX(1,I)
            TRNMAT(8,I) = 0
            TRNMAT(9,I) = SCMNMX(3,I)
            DO 999,K=1,NPALET
               CALL F_INK(65535,65535-1500*(K-1),
     &                    65535-1500*(K-1),NCOLOR(K))
               CALL F_INK(2114*(K-1),2114*(K-1),
     &                    2114*(K-1),NGRAY(K))
 999        CONTINUE

 11	 CONTINUE

	 DO 12 I=1,NSCH
*           ADD JOB NAME TO SCREEN TITLE
            ISCTIT=IEND(CHISTITLE(I))
            NJOBN=MIN(20,IEND(JOB))
            CHISTITLE(I)(ISCTIT+1:MIN(40,ISCTIT+23))=' - '//JOB(1:NJOBN)
*	    OPEN HISTOGRAM SCREENS
	    CALL F_OPENX(SCXSIZ(I+NSCL),SCYSIZ(I+NSCL),SCXOFF(I+NSCL),
     .                SCYOFF(I+NSCL),
     .                CVALUE(I)//CHISTITLE(I),
     .                CVALUE(I),
     .                1,NXHIS(I))

            DO 109,K=1,NPALET
               CALL F_INK(65535,65535-1500*(K-1),
     &                    65535-1500*(K-1),NCOLOR(K))
               CALL F_INK(2114*(K-1),2114*(K-1),
     &                    2114*(K-1),NGRAY(K))
 109        CONTINUE
 12	 CONTINUE

      ENDIF

*     INITIALIZE STATUS SCREEN
      IF (LSTATW) THEN
         IF (.NOT.LSTWOPEN) THEN
  	    CALL F_OPENX(600,350,100,100,
     .           'SeSAME 2.2: Status Window','SeSAME',2,NXSTAT)
            LSTWOPEN=.TRUE.
         ENDIF
         CALL F_OUTPUTTO(NXSTAT,NS)
         CALL DRWSTA(.TRUE.,IETRN1)
         CALL F_PUTBITMAP(40.D0,30.D0,0,0,31)
         CALL F_FSHOW(NS)
         CALL F_PUTBITMAP(30.D0,80.D0,1,1,0)
         CALL F_FSHOW(NS)
         CALL F_PUTBITMAP(250.D0,0.D0,3,1,0)
         CALL F_FSHOW(NS)
         CALL F_SETFONTSIZE(17.D0,NS)
         CALL F_DRAWSTRING(40.D0,260.D0,
     .        '*** SeSAME V2.1 , CEC-Vienna  1997 ***')
      ENDIF

      IF (LPOST) THEN

*        OPEN POSTSCRIPT DEVICES

	 DO 13 I=1,NPS
cs	    CALL F_OPENPS(FILEPS(I),1,NXLOC(I+NSCL))
	    CALL F_OPENBMP(FILEPS(I),PSXSIZ(I),PSYSIZ(I),
     .                     NXLOC(I+NSCL)) 
            TRNMAT(1,I+NSCL) = PSXSIZ(I)/
     .			       (SCMNMX(2,I+NSCL)-SCMNMX(1,I+NSCL))
            TRNMAT(2,I+NSCL) = 0
            TRNMAT(3,I+NSCL) = 0
            TRNMAT(4,I+NSCL) = 0
            TRNMAT(5,I+NSCL) = 0
            TRNMAT(6,I+NSCL) = PSYSIZ(I)/
     . 			       (SCMNMX(4,I+NSCL)-SCMNMX(3,I+NSCL))
            TRNMAT(7,I+NSCL) = SCMNMX(1,I+NSCL)
            TRNMAT(8,I+NSCL) = 0
            TRNMAT(9,I+NSCL) = SCMNMX(3,I+NSCL)
            DO 7,K=1,NPALET
               CALL F_INK(65535,65535-1500*(K-1),
     &                    65535-1500*(K-1),NCOLOR(K))
               CALL F_INK(2114*(K-1),2114*(K-1),
     &                    2114*(K-1),NGRAY(K))
7	    CONTINUE 
13       CONTINUE
      ENDIF

*     ---INITIALIZE LOCATION DEPENDENT TRANSFORMATION MATRX
      WRITE(6,'(A)')'   '
      WRITE(6,'(A)')' INITIALIZING TRANSFORMATION MATRIX'
      CALL TRNINI(TRNMAT)

*     ---INITIALIZE BREMSSTRAHLUNG CROSS SECTION TABLES IF RQUIRED
      IF (LBREMS) THEN
         IF (LKQP) THEN
            WRITE(6,'(A)')'   '
            WRITE(6,'(2A)')' INITIALIZING BREMSSTRAHLUNG CROSS',
     &                     ' SECTION TABLE'
            CALL STATXT
     &      (' INITIALIZING BREMSSTRAHLUNG CROSS SECTION TABLE')
*           INITIALIZE FROM TABLES OF KISSEL, QUARLES AND PRATT
            IERR=0
            DO 112 IR=1,NREG
               IZ=INT(ZQUER(IR)+0.5)
               CALL BSFINIT(IR,IZ,BREMSSPEC,BREMSANGLE,IERR)
               IF (IERR.NE.0) THEN
                  WRITE(6,'(A)')'         '
                  WRITE(6,'(A)')' *** WARNING:'
                  WRITE(6,'(3A)')' ERROR OCCURED DURING INITIALIZ',
     &                           'ATION OF BREMSSTRAHLUNG CROSS',
     &                           ' SECTION TABLES'
                  WRITE(6,'(2A)')' ANALYTICAL FORMULA FROM WIEDMA',
     &                           'NN & KIRKPATRICK WILL BE TAKEN!'
                  LWIEDKIRK=.TRUE.
                  LKQP=.FALSE.
                  GOTO 113
               ENDIF
 112        CONTINUE
 113     ENDIF
      ENDIF

*     ---WRITE CONTENTS OF THE COMMON BLOCKS TO THE OUTPUT FILE
      CALL WROUT(
     I           2,IDUMMY)

*     ---WRITE THE GEOMETRY TO THE OUTPUT FILE
      CALL WRGEOM(
     D            NR, NPTS,
     I            PCOORD, ILINES, IENDIX, XSCALE)

*     ---GENERATE THE QUADTREE
      WRITE(6,'(A)')'   '
      CALL STATXT(' GENERATING THE QUADTREE')
      CALL IMQUAD (
     D             NR,
     I             IENDIX, ILINES,
     D             NPTS,
     I             PCOORD, EPSMA, XSCALE,
     O             IER)
      IF (IER.NE.0) THEN
	 WRITE (*,*) ' '
	 WRITE (*,*) ' '
	 WRITE (*,*) '***** ERROR OCCURED WHILE GENERATING ',
     ,               'THE QUADTREE *****'
	 WRITE (*,*) ' '
	 WRITE (*,*) ' '
	 STOP
      ENDIF

*     ---GET COORDONATES OF SURFACE POLYLINE
      CALL IMSURFGETCOORD(SCORDX,SCORDZ,NSCORD)

*     ---GENERATE GRID FOR X-RAY CALCULATIONS      
      IF (LBREMS) LGRD=.TRUE.
      IF (LGRD.AND.(.NOT.LUSEBK)) THEN
         WRITE(6,'(A)')'   '
         WRITE(6,'(A)')' GENERATING GRID FOR X-RAYS'
         CALL RDGRID(
     I               NPTS,NFCS,
     O               XGRMIN,XGRMAX,ZGR,IER)
         IF (IER.NE.0) THEN
            WRITE (*,*) ' '
   	    WRITE (*,*) ' '
	    WRITE (*,*)
     &	   	    '***** ERROR: OCCURED DURING INIT OF GRID! *****'
	    WRITE (*,*) ' '
	    WRITE (*,*) ' '
	    STOP
         ENDIF
      ELSE IF (.NOT.LGRD) THEN
         NGRIDX=0
         NGRIDZ=0
         NGRIDY=0
      ELSE IF (LUSEBK) THEN
*        GET GRID FROM BACKUP FILE
         NGRIDX=NDMAXGRID
         NGRIDZ=NDMAZGRID
         NGRIDY=NDMAYGRID
      ENDIF
      IF ((NGRIDX.NE.NDMAXGRID).OR.(NGRIDZ.NE.NDMAZGRID).OR.
     &    (NGRIDY.NE.NDMAYGRID)) THEN
         N=NGRIDX*NGRIDZ*NGRIDY
         IF (LGRD.AND.(.NOT.LUSEBK).AND.(N.LT.1)) THEN
*           SOMETHING FUNDAMENTALLY WRONG !
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' THERE ARE NO GRID LINES SPECIFIED',
     &                     ' ALTHOUGH A GRID IS NEEDED !'
            WRITE(6,'(2A)')' USE A USER-DEFINED GRID (GRID-FILE) OR',
     &                  ' CONTACT ONE OF THE SeSAME REPS'
            STOP
         ELSE IF (LGRD) THEN
*           GO BACK AND ALLOCATE MEMORY AGAIN USING THE NEW NUMBERS FOR
*           THE GRID LINES
            IF ((NGRIDX.GT.NDMAXGRID).OR.(NGRIDZ.GT.NDMAZGRID).OR.
     &          (NGRIDY.GT.NDMAYGRID)) THEN
               IDMAFLAG=2
            ELSE
               IDMAFLAG=-2
            ENDIF
            LISSUF=.FALSE.
            GOTO 127
         ENDIF
      ENDIF

      IF (LSCRN.AND.LLOC) THEN
*     ---DRAW THE GEOMETRY
         DO 14 ILOC = 1,NSCL
            CALL F_OUTPUTTO(NXLOC(ILOC),NS)
            IF (LGRID.AND.LGRD) CALL DRWGRD (ILOC,NS)
            CALL DRWGEO (
     I                   ILOC, NR, IENDIX, ILINES, PCOORD, IQUAD)
            CALL DRWAXS(ILOC)
 14      CONTINUE
*        DRAW THE COLOR LEGEND TO THE APPROPRIATE WINDOWS ON SCREEN
         IF (LCOLTRJ) THEN
            CALL COLLEG(E0,EF)
         ENDIF
      ENDIF

*     ---INITIALIZE STATISTICS
      CALL STATCS(
     I            10,DUMMY1,DUMMY2,DUMMY3,DUMMY4,DUMMY5,DUMMY6,
     I            DUMMY7,DUMMY8,DUMMY9,DUMMY10,DUMMY11,DUMMY12,
     I            DUMMY,DUMMY,IDUM1,IDUM2)

*     ---INITIALIZE THE HISTOGRAM FOR THE CHAR. X-RAYS
      IF (LGRD.AND.(.NOT.LUSEBK)) THEN
         CALL IONVAL
     I               ( .TRUE.,1,
     D	   	      NDMASHELL,NDMAXGRID,NDMAZGRID,NDMAYGRID,
     D		      XGRIDL,ZGRIDL,YGRIDL,X_MIN,X_MAX,Z_MIN,Z_MAX,
     I                XDUMMY,ZDUMMY,IDUMMY,VDUMMY,
     O                VALION,NOUTGR,NOUTAR,IXGR,IZGR,
     O                IER)
         IF (IER.NE.0) THEN
	    WRITE (*,'(A)')' '
            WRITE (*,'(A)')' '
	    WRITE (*,'(2A)')
     &	 	  '***** ERROR: OCCURED DURING INIT OF IONVAL', 
     &            ' (CHAR. X-RAYS)! *****'
	    WRITE (*,'(A)')' '
	    WRITE (*,'(A)')' '
	    STOP
         ENDIF
         IF (LBREMS) THEN
            DO 123 IXD=0,NDMAXDET-1
               CALL BRMVAL
     I                    (.TRUE.,1,NDMAXCONT,
     D	   		   NDMAXGRID,NDMAZGRID,NDMAYGRID,
     D			   XGRIDL,ZGRIDL,YGRIDL,
     D                     X_MIN,X_MAX,Z_MIN,Z_MAX,
     I                     XDUMMY,ZDUMMY,IDUMMY,VDUMMY,
     O                     VALBREMS(1,1,1,1,IXD),
     O                     NBREMSOUTGR,NBREMSOUTAR,
     O                     IXGR,IZGR,
     O                     IER)
               IF (IER.NE.0) THEN
	          WRITE (*,'(A)')' '
                  WRITE (*,'(A)')' '
	          WRITE (*,'(2A)')
     &	 	     '***** ERROR: OCCURED DURING INIT OF BRMVAL', 
     &               ' (BREMSSTRAHLUNG)! *****'
	          WRITE (*,'(A)')' '
	          WRITE (*,'(A)')' '
	          STOP
               ENDIF
 123        CONTINUE
         ENDIF
      ENDIF

*     ---INITIALIZE PHYSICAL (FUNDAMENTAL) PARAMETERS
      WRITE(6,'(A)')'   '
      WRITE(6,'(A)')' INITIALIZING PHYSICAL (FUNDAMENTAL) PARAMETERS'
      CALL INITPH (NPTS,NFCS,XCABS)

*     ***IMPORTANT***IMPORTANT***IMPORTANT***IMPORTANT***IMPORTANT***
*     UP TO THIS POINT ONLY THE "DMA-VALUES" SHOULD BE USED SINCE
*     FOR ALLOCATING MEMORY ALSO THE "DMA-VALUES" HAVE BEEN USED

*     CHECK WHETHER DYNAMICALLY ALLOCATED MEMORY IS SUFFICIENT OR NOT
      CALL CHKMEM(LISSUFF)
 127  IF (.NOT.LISSUFF) THEN
         IF (LSCRN.OR.LSTATW) THEN
            IF (LSCRN) THEN
               DO 128 IHIS = 1,NSCH
                  CALL F_CLOSEDEVICE(NXHIS(IHIS),NS)
 128           CONTINUE
               DO 129 ISCL = 1,NSCL
                  CALL F_CLOSEDEVICE(NXLOC(ISCL),NS)
 129           CONTINUE        
            ENDIF
            IF (LSTWOPEN) THEN
               CALL F_OUTPUTTO(NXSTAT,NS)
               CALL F_SETFONTSIZE(28.D0,NS)
               CALL F_CLEAR(NS)
               CALL F_PUTBITMAP(40.D0,30.D0,0,0,31)
               CALL F_FSHOW(NS)
               CALL F_PUTBITMAP(30.D0,80.D0,1,1,0)
               CALL F_FSHOW(NS)
               CALL F_PEN(5,NS)
               CALL F_FILLEDRECTANGLE(250.D0,30.D0,340.D0,200.D0,NS)
               CALL F_PEN(18,NS)
               CALL F_DRAWSTRING(310.D0,80.D0,
     .              '*** MESSAGE ***')
               CALL F_SETFONTSIZE(18.D0,NS)
               IF (IDMAFLAG.LT.0) THEN
                  CALL F_DRAWSTRING(265.D0,120.D0,
     .                 '     allocated memory is too large !')
               ELSE
                  CALL F_DRAWSTRING(265.D0,120.D0,
     .                 '     allocated memory not large enough !')
               ENDIF
               CALL F_DRAWSTRING(255.D0,150.D0,
     .              '     do not panic - SeSAME will try again !')
               CALL F_PEN(30,NS)
               CALL F_SETFONTSIZE(23.D0,NS)
               CALL F_DRAWSTRING(280.D0,200.D0,
     .              ' klick into blue field to continue !')
               CALL F_PEN(1,NS)
               CALL F_SETFONTSIZE(17.D0,NS)
               CALL F_DRAWSTRING(40.D0,260.D0,
     .              '*** SeSAME V2.1 , CEC-Vienna  1997 ***')
               CALL ZZZSEC(T1)
 130           CALL F_GETMOUSEPRESSEVENT(IX,IY,ISTAT,NS)
               IF (NS.EQ.1) THEN
                  IF ((IX.GT.250).AND.(IY.LT.590)) THEN
                     IF ((IY.GT.30).AND.(IY.LT.230)) THEN
*                       CONTINUE SIMULATION
                        GOTO 131
                     ENDIF
                  ENDIF
               ENDIF
               CALL ZZZSEC(T2)
               IF ((T2-T1).LT.15) GOTO 130
 131           CONTINUE
               IF (LTEST) THEN
                  WRITE(6,*)'     '
                  WRITE(6,'(A,F13.3)')' MESSAGE TIME: ',T2-T1
               ENDIF
            ENDIF
CS            IF (LSTATW) THEN
CS               CALL F_CLOSEDEVICE(NXSTAT,NS)
CS            ENDIF
         ENDIF
         IF (LPOST) THEN
            DO 132 IPS=1,NPS
               CALL F_CLOSEDEVICE(NXLOC(IPS+NSCL),NS)
 132        CONTINUE
         ENDIF
         IF (IDMAFLAG.EQ.0) IDMAFLAG=1
         RETURN
      ENDIF

*     ---DETERMINE FUDGE FACTORS FOR CHAR. AND CONT. X-RAYS
      CALL GETFUDGE()

*     ---READ (OR CALCULATE) X-RAY DETECTOR EFFICIENCIES
      CALL GETXDE()

*     ---CHECK ALL HISTOGRAMS FOR 'XCY', 'XKY', AND 'XRY' AND ESTABLISH 
*        CONNECTIONS TO XCONT TABLES
      IF (LBREMS) CALL CHKHIS()

CHW      CALL TESTPLASMON()

*     ---INITIALIZE THE SEED OF THE RANDOM NUMBER GENERATOR
      IF (MRAND.NE.0) CALL RANSET(
     I                            MRAND,IARAND,IBRAND,IRAND)

*     ---CREATE AUGER LIST
      IF (LAUGFILE) THEN
	 OPEN(17,FILE=AUGERFILE,CARRIAGECONTROL='LIST',STATUS='NEW')
      ENDIF

*     ---OPEN ELECTRON SOURCE FILE IF SPECIFIED

      IF (NELESOURCE .EQ. 3) THEN 
	 OPEN(18,FILE=FETAB,CARRIAGECONTROL='LIST',STATUS='OLD')
      ENDIF

C     READ THE BACKUP FILE IF DESIRED

      IETRN1=0
      IF (LUSEBK) CALL LOADBK(IETRN1,VALION,VALBREMS,XCABS)
      IETRN1=IETRN1+1
      IF (NETRN.LE.IETRN1) THEN
         WRITE(6,'(A)')'       '
         WRITE(6,'(A)')' %%% WARNING %%% '
         WRITE(6,'(2A)')' The total number of electrons specified ',
     &                  'in the input deck is smaller then'
         WRITE(6,'(2A)')' the total number of electrons stored ',
     &                  'in the backup file !'
         WRITE(6,'(2A,I9)')' total number of electrons from input ',
     &                  'deck:  ',NETRN
         WRITE(6,'(2A,I9)')' total number of electrons from backup',
     &                  ' file: ',IETRN1-1
         WRITE(6,'(2A,I9)')' total number of electrons will be set',
     &                  ' to:   ',IETRN1+NETRN-1
         WRITE(6,'(A)')' Protests are useless - ;-) SeSAME'
         NETRN=IETRN1+NETRN-1
      ENDIF

C PREPARE FOR ELECTRON BEAM
C==========================

*     DETERMINE GENERAL DIRECTION (WITHOUT DIVERGENCE)
      DXGEN=COS(EBROTR)*SIN(EBTLTR)
      DYGEN=SIN(EBROTR)*SIN(EBTLTR)
      DZGEN=COS(EBTLTR)

*     CALCULATE MAX AND MIN Z COORDINATE OF SURFACE POLYGON
      ZSMIN=SCORDZ(1)
      ZSMAX=SCORDZ(1)
      DO 15 I=2,NSCORD
         IF (SCORDZ(I).GT.ZSMAX) ZSMAX=SCORDZ(I)
         IF (SCORDZ(I).LT.ZSMIN) ZSMIN=SCORDZ(I)
 15   CONTINUE

      IF (ZFOCUS.NE.-9999999) ZFOCUS=ZFOCUS*DUNITS
      IF (SCAN) THEN
*        CALCULATE PLAN OF FOCUS (AT POSITION XESPOT)
         IF (ZFOCUS.EQ.-9999999) ZFOCUS=(ZSMAX+ZSMIN)/2
         NELEFF=NETRN-IETRN1+1
         IEPLOC=INT(DBLE(NELEFF)/DBLE(NLSCP)+0.9)
         NETRN=IEPLOC*NLSCP+IETRN1-1
         DO 16 IPOS=1,NLSCP
            XPREFC(IPOS)=XEFRST+(IPOS-1)*XLSCP
            YPREFC(IPOS)=DTAN(SCANANG)*(XPREFC(IPOS)-XESPOT)
 16      CONTINUE
CS         ZPREF=(XESPOT*DXGEN+ZFOCUS*DZGEN-(XESPOT-XPREF)*
CS     &         (DXGEN+DTAN(SCANANG)))/DZGEN
         ZPREF=ZFOCUS
      ELSE
*        CALCULATE CROSSING POINT OF BEAM DIRECTION AND SURFACE
*        THIS POINT IS THE REFERENCE POINT FOR SCAN=F
         NCUT=0
         DO 17 I=2,NSCORD
            IF ((XESPOT.GT.SCORDX(I-1)).AND.
     &         (XESPOT.LE.SCORDX(I))) THEN
               NCUT=NCUT+1
               ICUT(NCUT)=I-1
            ENDIF
 17      CONTINUE
         IF (NCUT.LT.1) THEN
*           IS IMPOSSIBLE!

         ELSE IF (NCUT.GE.1) THEN
            XPREF=XESPOT
            YPREF=0
            ZN=SCORDX(ICUT(1)+1)-SCORDX(ICUT(1))
            XN=SCORDZ(ICUT(1))-SCORDZ(ICUT(1)+1)
            IF (ZFOCUS.EQ.-9999999) THEN
               ZPREF=(XN*(SCORDX(ICUT(1))-XPREF)+ZN*SCORDZ(ICUT(1)))/ZN
            ELSE
               ZPREF=ZFOCUS
            ENDIF
            DO 18 I=2,NCUT
               ZN=SCORDX(ICUT(I)+1)-SCORDX(ICUT(I))
               XN=SCORDZ(ICUT(I))-SCORDZ(ICUT(I)+1)
               ZPREF1=(XN*(SCORDX(ICUT(I))-XPREF)+
     &                 ZN*SCORDZ(ICUT(I)))/ZN
               IF (ZPREF1.LT.ZPREF) ZPREF=ZPREF1
 18         CONTINUE
         ENDIF
      ENDIF

C WRITE INFORMATION TO SCREEN
* ===========================

      IF (LTEST) THEN
*        WRITE SHELL TABLES TO SCREEN
         IF (NSHELL.GT.0) THEN
           WRITE(6,'(A)')'    '
           WRITE(6,'(A)')' Shell Tables: '
           WRITE(6,'(2A)')' ELEM   SHELL  ENER   SCR    HIST  SCR',
     &                    ' PSMIN XCHAR ION'
           WRITE(6,'(2A)')'  OF     OF     OF     OF     OF    OF',
     &                    '   OF    OF  HIST'
           WRITE(6,'(2A)')' SHELL  SHELL  SHELL  SHELL  ION   ION',
     &                    '  ION  SHELL'
           WRITE(6,'(2A)')'--------------------------------------',
     &                    '------------------'
         ENDIF
         DO 20 K=1,NSHELL
            IS1INDX=(K-1)*(NDMASCRN+NDMAPS)+1
            IS2INDX=(K-1)*NDMAPM+1
            IS3INDX=(K-1)*NDMAXCHAR+1
            IS4INDX=(K-1)*NDMAHIST+1
            WRITE(BUFFER(1:20),'(A)')'                    '
            WRITE(BUFFER(21:40),'(A)')'                    '
            WRITE(BUFFER(41:60),'(A)')'                    '
            WRITE(BUFFER(61:80),'(A)')'                    '
            WRITE(BUFFER(1:21),'(2I5,F11.2)')ELEMOFSHELL(K),
     &                                       SHELLOFSHELL(K),
     &                                       ENEROFSHELL(K)
            IF ((NDMASCRN+NDMAPS).GT.0) THEN
              WRITE(BUFFER(22:24),'(I3)')    SCROFSHELL(IS1INDX)
              WRITE(BUFFER(25:30),'(I6)')    HISTOFION(K)
              WRITE(BUFFER(31:36),'(I6)')    SCROFION(IS1INDX)
            ELSE
              WRITE(BUFFER(25:30),'(I6)')    HISTOFION(K)
            ENDIF
            IF (NDMAPM.GT.0)
     &        WRITE(BUFFER(37:42),'(I6)')    PSMINOFION(IS2INDX)
            IF (NDMAXCHAR.GT.0)
     &        WRITE(BUFFER(43:48),'(I6)')    XCHAROFSHELL(IS3INDX)
            IF (NDMAHIST.GT.0)
     &        WRITE(BUFFER(49:54),'(I6)')    IONHIST(IS4INDX)
            WRITE(6,'(A)')BUFFER
CS            WRITE(6,'(2I5,F11.2,I3,9I6)')ELEMOFSHELL(K),
CS     &                                   SHELLOFSHELL(K),
CS     &                                   ENEROFSHELL(K),
CSCS     &                                   SCROFSHELL(K,1),
CS     &                                   SCROFSHELL(IS1INDX),
CS     &                                   HISTOFION(K),
CSCS     &                                   SCROFION(K,1),
CS     &                                   SCROFION(IS1INDX),
CSCS     &                                   PSMINOFION(K,1),
CS     &                                   PSMINOFION(IS2INDX),
CSCS     &                                   XCHAROFSHELL(K,1),
CS     &                                   XCHAROFSHELL(IS3INDX),
CSCS     &                                   IONHIST(K,1)
CS     &                                   IONHIST(IS4INDX)
            MXINDX=MAX(NSCROFSHELL(K),NSCROFION(K))
            MXINDX=MAX(MXINDX,NPSMINOFION(K))
            MXINDX=MAX(MXINDX,NXCHAROFSHELL(K))
            MXINDX=MAX(MXINDX,NIONHIST(K))
            DO 19 KK=2,MXINDX
               IS1INDX=(K-1)*(NDMASCRN+NDMAPS)+KK
               IS2INDX=(K-1)*NDMAPM+KK
               IS3INDX=(K-1)*NDMAXCHAR+KK
               IS4INDX=(K-1)*NDMAHIST+KK
               WRITE(BUFFER(1:20),'(A)')'                    '
               WRITE(BUFFER(21:40),'(A)')'                    '
               WRITE(BUFFER(41:60),'(A)')'                    '
               WRITE(BUFFER(61:80),'(A)')'                    '
               IF (((NDMASCRN+NDMAPS).GT.0).AND.
     &             (KK.LE.NSCROFSHELL(K)))
     &            WRITE(BUFFER(22:24),'(I3)')SCROFSHELL(IS1INDX)
               IF (((NDMASCRN+NDMAPS).GT.0).AND.
     &             (KK.LE.NSCROFION(K)))
     &            WRITE(BUFFER(31:36),'(I6)')SCROFION(IS1INDX)
               IF ((NDMAPM.GT.0).AND.(KK.LE.NPSMINOFION(K)))
     &            WRITE(BUFFER(37:42),'(I6)')PSMINOFION(IS2INDX)
               IF ((NDMAXCHAR.GT.0).AND.(KK.LE.NXCHAROFSHELL(K)))
     &            WRITE(BUFFER(43:48),'(I6)')XCHAROFSHELL(IS3INDX)
               IF ((NDMAHIST.GT.0).AND.(KK.LE.NIONHIST(K)))
     &            WRITE(BUFFER(49:54),'(I6)')IONHIST(IS4INDX)
               WRITE(6,'(A)')BUFFER
CS               WRITE(6,'(A,I3,A,4I6)')'                     ',
CS     &               SCROFSHELL(K,KK),'      ',SCROFION(K,KK),
CS     &               PSMINOFION(K,KK),
CS     &               XCHAROFSHELL(K,KK),IONHIST(K,KK)
CS               WRITE(6,'(A,I3,A,4I6)')'                     ',
CS     &               SCROFSHELL(IS1INDX),'      ',SCROFION(IS1INDX),
CS     &               PSMINOFION(IS2INDX),
CS     &               XCHAROFSHELL(IS3INDX),IONHIST(IS4INDX)
 19         CONTINUE
 20      CONTINUE

*        WRITE AUGER TABLES TO SCREEN
         IF (NAUGER.GT.0) THEN
           WRITE(6,'(A)')'    '
           WRITE(6,'(A)')' Auger Tables: '
           WRITE(6,'(2A)')' ELEM   LINE   ENER   ADD    AGD   AGD',
     &                    '  ADD  NAE_  AE_'
           WRITE(6,'(2A)')'  OF     OF     OF    HIS    HIS   LOC',
     &                    '  LOC  HIS   HIS'
           WRITE(6,'(2A)')' AUGER  AUGER  AUGER                  ',
     &                    '                            '
           WRITE(6,'(2A)')'--------------------------------------',
     &                    '------------------'
         ENDIF
         DO 22 K=1,NAUGER
            WRITE(6,'(2I5,F11.2,I3,5I6)')ELEMOFAUGER(K),
     &                                   LINEOFAUGER(K),
     &                                   ENEROFAUGER(K),
     &                                   ADDHIS(K),
     &                                   AGDHIS(K),
     &                                   AGDLOC(K,1),
     &                                   ADDLOC(K,1),
     &                                   NAE_HIS(K),
     &                                   AE_HIS(K,1)
            MXINDX=MAX(NAGDLOC(K),NADDLOC(K))
            MXINDX=MAX(MXINDX,NAE_HIS(K))
            DO 21 IAE=2,MXINDX
               WRITE(6,'(A,2I6,A,I6)')
     &          '                              ',AGDLOC(K,IAE),
     &          ADDLOC(K,IAE),'      ',AE_HIS(K,IAE)
 21         CONTINUE
 22      CONTINUE
         
*        WRITE XCHAR TABLES TO SCREEN
         IF (NXCHAR.GT.0) THEN
           WRITE(6,'(A)')'    '
           WRITE(6,'(A)')' XCHAR Tables: '
           WRITE(6,'(3A)')' ELEM  XCHAR ENER  SHELL FYIELD',
     &                    ' FRELINT XDETEFF NXCHIS XCHIS',
     &                    ' SCR  SCR PSMIN PSMIN'
           WRITE(6,'(3A)')'  OF    OF    OF    OF     OF  ',
     &                    '  OF     OF                  ',
     &                    ' OF   OF   OF    OF'
           WRITE(6,'(3A)')' XCHAR XCHAR XCHAR XCHAR XCHAR ',
     &                    ' XCHAR   XCHAR               ',
     &                    ' XCG  XCD  XCG   XCD'
           WRITE(6,'(3A)')'-------------------------------',
     &                    '-----------------------------',
     &                    '---------------------'
         ENDIF
         DO 24 K=1,NXCHAR
            IK=(NXDET+1)*(K-1)+2
            IXINDX1=(K-1)*NDMAHIST+1
            IXINDX2=(K-1)*(NDMASCRN+NDMAPS)+1
            IXINDX3=(K-1)*NDMAPS+1
            WRITE(BUFFER(1:20),'(A)')'                    '
            WRITE(BUFFER(21:40),'(A)')'                    '
            WRITE(BUFFER(41:60),'(A)')'                    '
            WRITE(BUFFER(61:80),'(A)')'                    '
            WRITE(BUFFER(1:38),'(2I4,F11.2,I3,2F8.3)')
     &                                       ELEMOFXCHAR(K),
     &                                       XCHAROFXCHAR(K),
     &                                       ENEROFXCHAR(K),
     &                                       SHELLOFXCHAR(K),
     &                                       FYIELDOFXCHAR(K),
     &                                       FRELINTOFXCHAR(K)
            IF (NXDET.GT.0)
     &         WRITE(BUFFER(39:46),'(F8.3)') XDETEFFOFXCHAR(IK)
            WRITE(BUFFER(47:52),'(I6)')      NXCHIS(K)
            IF (NDMAHIST.GT.0)
     &         WRITE(BUFFER(53:58),'(I6)')   XCHIS(IXINDX1)
            IF ((NDMASCRN+NDMAPS).GT.0)
     &         WRITE(BUFFER(59:68),'(2I5)')  SCROFXCG(IXINDX2),
     &                                       SCROFXCD(IXINDX2)
            IF (NDMAPM.GT.0)
     &         WRITE(BUFFER(69:79),'(I5,I6)')PSMINOFXCG(IXINDX3),
     &                                       PSMINOFXCD(IXINDX3)
            WRITE(6,'(A)')BUFFER
CS            WRITE(6,'(2I4,F11.2,I3,3F8.3,2I6,3I5,I6)')
CS     &                                         ELEMOFXCHAR(K),
CS     &                                         XCHAROFXCHAR(K),
CS     &                                         ENEROFXCHAR(K),
CS     &                                         SHELLOFXCHAR(K),
CS     &                                         FYIELDOFXCHAR(K),
CS     &                                         FRELINTOFXCHAR(K),
CS     &                                         XDETEFFOFXCHAR(IK),
CS     &                                         NXCHIS(K),
CSCS     &                                         XCHIS(K,1),
CS     &                                         XCHIS(IXINDX1),
CSCS     &                                         SCROFXCG(K,1),
CS     &                                         SCROFXCG(IXINDX2),
CSCS     &                                         SCROFXCD(K,1),
CS     &                                         SCROFXCD(IXINDX2),
CSCS     &                                         PSMINOFXCG(K,1),
CS     &                                         PSMINOFXCG(IXINDX3),
CSCS     &                                         PSMINOFXCD(K,1)
CS     &                                         PSMINOFXCD(IXINDX3)
            MXINDX=MAX(NXCHIS(K),NSCROFXCG(K))
            MXINDX=MAX(MXINDX,NSCROFXCD(K))
            MXINDX=MAX(MXINDX,NPSMINOFXCG(K))
            MXINDX=MAX(MXINDX,NPSMINOFXCD(K))
            MXINDX=MAX(MXINDX,(NXDET+1))
            IF (MXINDX.GT.(NXDET+1)) MXINDX=NXDET+1
            MAXINDX=(NXDET+1)*(NXCHAR-1)+MXINDX
            CALL CHKBND (13,MAXINDX,'SESAME1','XDETEFFOFXCHAR')
            DO 23 KK=2,MXINDX
               IK=(NXDET+1)*(K-1)+(KK+1)
               IXINDX1=(K-1)*NDMAHIST+KK
               IXINDX2=(K-1)*(NDMASCRN+NDMAPS)+KK
               IXINDX3=(K-1)*NDMAPS+KK
               WRITE(BUFFER(1:20),'(A)')'                    '
               WRITE(BUFFER(21:40),'(A)')'                    '
               WRITE(BUFFER(41:60),'(A)')'                    '
               WRITE(BUFFER(61:80),'(A)')'                    '
               IF ((NDMAXDET.GT.0).AND.(KK.LE.NXDET))
     &            WRITE(BUFFER(38:45),'(F8.3)')XDETEFFOFXCHAR(IK)
               IF ((NDMAHIST.GT.0).AND.(KK.LE.NXCHIS(K)))
     &            WRITE(BUFFER(52:57),'(I6)')  XCHIS(IXINDX1)
               IF (((NDMASCRN+NDMAPS).GT.0).AND.
     &             (KK.LE.NSCROFXCG(K)))
     &            WRITE(BUFFER(58:62),'(I5)')SCROFXCG(IXINDX2)
               IF (((NDMASCRN+NDMAPS).GT.0).AND.
     &             (KK.LE.NSCROFXCD(K)))
     &            WRITE(BUFFER(63:67),'(I5)')SCROFXCD(IXINDX2)
               IF ((NDMAPM.GT.0).AND.(KK.LE.NPSMINOFXCG(K)))
     &            WRITE(BUFFER(68:72),'(I5)')PSMINOFXCG(IXINDX3)
               IF ((NDMAPM.GT.0).AND.(KK.LE.NPSMINOFXCD(K)))
     &            WRITE(BUFFER(73:78),'(I6)')PSMINOFXCD(IXINDX3)
               WRITE(6,'(A)')BUFFER
CS               WRITE(6,'(A,F8.3,A,I6,3I5,I6)')
CS     &            '                                      ',
CS     &            XDETEFFOFXCHAR(IK),'      ',
CSCS     &            XCHIS(K,KK),SCROFXCG(K,KK),SCROFXCD(K,KK),
CS     &            XCHIS(IXINDX1),SCROFXCG(IXINDX2),SCROFXCD(IXINDX2),
CSCS     &            PSMINOFXCG(K,KK),PSMINOFXCD(K,KK)
CS     &            PSMINOFXCG(IXINDX3),PSMINOFXCD(IXINDX3)
 23         CONTINUE
 24      CONTINUE

         IF (LXCONT) THEN
           CALL CHKBND (7,NXCONT,'SESAME1','ENEROFXCONT')
           WRITE(6,'(A)')'    '
           WRITE(6,'(A)')' XCONT Tables: '
           WRITE(6,'(A)')' INDEX    ENERGY' 
           CALL CHKBND (7,NXCONT,'SESAME1','IXCONTOFXCHAR')
           DO 25 I=1,NXCONT
             WRITE(6,'(2I5,F11.2)')I,IXCONTOFXCHAR(I),ENEROFXCONT(I)
 25        CONTINUE
         ENDIF

CS         WRITE(6,'(A)')'    '
CS         WRITE(6,'(A)')' STATCS Tables: '
CS         WRITE(6,'(A)')' BEHIS  TEHIS  AEHIS   SEHIS    '
CS         WRITE(6,'(A)')'--------------------------------------'

CS         DO 26,K=1,MXHIST
CS         WRITE(6,*) '  ',CVALUE(BEHIS(K)),'    ',CVALUE(TEHIS(K)),
CS     .		    '    ',CVALUE(AEHIS(K)),'    ',CVALUE(SEHIS(K))
CS 26	 CONTINUE

c         OPEN(17,FILE='LAMPLAS',CARRIAGECONTROL='LIST',STATUS='UNKNOWN')
c         DO 9990,I=1,1000
c            E = EPRIM*I/1000.
c      	    CALL P_LAMBDA(1,E,PLAMBDA,IER)
c 	    WRITE(17,*) E,PLAMBDA
c 9990    CONTINUE
c         CLOSE(17)

c         OPEN (17,FILE='LAMELA',CARRIAGECONTROL='LIST',STATUS='UNKNOWN')
c      	  DO 9991,I=1,1000
c            E = EPRIM*I/1000.
c      	    CALL E_LAMBDA(1,E,ELAMBDA,IER)
c 	    WRITE(17,*) E,ELAMBDA
c 9991    CONTINUE
c         CLOSE(17)
      
c         IF (NSHELL .GT. 0) THEN
c         OPEN (17,FILE='LAMION',CARRIAGECONTROL='LIST',STATUS='UNKNOWN')
c      	  DO 9992,I=1,1000
c            E = EPRIM*I/1000.
c            SIGMAION = DINTERPOL(SIGMA_ION(1,1,NSHELLOFREG(1)),
c     .	 	 		 MAXENER,EMIN,EMAX,E,IER)
c            IF (SIGMAION.NE.0) THEN 
c      	       WRITE(17,*) E,1./(TOT_ATDENS(1)*SIGMAION)
c            ENDIF
c 9992    CONTINUE
c         CLOSE(17)
c         ENDIF

c         IF (NAUGER .GT. 0) THEN
c         OPEN (17,FILE='LAMAUG',CARRIAGECONTROL='LIST',STATUS='UNKNOWN')
c      	  DO 9993,I=1,1000
c            E = EPRIM*I/1000.
c            SIGMAAUG = DINTERPOL(SIGMA_AUG(1,1,1),
c     .	 	 		 MAXENER,EMIN,EMAX,E,IER)
c            IF (SIGMAAUG.NE.0) THEN 
c      	       WRITE(17,*) E,1./(TOT_ATDENS(1)*SIGMAAUG)
c            ENDIF
c 9993    CONTINUE
c         CLOSE(17)
c         ENDIF

*        WRITE DETECTOR INFORMATION
*        X-RAY DETECTOR
         WRITE(6,'(A)')'        '
         WRITE(6,'(A)')' X-RAY DETECTOR INFO:'
         WRITE(6,'(2A)')' DET#   TAKOFF  XDEROT    SOLIDA   FWHM   ',
     &                      '  ENFWHM  XDTYPE  XFDEFF'
         WRITE(6,'(2A)')'---------------------------------------',
     &                  '-------------------------------'
         DO 9994 I=0,NXDET
             WRITE(6,'(I4,F10.2,F8.2,F10.5,F8.2,F10.2,4A)')
     &               I,DTAKOFF(I),DXDEROT(I),DSOLIDA(I),DFWHM(I),
     &               DENFWHM(I),'    ',DXDTYPE(I),'    ',
     &               DXFDEFF(I)(1:IEND(DXFDEFF(I)))
9994     CONTINUE
*        ELECTRON DETECTOR
         WRITE(6,'(A)')'        '
         WRITE(6,'(A)')' ELECTRON DETECTOR INFO:'
         WRITE(6,'(2A)')' DET#   EDTHET   EDPHI   EDTHMN  EDTHMX',
     &                  '  ACC.ANG   FEDTRN  '
         WRITE(6,'(2A)')'------------------------------------',
     &                  '--------------------------------'
         DO 9995 I=0,NEDET
             WRITE(6,'(I4,F10.2,F8.2,F9.2,F8.2,F9.2,2A)')
     &            I,DEDTHET(I)*180/PI,DEDPHI(I)*180/PI,
     &            DEDTHMN(I)*180/PI,DEDTHMX(I)*180/PI,EDACAN(I),
     &            '   ',DFEDTRN(I)(1:IEND(DFEDTRN(I)))
9995     CONTINUE

*        WRITE SOME HISTOGRAM INFORMATION:
         IF (NHIST.GT.0) THEN
           WRITE(6,'(A)')'        '
           WRITE(6,'(A)')' SOME HISTOGRAM INFO:'
           WRITE(6,'(A,I3)')' TOTAL NUMBER OF HISTOGRAMS: ',NHIST
           WRITE(6,'(A,I3)')' NUMBER OF BE HISTOGRAMS:    ',NBEHIS
           WRITE(6,'(A,I3)')' NUMBER OF TE HISTOGRAMS:    ',NTEHIS
           WRITE(6,'(A,I3)')' NUMBER OF SE HISTOGRAMS:    ',NSEHIS
           WRITE(6,'(A,I3)')' NUMBER OF AE HISTOGRAMS:    ',NAEHIS
           NHN=MAX(NBEHIS,NTEHIS)
           NHN=MAX(NHN,NSEHIS)
           NHN=MAX(NHN,NAEHIS)
           IF (NHN.GT.0) THEN
              WRITE(6,'(A)')'      BEHIS    TEHIS    SEHIS    AEHIS'
           ENDIF
           DO 9996 I=1,NHN
              WRITE(6,'(4I9)')BEHIS(I),TEHIS(I),SEHIS(I),AEHIS(I)
 9996      CONTINUE
         ENDIF
      ENDIF


C      IF (AUGMOD .EQ. 1) CALL INIAUGESCHIS(NPTS,NFCS)

C     ---PROVIDE SCREEN AND POSTMINI TABLES FROM SHELL AND XCHAR TABLES
      CALL TRNTAB()

C     ---DRAW STATUS WINDOW (ION LEGEND) AND XCHAR-TABLE (OPEN THIS ONE FIRST)
      IF (LSTATW) THEN
         IF (NXCHAR.GT.0) THEN
            NWIDTH=125+80+(NXDET+1)*(75+75)
            NHEIGH=87+NXCHAR*17
  	    CALL F_OPENX(NWIDTH,NHEIGH,100,100,
     .                   'SeSAME X-char Table','SeSAME',2,NXCSTAT)
            CALL DRWXCT(1,IETRN1)
            NYWIPO=MIN(600,100+NHEIGH+35)
            CALL F_OPENX(NWIDTH,NHEIGH,100,NYWIPO,
     .                   'SeSAME X-Detector Table','SeSAME',2,NXDSTAT)
            CALL DRWXDET(1,IETRN1)
            IF (LPTOB) THEN
               NYWIPO=MIN(1000,100+2*(NHEIGH+35))
               NXWIPO=100
               IF ((NHEIGH+NYWIPO).GT.1200) NXWIPO=150
               CALL F_OPENX(NWIDTH,NHEIGH,NXWIPO,NYWIPO,
     .                      'SeSAME P/B Table','SeSAME',2,NXKSTAT)
               CALL DRWXKT(1,IETRN1)
            ENDIF
         ENDIF
         CALL DRWSTA(.FALSE.,IETRN1)
      ENDIF

      WRITE(6,'(A)')'      '
      CALL STATXT(' SIMULATING ELECTRON TRAJECTORIES')

      WRITE(6,'(A)')'         '

C LOOP OVER ELECTRONS
C ===================

      DO 10, IETRN=IETRN1,NETRN
	 IF ((IETRN/500.) .EQ. AINT(IETRN/500.))
     &      WRITE(6,'(I12,A)')IETRN,' ELECTRONS SIMULATED' 
*        ---INITIALIZE ELECTRON TRAJECTORY
*        ---BRANCH TO SELECTED ELECTRON SOURCE

	 GOTO (50,55,60) NELESOURCE

*        ELECTRON BEAM
*        -------------

*        CALCULATE POINT Q (ROTATED COORDINATE SYSTEM = E- BEAM
*        DIRECTION IS Z-AXIS OF NEW COORDINATE SYSTEM)
 50      IF (SCAN) THEN
            IELREL=IETRN-IETRN1+1
*           NEW SCAN POSITION
            INDX=MOD(IELREL,NLSCP)
            IF (INDX.EQ.0) INDX=NLSCP
            XPREF=XPREFC(INDX)
            YPREF=YPREFC(INDX)
CS            ZPREF=(XESPOT*DXGEN+ZFOCUS*DZGEN-(XESPOT-XPREF)*
CS     &            (DXGEN+DTAN(SCANANG)))/DZGEN
         ENDIF
         ZQS=0
CS         RADIUS=SPSIZE*DABS(RANNO())/3.3
         RR=RANNUM()
CS         IF (RR.EQ.0) RR=1.0E-10
         RADIUS=0.3295051144911*SPSIZE*DSQRT(-DLOG(RR))
         ANGQ=RANNUM()*2*PI
         XQS=RADIUS*COS(ANGQ)
         YQS=RADIUS*SIN(ANGQ)
         IF (DIVERG.GT.ZERO) THEN
CS	    SINPSH=SIN(DIVERG*PI/360)*SQRT(RANNUM())
CS	    DIVACT=TWO*ASIN(SINPSH)
            DIVACT=RANNUM()*DIVERG*PI/180
            XDMY=XQS*(1-SIN(DIVACT)/RADIUS)
            YDMY=YQS*(1-SIN(DIVACT)/RADIUS)
            ZDMY=COS(DIVACT)
         ELSE
            XDMY=XQS
            YDMY=YQS
            ZDMY=1
         ENDIF
*        ROTATE BACK TO ORIGINAL COORDINATE SYSTEM
*        X/Z ROTATION
         XQS1=XQS*COS(EBTLTR)-ZQS*SIN(EBTLTR)
         ZQS1=XQS*SIN(EBTLTR)+ZQS*COS(EBTLTR)
         YQS1=YQS
         XDMY1=XDMY*COS(EBTLTR)-ZDMY*SIN(EBTLTR)
         ZDMY1=XDMY*SIN(EBTLTR)+ZDMY*COS(EBTLTR)
         YDMY1=YDMY
*        X/Y ROTATION
         XQS=XQS1*COS(EBROTR)-YQS1*SIN(EBROTR)
         YQS=XQS1*SIN(EBROTR)+YQS1*COS(EBROTR)
         ZQS=ZQS1
         XDMYS=XDMY1*COS(EBROTR)-YDMY1*SIN(EBROTR)
         YDMYS=XDMY1*SIN(EBROTR)+YDMY1*COS(EBROTR)
         ZDMYS=ZDMY1
*        DETERMINE DIRECTION (LENGTH OF VECTOR NORMALIZED TO 1)
         DIRX=XDMYS-XQS
         DIRY=YDMYS-YQS
         DIRZ=ZDMYS-ZQS
*        TRANSLATION
         X=XQS+XPREF
         Y=YQS+YPREF
         Z=ZQS+ZPREF
*        MOVE STARTING POINT DEFINITELY OUTSIDE SAMPLE
 54      X=X-DIRX*(DABS(ZMAX-ZMIN))
         Y=Y-DIRY*(DABS(ZMAX-ZMIN))
         Z=Z-DIRZ*(DABS(ZMAX-ZMIN))
         IF (Z.GE.ZSMIN) GOTO 54
  	 FRAC = 1.
	 E = EPRIM + ESTD*RANNO()
CHW      ---PRIMARY ELECTRON : FRAC=1,IETYP=1(PE)
         IETYP= 1
         FRAC = 1.
	 GOTO 70

*        PHI(Z) SOURCE
*        -------------
 55      RAND = RANNUM()
	 II = AINT(RAND*100.)
	 TESTRAN(II) = TESTRAN(II) + 1
	 CALL ZPHI(Z,FRAC,RAND,1)
	 X = (XW1+XW2)/2.
	 Y = 0
	 DIRX = 0
	 DIRY = 0
	 DIRZ = 1
	 FI = 2*PI*RANNUM()
	 PSI = 2*PI*RANNUM()
	 COSFI = COS(FI)
	 SINFI = SIN(FI)
	 COSPSI = COS(PSI)
	 SINPSI = SIN(PSI)
	 CALL NDIRA(
     V              DIRX,DIRY,DIRZ,
     I              COSPSI,SINPSI,COSFI,SINFI)
	 E = EPRIM
CHW      ---PRIMARY ELECTRON : FRAC=1,IETYP=1(PE)
         IETYP= 1
         FRAC = 1.
	 GOTO 70

*        READ ELECTRON STARTING DATA FROM FILE
*        -------------------------------------
cs 60      READ(18,FMT='(4F9.0,4E9.2)',END=1000)
 60      READ(18,*,END=1000)X,Y,Z,DIRX,DIRY,DIRZ,E,FRAC
         DNORMLZ=DSQRT(DIRX*DIRX+DIRY*DIRY+DIRZ*DIRZ)
         IF (DNORMLZ.LE.0) GOTO 60
         DIRX=DIRX/DNORMLZ
         DIRY=DIRY/DNORMLZ
         DIRZ=DIRZ/DNORMLZ
CS       ---SECONDARY ELECTRON : IETYP=4 (SE)
         IETYP= 4

	 GOTO 70

70       CONTINUE

*        ---RESET THE NORMAL DISTRIBUTED RANDOM NUMBER GENERATOR
	 CALL RNNSET(
     I               .TRUE.,DUMMY)

*        ---INITIALIZE TRAJECTORY STATISTICS
	 CALL STATCS(
     I               21,X,Y,Z,DUMMY4,DUMMY5,DUMMY6,DUMMY7,DUMMY8,
     I               DUMMY9,DUMMY10,DUMMY11,DUMMY12,
     I               DUMMY,DUMMY,IDUM1,IDUM2)

*        ---SAVE STARTING POINT 

 100     XSP = X
	 YSP = Y
	 ZSP = Z
   
         CALL ONETRJ(
     V               IETYP,NPTS,NFCS,
     V               NSCAT,NSCATEL,NSCATIO,NSCATPL,TRJLEN,
     V               X,Y,Z,DIRX,DIRY,DIRZ,E,FRAC,
     A               VALION,VALBREMS,XCABS,
     A               BREMSSPEC,BREMSANGLE)

         TRLEN(1)=TRLEN(1)+TRJLEN
         NSCATTER(1)=NSCATTER(1)+NSCAT
         NSCATTER(2)=NSCATTER(2)+NSCATEL
         NSCATTER(3)=NSCATTER(3)+NSCATIO
         NSCATTER(4)=NSCATTER(4)+NSCATPL

CS-TEST-START
c      write(6,'(6d11.4)')ionintofshell(1),
c     &                   xgenofxchar(1),
c     &                   xdetofxchar(1,1),
c     &                   ionintofshell(1)/ietrn,
c     &                   xgenofxchar(1)/ietrn,
c     &                   xdetofxchar(1,1)/ietrn
c      write(6,'(3d11.4)')ionintofshell(1)-AIONOLD,
c     &                   xgenofxchar(1)-XGENOLD,
c     &                   xdetofxchar(1,1)-XDETOLD
c      write(6,'(a)')'   '
c      AIONOLD=ionintofshell(1)
c      XGENOLD=xgenofxchar(1)
c      XDETOLD=xdetofxchar(1,1)
CS      READ(6,'(A)')
CS-TEST-END

	 IF (E.LE.0) E = 0

*        ---EVALUATE FINAL ELECTRON STATE
	 
	 IF (E .LE. EMIN) GOTO 710
*        ELECTRON ENERGY LOW

	 IF (X.LT.XMIN) THEN
*        ELECTRON LEFT ON LEFT SIDE
	    NOUTL = NOUTL + 1
            TRLENS(1)=TRLENS(1)+TRJLEN
	    GOTO 800
	 ENDIF

	 IF (X.GT.XMAX) THEN
*        ELECTRON LEFT ON RIGHT SIDE
	    NOUTR = NOUTR + 1
            TRLENS(1)=TRLENS(1)+TRJLEN
	    GOTO 800
	 ENDIF

*        CALCULATE TRANSMISSION IF NEEDED FOR IETYP 
         IF (LDELE(IETYP)) THEN
            DFRAC(0) = 1.
            DO 120 IED=0,NEDET
               DFRAC(IED) = 1.
               CALL ELDECT(IED,DIRX,DIRY,DIRZ,E,DFRAC(IED))
 120        CONTINUE
         ENDIF

*	 IS THIS AN AUGER ELECTRON AND ADD SPECIFIED FOR THIS LINE ?
 
         IF (IETYP .EQ. 5) THEN
            IF (ADDHIS(IESUBTYP) .GT. 0) THEN
               IF (E .GE. ENEROFAUGER(IESUBTYP)) THEN
      		  CALL IMSURFGETDEPTH(XSP,ZSP,DD,DL,IR)
      	          IF (IR.EQ.0) THEN
                     DDFRAC=DFRAC(HISEDT(ADDHIS(IESUBTYP)))
      		     CALL HISTOG(2,ADDHIS(IESUBTYP),DDFRAC*FRAC,
     .		  	         DL,DD,DD)
                  ENDIF
      	       ENDIF
            ENDIF
         ENDIF

	 IF ((DIRZ.LT.0).AND.(Z.LE.ZSMAX)) GOTO 720
*        ELECTRON IS BACKSCATTERED

	 IF ((DIRZ.GT.0).AND.(Z.GT.ZSMAX)) GOTO 730
*        ELECTRON IS TRANSMITTED

*        ELSE ELECTRON LEFT ON THE SIDE
         IF (LTEST) THEN
            WRITE(6,'(A)')'   '
            WRITE(6,'(A,I7,2A)')' ELECTRON #',IETRN,' LEFT SAMPLE',
     &                          ' AND IS LOST !'
         ENDIF
         IF (DIRX.LT.0) NOUTL=NOUTL+1
         IF (DIRX.GE.0) NOUTR=NOUTR+1
	 NOUTLR = NOUTLR + 1
         TRLENS(1)=TRLENS(1)+TRJLEN
	 GOTO 800

*        ---ELECTRON HAS STOPPED 
710      CALL STATCS(
     I               23,X,Y,Z,XSP,YSP,ZSP,XAIR,YAIR,DUMMY,
     I               DIRX,DIRY,DIRZ,
     I               E,FRAC,IETYP,IESUBTYP)
         TRLENP(1)=TRLENP(1)+TRJLEN
	 GOTO 800

*        ---ELECTRON IS BACKSCATTERED
720      CALL STATCS(
     I               24,X,Y,Z,XSP,YSP,ZSP,XAIR,YAIR,DFRAC,
     I               DIRX,DIRY,DIRZ,
     I               E,FRAC,IETYP,IESUBTYP)
         TRLENB(1)=TRLENB(1)+TRJLEN
	 GOTO 800

*        ---ELECTRON IS TRANSMITTED
730      CALL STATCS(
     I               25,X,Y,Z,XSP,YSP,ZSP,XAIR,YAIR,DFRAC,
     I               DIRX,DIRY,DIRZ,
     I               E,FRAC,IETYP,IESUBTYP)
         TRLENT(1)=TRLENT(1)+TRJLEN
	 GOTO 800

*        ---RESET OLD LATTICE SITE LIST
 800     E=ZERO

CHW      SECONDARY ELECTRONS LEFT ?      
	 IF (NSEC .GT. 0) THEN
	    DIRX = SEC_DIRX(NSEC)
	    DIRY = SEC_DIRY(NSEC)
	    DIRZ = SEC_DIRZ(NSEC)
	    X = SEC_X(NSEC)
	    Y = SEC_Y(NSEC)
	    Z = SEC_Z(NSEC)
	    E = SEC_E(NSEC)
	    FRAC = SEC_FRAC(NSEC)       
	    IETYP = SEC_ETYP(NSEC)
       	    IESUBTYP = SEC_ESUBTYP(NSEC)
      	    NSEC = NSEC - 1
	    GOTO 100
	 ENDIF  
 
*        ---WRITE A BACKUP FILE IF DESIRED
	 IF (NETRBK.GT.0) THEN
	    IF (MOD(IETRN,NETRBK).EQ.0 .OR. IETRN.EQ.NETRN) 
     1         CALL BACKUP(
     I                     IETRN,
     I                     VALION,VALBREMS,XCABS)
	 ENDIF


*        ---UPDATE SCREEN(S) FOR IONIZATION DISTRIBUTIONS
	 IF (MOD(IETRN,NSCRUP).EQ.0.OR.IETRN.EQ.NETRN) THEN
*           UPDATE SCATTERING AND TRAJECTORY INFORMATION
            NOUTS=NOUTL+NOUTR
            TRLEN(2)=TRLEN(1)/IETRN
            IF (NIN.GT.0) TRLENP(2)=TRLENP(1)/NIN
            IF (NBACK.GT.0) TRLENB(2)=TRLENB(1)/NBACK
            IF (NTRAN.GT.0) TRLENT(2)=TRLENT(1)/NTRAN
            IF (NOUTS.GT.0) TRLENS(2)=TRLENS(1)/NOUTS
            IF (NSCATTER(1).GT.0) THEN
               TRLEN(3)=TRLEN(1)/NSCATTER(1)
               TRLENP(3)=TRLENP(1)/NSCATTER(1)
               TRLENB(3)=TRLENB(1)/NSCATTER(1)
               TRLENT(3)=TRLENT(1)/NSCATTER(1)
               TRLENS(3)=TRLENS(1)/NSCATTER(1)
            ENDIF

            IF (NSCATTER(2).GT.0) THEN
               TRLEN(4)=TRLEN(1)/NSCATTER(2)
               TRLENP(4)=TRLENP(1)/NSCATTER(2)
               TRLENB(4)=TRLENB(1)/NSCATTER(2)
               TRLENT(4)=TRLENT(1)/NSCATTER(2)
               TRLENS(4)=TRLENS(1)/NSCATTER(2)
            ENDIF

            IF (NSCATTER(3).GT.0) THEN
               TRLEN(5)=TRLEN(1)/NSCATTER(3)
               TRLENP(5)=TRLENP(1)/NSCATTER(3)
               TRLENB(5)=TRLENB(1)/NSCATTER(3)
               TRLENT(5)=TRLENT(1)/NSCATTER(3)
               TRLENS(5)=TRLENS(1)/NSCATTER(3)
            ENDIF

            IF (NSCATTER(4).GT.0) THEN
               TRLEN(6)=TRLEN(1)/NSCATTER(4)
               TRLENP(6)=TRLENP(1)/NSCATTER(4)
               TRLENB(6)=TRLENB(1)/NSCATTER(4)
               TRLENT(6)=TRLENT(1)/NSCATTER(4)
               TRLENS(6)=TRLENS(1)/NSCATTER(4)
            ENDIF

            IF (LTEST) THEN
               WRITE(6,'(A)')'        '
               WRITE(6,'(A,I7)')' TOTAL NUMBER OF ELECTRONS: ',IETRN
               WRITE(6,'(A,I7)')' EL. STOPPED INSIDE SAMPLE: ',NIN
               WRITE(6,'(A,I7)')' BACKSCATTERED ELECTRONS:   ',NBACK
               WRITE(6,'(A,I7)')' TRANSMITTED ELECTRONS:     ',NTRAN
               WRITE(6,'(A,I7)')' ELECTRONS LEFT ON SIDE:    ',NOUTS
               WRITE(6,'(A)')' TOTAL MEAN PATH LENGTH PER ELECTRONS:'
               WRITE(6,'(A,F12.7,A)')' ALL ELECTRONS:           ',
     &                                 TRLEN(2)/10000,' m'
               WRITE(6,'(A,F12.7,A)')' EL. STOPPED IN SAMPLE:   ',
     &                                 TRLENP(2)/10000,' m'
               WRITE(6,'(A,F12.7,A)')' BACKSCATTERED ELECTRONS: ',
     &                                 TRLENB(2)/10000,' m'
               WRITE(6,'(A,F12.7,A)')' TRANSMITTED ELECTRONS:   ',
     &                                 TRLENT(2)/10000,' m'
               WRITE(6,'(A,F12.7,A)')' ELECTRONS LEFT ON SIDE:  ',
     &                                 TRLENS(2)/10000,' m'
               IF (NSCATTER(1).GT.0) THEN
                WRITE(6,'(2A)')' MEAN PATH LENGTH BETWEEN TWO ',
     &                         'SCATTERING EVENTS:'
                WRITE(6,'(A,F12.7,A)')' ALL ELECTRONS:           ',
     &                                  TRLEN(3),' '
cs                WRITE(6,'(A,F12.7,A)')' EL. STOPPED IN SAMPLE:   ',
cs     &                                 TRLENP(3),' '
cs                WRITE(6,'(A,F12.7,A)')' BACKSCATTERED ELECTRONS: ',
cs     &                                  TRLENB(3),' '
cs                WRITE(6,'(A,F12.7,A)')' TRANSMITTED ELECTRONS:   ',
cs     &                                  TRLENT(3),' '
cs                WRITE(6,'(A,F12.7,A)')' ELECTRONS LEFT ON SIDE:  ',
cs     &                                  TRLENS(3),' '
               ENDIF
               IF (NSCATTER(2).GT.0) THEN
                WRITE(6,'(2A)')' MEAN PATH LENGTH BETWEEN TWO ',
     &                         ' ELASTIC SCATTERING EVENTS:'
                WRITE(6,'(A,F12.7,A)')' ALL ELECTRONS:           ',
     &                                  TRLEN(4),' '
cs                WRITE(6,'(A,F12.7,A)')' EL. STOPPED IN SAMPLE:   ',
cs     &                                 TRLENP(4),' '
cs                WRITE(6,'(A,F12.7,A)')' BACKSCATTERED ELECTRONS: ',
cs     &                                  TRLENB(4),' '
cs                WRITE(6,'(A,F12.7,A)')' TRANSMITTED ELECTRONS:   ',
cs     &                                  TRLENT(4),' '
cs                WRITE(6,'(A,F12.7,A)')' ELECTRONS LEFT ON SIDE:  ',
cs     &                                  TRLENS(4),' '
               ENDIF
               IF (NSCATTER(3).GT.0) THEN
                WRITE(6,'(2A)')' MEAN PATH LENGTH BETWEEN TWO ',
     &                         'IIONIZATION EVENTS:'
                WRITE(6,'(A,F12.7,A)')' ALL ELECTRONS:           ',
     &                                  TRLEN(5)/10000,' m'
cs                WRITE(6,'(A,F12.7,A)')' EL. STOPPED IN SAMPLE:   ',
cs     &                                 TRLENP(5)/10000,' m'
cs                WRITE(6,'(A,F12.7,A)')' BACKSCATTERED ELECTRONS: ',
cs     &                                  TRLENB(5)/10000,' m'
cs                WRITE(6,'(A,F12.7,A)')' TRANSMITTED ELECTRONS:   ',
cs     &                                  TRLENT(5)/10000,' m'
cs                WRITE(6,'(A,F12.7,A)')' ELECTRONS LEFT ON SIDE:  ',
cs     &                                  TRLENS(5)/10000,' m'
               ENDIF
               IF (NSCATTER(4).GT.0) THEN
                WRITE(6,'(2A)')' MEAN PATH LENGTH BETWEEN TWO ',
     &                         'SCATTERING EVENTS:'
                WRITE(6,'(A,F12.7,A)')' ALL ELECTRONS:           ',
     &                                  TRLEN(6),' '
cs                WRITE(6,'(A,F12.7,A)')' EL. STOPPED IN SAMPLE:   ',
cs     &                                 TRLENP(6),' '
cs                WRITE(6,'(A,F12.7,A)')' BACKSCATTERED ELECTRONS: ',
cs     &                                  TRLENB(6),' '
cs                WRITE(6,'(A,F12.7,A)')' TRANSMITTED ELECTRONS:   ',
cs     &                                  TRLENT(6),' '
cs                WRITE(6,'(A,F12.7,A)')' ELECTRONS LEFT ON SIDE:  ',
cs     &                                  TRLENS(6),' '
               ENDIF
            ENDIF

            IF (LSTATW) THEN
              IF (NXCHAR.GT.0) THEN
                 CALL DRWXCT(2,IETRN)
cs                 CALL DRWXDET(2,IETRN)
                 IF (LPTOB) CALL DRWXKT(2,IETRN)
              ENDIF
              CALL DRWSTA(.FALSE.,IETRN)
824           CALL F_GETMOUSEPRESSEVENT(IX,IY,ISTAT,NS)
              IF (NS.EQ.1) THEN   
                DO 825 I=1,NBUT
                  IF (IX .GE. BUTX1(I) .AND. IX .LE. BUTX2(I) .AND.
     .            IY .GE. BUTY1(I) .AND. IY .LE. BUTY2(I)) THEN
C                     DOSOMETHING
      		     IF (I.EQ.1) THEN
                        IDMAFLAG=0
                        RETURN
                     ENDIF
                  ENDIF 
825             CONTINUE
      		GOTO 824
              ENDIF
            ENDIF


CS            DO 803 IION=1,NSHELL
CS               DO 802 ISCR=1,NSCROFION(IION)
CS                  IF (SCROFION(IION,ISCR).LE.NSCRN) THEN
CS                     CALL DRWLDH(1,IION,0,
CS     &                   HISTOFION(IION),SCROFION(IION,ISCR),1)
CS                  ENDIF
CS 802           CONTINUE
CS 803        CONTINUE
CS            DO 806 IIXCH=1,NXCHAR
CS               ISHTAB=SHELLOFXCHAR(IIXCH)
CS               DO 804 ISCR=1,NSCROFXCG(ISHTAB)
CS                  IF (SCROFXCG(ISHTAB,ISCR).LE.NSCRN) THEN
CS                     CALL DRWLDH(2,ISHTAB,IIXCH,
CS     &                   HISTOFION(ISHTAB),SCROFXCG(ISHTAB,ISCR),1)
CS                  ENDIF
CS 804           CONTINUE
CS               DO 805 ISCR=1,NSCROFXCD(ISHTAB)
CS                  IF (SCROFXCD(ISHTAB,ISCR).LE.NSCRN) THEN
CS                     CALL DRWLDH(3,ISHTAB,IIXCH,
CS     &                   HISTOFION(ISHTAB),SCROFXCD(ISHTAB,ISCR),
CS     &                   XDETSCROFXCD(ISHTAB,ISCR))
CS                  ENDIF
CS 805           CONTINUE
CS 806        CONTINUE

            IF (LSCRN) THEN
               DO 803 ISCR=1,MIN(MXIONSCR,NSCRN)
                  ILAST=0
                  ILGLIN=ILOGIONTOSCR(ISCR)
                  DO 802 J=1,NIONTOSCR(ISCR)
                     ISINDX=(J-1)*(NDMASCRN+NDMAPS)+ISCR
                     CALL CHKBND(16,ISINDX,'SESAME1   ','IONTOSCR')
CS                     IION=IONTOSCR(ISCR,J)
                     IION=IONTOSCR(ISINDX)
                     CALL CHKBND(5,IION,'SESAME1   ','HISTOFION')
                     IF (J.EQ.NIONTOSCR(ISCR)) ILAST=1
                     CALL DRWLDH(1,J,ILAST,IION,0,
     &                           HISTOFION(IION),ISCR,1,ILGLIN,
     &                           VALION,XCABS)
 802              CONTINUE
 803           CONTINUE
               DO 805 ISCR=1,MIN(MXXCGSCR,NSCRN)
                  ILAST=0
                  ILGLIN=ILOGXCGTOSCR(ISCR)
                  DO 804 J=1,NXCGTOSCR(ISCR)
                     IF (J.EQ.NXCGTOSCR(ISCR)) ILAST=1
                     IXINDX=(J-1)*(NDMASCRN+NDMAPS)+ISCR
                     CALL CHKBND(21,IXINDX,'SESAME1   ','XCGTOSCR')
CS                     IXTAB=XCGTOSCR(ISCR,J)
                     IXTAB=XCGTOSCR(IXINDX)
                     CALL CHKBND(6,IXTAB,'SESAME1   ','SHELLOFXCHAR')
                     ISHTAB=SHELLOFXCHAR(IXTAB)
                     CALL CHKBND(5,ISHTAB,'SESAME1   ','HISTOFION')
                     CALL DRWLDH(2,J,ILAST,ISHTAB,IXTAB,
     &                           HISTOFION(ISHTAB),ISCR,1,ILGLIN,
     &                           VALION,XCABS)
 804              CONTINUE
 805           CONTINUE
               DO 807 ISCR=1,MIN(MXXCDSCR,NSCRN)
                  ILAST=0
                  ILGLIN=ILOGXCDTOSCR(ISCR)
                  DO 806 J=1,NXCDTOSCR(ISCR)
                     IF (J.EQ.NXCDTOSCR(ISCR)) ILAST=1
                     IXINDX=(J-1)*(NDMASCRN+NDMAPS)+ISCR
                     CALL CHKBND(21,IXINDX,'SESAME1   ',
     &                           'XCDTOSCR/...')
CS                     IXTAB=XCDTOSCR(ISCR,J)
                     IXTAB=XCDTOSCR(IXINDX)
                     CALL CHKBND(6,IXTAB,'SESAME1   ','SHELLOFXCHAR')
                     ISHTAB=SHELLOFXCHAR(IXTAB)
                     CALL CHKBND(5,ISHTAB,'SESAME1   ','HISTOFION')
                     CALL DRWLDH(3,J,ILAST,ISHTAB,IXTAB,
CS     &                    HISTOFION(ISHTAB),ISCR,XDETSCR(ISCR,J),
     &                    HISTOFION(ISHTAB),ISCR,XDETSCR(IXINDX),
     &                    ILGLIN,VALION,XCABS)
 806              CONTINUE
 807           CONTINUE


*              ---CHECK FOR MOUSE CLICKS IN LOCATION DEPENDENT OUTPUT

               IF (LLOC) THEN
                 DO 808 ILOC=1,NSCL
                   CALL F_OUTPUTTO(NXLOC(ILOC),NS)
      		   CALL DRWAXS(ILOC)
 809               CALL F_GETMOUSEPRESSEVENT(IX,IY,ISTAT,NS)
                   IF (NS .EQ. 1) THEN
                     CALL TRNZYX(ILOC,XX,YY,ZZ,DBLE(IX),DBLE(IY))
      	             CALL F_PEN(0,NS)
                     CALL F_FILLEDRECTANGLE(5.D0,DBLE(SCYSIZ(ILOC)-15),
     . 		  	                    100.D0,15.D0,NS)
                     CALL F_PEN(1,NS)
                     WRITE (CDUMMY,'(F7.0,A,F7.0,A)')  XX,'/',ZZ,' ANG'
                     CALL F_DRAWSTRING(5.D0,DBLE(SCYSIZ(ILOC)-1),CDUMMY)
      	             GOTO 809
                   ENDIF
 808             CONTINUE
*                UPDATE LEGEND FOR COLORED TRAJECTORIES
                 IF (LCOLTRJ) THEN
                    CALL COLLEG(E0,EF)
                 ENDIF
               ENDIF

*	       ---UPDATE SCREEN(S) IF DESIRED (FOR HISTOGRAMS)
       
      	       DO 814 IAUG = 1,NAUGER
                  DO 810 IAUG2=1,NADDLOC(IAUG)
                     IF (NADDLOC(IAUG).LE.NSCRN) THEN
                        CALL DRWAUG(IAUG,IAUG2,0)
                     ENDIF
 810              CONTINUE
                  DO 813 IAUG2=1,NAGDLOC(IAUG)
                     IF (NAGDLOC(IAUG).LE.NSCRN) THEN
                        CALL DRWAUG(IAUG,IAUG2,1)
                     ENDIF
 813              CONTINUE
 814           CONTINUE

               IF (LSCHIS) THEN
                  FDUMMY(1)=XESPOT
                  FDUMMY(2)=EBTILT
cs-test-start
c                  write(6,'(a)')'    '
c                  write(6,'(a)')' just before drawing Histograms'
c                  write(6,'(a,i3)')' nsch =',nsch
c                  write(6,'(a,f19.5)')' fdummy(1)=',fdummy(1)
c                  write(6,'(a,f19.5)')' fdummy(2)=',fdummy(2)
c                  read(*,*)
cs-test-end
                  DO 820 IHIS = 1,NSCH
                     IF ((CVALUE(IHIS)(1:3).EQ.'XKS').OR.
     &                   (CVALUE(IHIS)(1:3).EQ.'XRS').OR.
     &                   (CVALUE(IHIS)(1:3).EQ.'XCS')) THEN
                        IXDET=0
                        IF ((CVALUE(IHIS)(1:3).EQ.'XRS').OR.
     &                      (CVALUE(IHIS)(1:3).EQ.'XCS')) THEN
                           DO 815 IXCSHIS=1,NXCSHIS
                              IF (XCSHIS(IXCSHIS).EQ.IHIS) THEN
                                 IXDET=XCSDET(IXCSHIS)
                              ENDIF
 815                       CONTINUE
                        ENDIF
                        IF (CVALUE(IHIS)(1:3).EQ.'XRS') THEN
*                          STORE HISTOGRAM VALUES IN TEMPORARY ARRAY
                           NINTVL=1
                           DO 816 IDIM=1,NVDIM(IHIS)
                              NINTVL=NINTVL*NVAL(IHIS,IDIM)
 816                       CONTINUE
                           P2RHELP=MALLOC(SIZEOF(RHELP(1))*NINTVL)
                           IF (P2RHELP.EQ.0) THEN
                              WRITE(6,'(A)')'     '
                              WRITE(6,'(A)')' *** ERROR ***'
                              WRITE(6,'(2A)')' Could not allocate',
     &                                       ' memory for RHELP !'
                              STOP
                           ENDIF
                           JSTART=IVBEG(IHIS)-1
                           NVH=JSTART+NINTVL
                           CALL CHKBND(8,NVH,'SESAME1','VALHIS')
                           DO 817 J=1,NINTVL
                              RHELP(J)=VALHIS(JSTART+J)
 817                       CONTINUE
                           CALL IPOLHI(IHIS,IXDET,E0)
                           CALL ADDVAL(IHIS,NINTVL,RHELP)
cs                           CALL GETESC(ESCFAC,
cs     &                                 VALMIN(IHIS,1),VDELT(IHIS,1),
cs     &                                 IVBEG(IHIS),NVAL(IHIS,1),
cs     &                                 VALHIS(IVBEG(IHIS)))
                        ELSE IF (CVALUE(IHIS)(1:3).EQ.'XKS') THEN
                           DO 818 IXKSHIS=1,NXKSHIS
                              IF (XKSHIS(IXKSHIS).EQ.IHIS) THEN
                                 IXDET=XKSDET(IXKSHIS)
                              ENDIF
 818                       CONTINUE
                           CALL IPOLHI(IHIS,IXDET,E0)
                        ENDIF
                     ENDIF
                     IF (CVALUE(IHIS)(3:3) .EQ. 'Y' .AND. LGRAY) THEN
                        CALL DENSPLOT(IHIS,DBLE(IETRN))
                     ELSE IF ((CVALUE(IHIS)(1:3).EQ.'XCS').OR.
     &                        (CVALUE(IHIS)(1:3).EQ.'XKS').OR.
     &                        (CVALUE(IHIS)(1:3).EQ.'XRS')) THEN
                        FACTNORM=DBLE(IETRN)/(6.24219725D9*
     &                               CURRENT*DSOLIDA(IXDET)*MTIME)
                        CALL DRWHIS(IHIS,FACTNORM,DBLE(NTRAN),FDUMMY)
                     ELSE
                        FACTNORM=DBLE(IETRN)*VDELT(IHIS,1)
                        CALL DRWHIS(IHIS,FACTNORM,DBLE(NTRAN),FDUMMY)
                     ENDIF
                     IF (CVALUE(IHIS)(1:3).EQ.'XRS') THEN
                        DO 819 J=1,NINTVL
                           VALHIS(JSTART+J)=RHELP(J)
 819                    CONTINUE
                        CALL FREE(P2RHELP)
                     ENDIF
 820	          CONTINUE
	       ENDIF
	    ENDIF
         ENDIF

 10   CONTINUE

C END OF LOOP OVER PARTICLES
C ==========================

*     CALCULATE PEAK-TO-BACKGROUND AND FIORI FACTOR
      IF (NXPTOB.GT.0) THEN
        DO 832 I=1,NXCHAR
          IF (IXCHAROFXCONT(I).LE.0) GOTO 832
          DO 831 J=0,NXDET
            INDX=NDMAXDET*(IXCHAROFXCONT(I)-1)+(J+1)
            CALL CHKBND (13,INDX,'SESAME1','XDETOFXCONT')
            IXINDX=(I-1)*NDMAXDET+(J+1)
            CALL CHKBND (20,IXINDX,'SESAME1','XDETOFXCHAR')
            IF (DXDTYPE(J).EQ.'WD') THEN
*              PEAK MEASURED AT PEAK MAXIMUM
*              PEAK-TO-BACKGROUND IS THEN SIMPLY THE PEAK HIGHT AT
*              PEAK MAXIMUM DEVIDED BY BACKGROUND AT SAME ENERGY
CS               IF (XDETOFXCONT(J,IXCHAROFXCONT(I)).LE.0) GOTO 831
               IF (XDETOFXCONT(INDX).LE.0) GOTO 831
CS               IF (DFWHM(J).GT.100) DFWHM(J)=10
CS               XINTST=XDETOFXCHAR(J,I)*0.93944/DFWHM(J)
               XINTST=XDETOFXCHAR(IXINDX)*0.93944/DFWHM(J)
CS               XPEAKTOBACK(J,I)=XINTST/XDETOFXCONT(J,IXCHAROFXCONT(I))
               XPEAKTOBACK(IXINDX)=XINTST/XDETOFXCONT(INDX)
            ELSE
CS               IF (XDETOFXCONT(J,IXCHAROFXCONT(I)).LE.0) GOTO 831
               IF (XDETOFXCONT(INDX).LE.0) GOTO 831
*              ACTUAL FWHM AT ENERGY OF CHARACTERISTIC X-RAY LINE
               XFWHM=2.5*(ENEROFXCHAR(I)-DENFWHM(J))+DFWHM(J)**2
               IF (XFWHM.LT.1) XFWHM=1
               XFWHM=DSQRT(XFWHM)
*              TAKE 3 SIGMA RANGE
               ENINTV=6*XFWHM/2.355
*              TAKE FULL PEAK SIGNAL DEVIDED BY A CONSTANT BACKGROUND
*              OF A 3 SIGMA ENERGY RANGE
CS               XPEAKTOBACK(J,I)=XDETOFXCHAR(J,I)/ENINTV/
CS     &                          XDETOFXCONT(J,IXCHAROFXCONT(I))
               XPEAKTOBACK(IXINDX)=XDETOFXCHAR(IXINDX)/ENINTV/
     &                             XDETOFXCONT(INDX)
            ENDIF
*           FIORI FACTOR: FULL PEAK OVER A CONSTANT BACKGROUND
*           OF 10 eV ENERGY RANGE, 5 eV AT BOTH SIDES OF CHARACTERISTIC
*           ENERGY OF ACTUAL PEAK MAXIMUM
CS            XFIORIFACT(J,I)=XDETOFXCHAR(J,I)/10/
CS     &                      XDETOFXCONT(J,IXCHAROFXCONT(I))
            XFIORIFACT(IXINDX)=XDETOFXCHAR(IXINDX)/10/
     &                         XDETOFXCONT(INDX)
 831      CONTINUE
 832    CONTINUE
      ENDIF

      IF (LTEST) THEN
        WRITE(6,'(A)')'   '
        WRITE(6,'(2A)')' Generated ionizations per electron and',
     &                 ' steradiant for model=HYB:'
        WRITE(6,'(2A)')' Ionization probabilities summed up at',
     &                 ' each scattering event (el.and inel.)'
        WRITE(6,'(2A)')' All entries in SHELL table in one',
     &                 ' single number (PROPION)'
        WRITE(6,'(A,D14.5)')' PROPION = ',PROPION/NETRN/4/PI
        IF (NSHELL.GT.0) THEN
          WRITE(6,'(A)')'   '
          WRITE(6,'(2A)')'  atomic# shell        energy ',
     &                   '  ionizations'
          WRITE(6,'(2A)')' -----------------------------',
     &                   '-------------'
        ENDIF
        DO 833 I=1,NSHELL
          WRITE(6,'(I7,I6,F16.4,D14.5)')
     &                                ATNUM(ELEMOFSHELL(I)),
     &                                SHELLOFSHELL(I),
     &                                ENEROFSHELL(I)/1000,
     &                                IONINTOFSHELL(I)/NETRN
 833    CONTINUE
        IF (NXCHAR.GT.0) THEN
          WRITE(6,'(A)')'   '
          WRITE(6,'(3A)')'  atomic# shell line   energy ',
     &                   '  ionizations   gen. x-rays ',
     &                   '  det. x-rays   det#'
          WRITE(6,'(3A)')' -----------------------------',
     &                   '----------------------------',
     &                   '--------------------'
        ENDIF
        NND=0
        DO 835 I=1,NXCHAR
          IXINDX=(I-1)*NDMAXDET+1
          CALL CHKBND(5,SHELLOFXCHAR(I),'SESAME1   ','SHELLOFSHELL')
          WRITE(6,'(I7,2I6,F10.4,3D14.5,I6)')
cs          WRITE(6,'(I7,2I6,F10.4,3D14.5,f6.2)')
     &                         ATNUM(ELEMOFXCHAR(I)),
     &                         SHELLOFSHELL(SHELLOFXCHAR(I)),
     &                         XCHAROFXCHAR(I),
     &                         ENEROFXCHAR(I)/1000,
     &                         IONINTOFSHELL(SHELLOFXCHAR(I))/NETRN,
     &                         XGENOFXCHAR(I)/NETRN,
CS     &                         XDETOFXCHAR(0,I)/NETRN,
     &                         XDETOFXCHAR(IXINDX)/NETRN,
     &                         NND
cs     &                         xdeteffofxchar(
          DO 834 J=1,NXDET
            IXINDX=(I-1)*NDMAXDET+(J+1)
            CALL CHKBND(20,IXINDX,'SESAME1   ','XDETOFXCHAR')
            WRITE(6,'(2A,D14.5,I6)')'                             ',
     &                              '                            ',
CS     &                              XDETOFXCHAR(J,I),J
     &                              XDETOFXCHAR(IXINDX),J
 834      CONTINUE
 835    CONTINUE
        IF (NXCHAR.GT.0) THEN
          WRITE(6,'(A)')'   '
          WRITE(6,'(A)')' X-RAYS [COUNTS PER SECONDS]:'
          WRITE(6,'(3A)')'  atomic# shell line   energy ',
     &                   '  det. x-rays   P/B[1 eV]   ',
     &                   '  Fiori fact.   det#'
          WRITE(6,'(3A)')' -----------------------------',
     &                   '----------------------------',
     &                   '--------------------'
        ENDIF
        NND=0
        DO 845 I=1,NXCHAR
          IXINDX=(I-1)*NDMAXDET+1
          CALL CHKBND(5,SHELLOFXCHAR(I),'SESAME1   ','SHELLOFSHELL')
          WRITE(6,'(I7,2I6,F10.4,3D14.5,I6)')
     &                              ATNUM(ELEMOFXCHAR(I)),
     &                              SHELLOFSHELL(SHELLOFXCHAR(I)),
     &                              XCHAROFXCHAR(I),
     &                              ENEROFXCHAR(I)/1000,
CS     &                              XDETOFXCHAR(0,I)*6.24219725D9*
     &                              XDETOFXCHAR(IXINDX)*6.24219725D9*
     &                                 CURRENT*DSOLIDA(0),
CS     &                              XPEAKTOBACK(0,I),
     &                              XPEAKTOBACK(IXINDX),
CS     &                              XFIORIFACT(0,I),
     &                              XFIORIFACT(IXINDX),
     &                              NND
          DO 844 J=1,NXDET
            IXINDX=(I-1)*NDMAXDET+(J+1)
            CALL CHKBND(20,IXINDX,'SESAME1   ','XDETOFXCHAR')
            WRITE(6,'(A,3D14.5,I6)')'                             ',
CS     &                              XDETOFXCHAR(J,I)*6.24219725D9*
     &                              XDETOFXCHAR(IXINDX)*6.24219725D9*
     &                                 CURRENT*DSOLIDA(J),
CS     &                              XPEAKTOBACK(J,I),
     &                              XPEAKTOBACK(IXINDX),
CS     &                              XFIORIFACT(J,I),J
     &                              XFIORIFACT(IXINDX),J
 844      CONTINUE
 845    CONTINUE

        IF (NXCONT.GT.0) THEN
          WRITE(6,'(A)')'   '
          WRITE(6,'(A)')' BREMSSTRAHLUNG [absolute units]:'
          WRITE(6,'(2A)')'   energy [keV]   counts/sec         counts',
     &                   '    det#     det.efficiency'
          WRITE(6,'(2A)')'---------------------------------------',
     &                   '--------------------------------'
          NND=0
          MXINDX=NDMAXDET*(NXCONT-1)+1
          CALL CHKBND (13,MXINDX,'SESAME1','XDETOFXCONT')
        ENDIF
        DO 855 I=1,NXCONT
          IK1=NDMAXDET*(I-1)+1
          IK2=NDMAXDET*(IXCONTOFXCHAR(I)-1)+1
          CALL CHKBND (13,IK2,'SESAME1','XDETEFFOFXCHAR')
          WRITE(6,'(F13.4,2D15.5,I7,F17.5)')
     &                              ENEROFXCONT(I)/1000,
CS     &                              XDETOFXCONT(0,I)*6.24219725D9*
CS     &                                 CURRENT*DSOLIDA(0),
     &                              XDETOFXCONT(IK1)*6.24219725D9*
     &                                 CURRENT*DSOLIDA(0),
CS     &                              XDETOFXCONT(0,I)*6.24219725D9*
CS     &                                 CURRENT*DSOLIDA(0)*MTIME,
     &                              XDETOFXCONT(IK1)*6.24219725D9*
     &                                 CURRENT*DSOLIDA(0)*MTIME,
     &                              NND,
CS     &                              XDETEFFOFXCHAR(0,IXCONTOFXCHAR(I))
     &                              XDETEFFOFXCHAR(IK2)
          DO 854 J=1,NXDET
            IK1=NDMAXDET*(I-1)+(J+1)
            IK2=NDMAXDET*(IXCONTOFXCHAR(I)-1)+(J+1)
            CALL CHKBND (13,IK2,'SESAME1','XDETEFFOFXCHAR')
            WRITE(6,'(A,2D15.5,I7,F17.5)')'             ',
CS     &                              XDETOFXCONT(J,I)*6.24219725D9*
CS     &                              CURRENT*DSOLIDA(J),
     &                              XDETOFXCONT(IK1)*6.24219725D9*
     &                              CURRENT*DSOLIDA(J),
CS     &                              XDETOFXCONT(J,I)*6.24219725D9*
CS     &                              CURRENT*DSOLIDA(J)*MTIME,J,
     &                              XDETOFXCONT(IK1)*6.24219725D9*
     &                              CURRENT*DSOLIDA(J)*MTIME,J,
CS     &                              XDETEFFOFXCHAR(J,IXCONTOFXCHAR(I))
     &                              XDETEFFOFXCHAR(IK2)
 854      CONTINUE
 855    CONTINUE
*       WRITE SOME HISTOGRAM INFORMATION:
        IF (NHIST.GT.0) THEN
           WRITE(6,'(A)')'        '
           WRITE(6,'(A)')' SOME HISTOGRAM INFO:'
           WRITE(6,'(A,I3)')' TOTAL NUMBER OF HISTOGRAMS: ',NHIST
           WRITE(6,'(A,I3)')' NUMBER OF BE HISTOGRAMS:    ',NBEHIS
           WRITE(6,'(A,I3)')' NUMBER OF TE HISTOGRAMS:    ',NTEHIS
           WRITE(6,'(A,I3)')' NUMBER OF SE HISTOGRAMS:    ',NSEHIS
           WRITE(6,'(A,I3)')' NUMBER OF AE HISTOGRAMS:    ',NAEHIS
           NHN=MAX(NBEHIS,NTEHIS)
           NHN=MAX(NHN,NSEHIS)
           NHN=MAX(NHN,NAEHIS)
           IF (NHN.GT.0) THEN
              WRITE(6,'(A)')'      BEHIS    TEHIS    SEHIS    AEHIS'
           ENDIF
           DO 856 I=1,NHN
              WRITE(6,'(4I9)')BEHIS(I),TEHIS(I),SEHIS(I),AEHIS(I)
 856       CONTINUE
        ENDIF
      ENDIF

1000  IF (LETAB) CLOSE(18)      

CHW   CLOSE AUGER LIST
      IF (LAUGFILE) THEN
	 CLOSE(17)
      ENDIF

C      OPEN(17,FILE='TESTRAN',CARRIAGECONTROL='LIST',STATUS='NEW')
C	 DO 98,I=0,100
C	 WRITE(17,*)TESTRAN(I)
C98    CONTINUE

C FINAL EVALUATION AND OUTPUT OF RESULTS
C ======================================

      CALL STATCS(
     I            30,DUMMY1,DUMMY2,DUMMY3,DUMMY4,DUMMY5,DUMMY6,
     I            DUMMY7,DUMMY8,DUMMY9,DUMMY10,DUMMY11,DUMMY12,
     I            DUMMY,DUMMY,IDUM1,IDUM2)

      NOUTS=NOUTL+NOUTR
      NSTP=NETRN-NBACK-NTRAN-NOUTL-NOUTR
      WRITE (6,'(A)')'  '
      WRITE (6,'(A)')'  '
      WRITE (6,'(I12,A)')NETRN,
     &       ' ELECTRONS SIMULATED          '
      WRITE (6,'(I12,A,F16.4,A)')NSTP,
     &       ' ELECTRONS STOPPED INSIDE     ',
     &       DBLE(NSTP)/DBLE(NETRN)*100,' %'
      WRITE (6,'(I12,A,F16.4,A)')NBACK,
     &       ' ELECTRONS BACKSCATTERED      ',
     &       DBLE(NBACK)/DBLE(NETRN)*100,' %'
      WRITE (6,'(I12,A,F16.4,A)')NTRAN,
     &       ' ELECTRONS TRANSMITTED        ',
     &       DBLE(NTRAN)/DBLE(NETRN)*100,' %'
CS      WRITE (6,'(I12,A,F16.4,A)')NOUTS,
CS     &       ' ELECTRONS LEFT ON SIDE       ',
CS     &       DBLE(NOUTS)/DBLE(NETRN)*100,' %'
      WRITE (6,'(I12,A,F16.4,A)')NOUTR,
     &       ' ELECTRONS LEFT ON RIGHT SIDE ',
     &       DBLE(NOUTR)/DBLE(NETRN)*100,' %'
      WRITE (6,'(I12,A,F16.4,A)')NOUTL,
     &       ' ELECTRONS LEFT ON LEFT SIDE  ',
     &       DBLE(NOUTL)/DBLE(NETRN)*100,' %'
CS      WRITE (6,'(I12,A,F16.4,A)')NOUTLR,
CS     &       ' ELECTRONS GOT LOST           ',
CS     &       DBLE(NOUTLR)/DBLE(NETRN)*100,' %'
      WRITE (6,'(A)')'  '
      WRITE (6,'(A)')'  '

*     ---WRITE POSTMINI SAVE FILE
*     INNER-SHELL IONIZATION DISTRIBUTION (ALSO GENERATED AND
*     DETECTED CHAR. X-RAYS)
      IF (LPMION) THEN
         DO 142 IPM=1,MXIONPM
            CDUMMY='IONIZATION DISTRIBUTION       '
     &             //CBL//CBL//CBL//CBL
            ILAST=0
            DO 141 J=1,NIONTOPM(IPM)
               IF (J.EQ.NIONTOPM(IPM)) ILAST=1
               ISINDX=(J-1)*NDMAPM+IPM
               CALL CHKBND(17,ISINDX,'SESAME1   ','IONTOPM')
CS               ISHTAB=IONTOPM(IPM,J)
               ISHTAB=IONTOPM(ISINDX)
               CALL CHKBND(5,ISHTAB,'SESAME1   ','HISTOFION')
               CALL IONSAVE (
     D                       1,J,ILAST,ISHTAB,0,
     D                       NGRIDX,NGRIDZ,NGRIDY,
     I                       XGRIDL,ZGRIDL,YGRIDL,
     I                       HISTOFION(ISHTAB),VALION,
     I                       WGTGRD,XCABS,
     I                       XGRIDL(1),ZGRIDL(NGRIDZ),
     I			     CDUMMY,FILEPM(IPM),1)
 141        CONTINUE
 142     CONTINUE
         DO 146 IPM=1,MXXCGPM
            CDUMMY='GENERATED CHAR. X-RAY DISTRIBUTION      '
     &             //CBL//CBL//CBL
            ILAST=0
            DO 145 J=1,NXCGTOPM(IPM)
               IF (J.EQ.NXCGTOPM(IPM)) ILAST=1
               IXINDX=(J-1)*NDMAPM+IPM
               CALL CHKBND(22,IXINDX,'SESAME1   ','XCGTOPM')
CS               IXTAB=XCGTOPM(IPM,J)
               IXTAB=XCGTOPM(IXINDX)
               CALL CHKBND(6,IXTAB,'SESAME1   ','SHELLOFXCHAR')
               ISHTAB=SHELLOFXCHAR(IXTAB)
               CALL CHKBND(5,ISHTAB,'SESAME1   ','HISTOFION')
               CALL IONSAVE (
     D                       2,J,ILAST,ISHTAB,IXTAB,
     D                       NGRIDX,NGRIDZ,NGRIDY,
     I                       XGRIDL,ZGRIDL,YGRIDL,
     I                       HISTOFION(ISHTAB),VALION,
     I                       WGTGRD,XCABS,
     I                       XGRIDL(1),ZGRIDL(NGRIDZ),
     I			     CDUMMY,FILEPM(IPM),1)
 145        CONTINUE
 146     CONTINUE
         DO 148 IPM=1,MXXCDPM
            CDUMMY='DETECTED CHAR. X-RAY DISTRIBUTION       '
     &             //CBL//CBL//CBL
            ILAST=0
            DO 147 J=1,NXCDTOPM(IPM)
               IF (J.EQ.NXCDTOPM(IPM)) ILAST=1
               IXINDX=(J-1)*NDMAPM+IPM
               CALL CHKBND(22,IXINDX,'SESAME1   ','XCDTOPM')
CS               IXTAB=XCDTOPM(IPM,J)
               IXTAB=XCDTOPM(IXINDX)
               CALL CHKBND(6,IXTAB,'SESAME1   ','SHELLOFXCHAR')
               ISHTAB=SHELLOFXCHAR(IXTAB)
               CALL CHKBND(5,ISHTAB,'SESAME1   ','HISTOFION')
               CALL IONSAVE (
     D                       3,J,ILAST,ISHTAB,IXTAB,
     D                       NGRIDX,NGRIDZ,NGRIDY,
     I                       XGRIDL,ZGRIDL,YGRIDL,
     I                       HISTOFION(ISHTAB),VALION,
     I                       WGTGRD,XCABS,
     I                       XGRIDL(1),ZGRIDL(NGRIDZ),
cs     I		       CDUMMY,FILEPM(IPM),XDETPM(IPM,J))
     I			     CDUMMY,FILEPM(IPM),XDETPM(IXINDX))
 147        CONTINUE
 148     CONTINUE
      ENDIF

*     HISTOGRAMS
      IF (LPMHIS) THEN
         DO 149 I=1,NHIST
            IF (LOUTTO(I,3)) THEN
    	       CALL WRPMHI(I)
            ENDIF
 149     CONTINUE
      ENDIF

*     ---WRITE HISTOGRAM FILES
      IF (LHIS.AND.((NHIST-NSCH-NPMH).GT.0)) THEN
         DO 158 IHIS=NSCH+NPMH+1,NHIST
            IF (LOUTTO(IHIS,2)) THEN 
               IF ((CVALUE(IHIS)(1:3).EQ.'XKS').OR.
     &             (CVALUE(IHIS)(1:3).EQ.'XRS').OR.
     &             (CVALUE(IHIS)(1:3).EQ.'XCS')) THEN
                  IXDET=0
                  IF ((CVALUE(IHIS)(1:3).EQ.'XRS').OR.
     &                (CVALUE(IHIS)(1:3).EQ.'XCS')) THEN
                     DO 151 IXCSHIS=1,NXCSHIS
                        IF (XCSHIS(IXCSHIS).EQ.IHIS) THEN
                           IXDET=XCSDET(IXCSHIS)
                        ENDIF
 151                 CONTINUE
                  ENDIF
                  IF (CVALUE(IHIS)(1:3).EQ.'XRS') THEN
*                    STORE HISTOGRAM VALUES IN TEMPORARY ARRAY
                     NINTVL=1
                     DO 152 IDIM=1,NVDIM(IHIS)
                        NINTVL=NINTVL*NVAL(IHIS,IDIM)
 152                 CONTINUE
                     P2RHELP=MALLOC(SIZEOF(RHELP(1))*NINTVL)
                     IF (P2RHELP.EQ.0) THEN
                        WRITE(6,'(A)')'     '
                        WRITE(6,'(A)')' *** ERROR ***'
                        WRITE(6,'(2A)')' Could not allocate',
     &                                 ' memory for RHELP !'
                        STOP
                     ENDIF
                     JSTART=IVBEG(IHIS)-1
                     NVH=JSTART+NINTVL
                     CALL CHKBND(8,NVH,'SESAME1','VALHIS')
                     DO 153 J=1,NINTVL
                        RHELP(J)=VALHIS(JSTART+J)
 153                 CONTINUE
                     CALL IPOLHI(IHIS,IXDET,E0)
                     CALL ADDVAL(IHIS,NINTVL,RHELP)
                     CALL FREE(P2RHELP)
                  ELSE IF (CVALUE(IHIS)(1:3).EQ.'XKS') THEN
                     DO 154 IXKSHIS=1,NXKSHIS
                        IF (XKSHIS(IXKSHIS).EQ.IHIS) THEN
                           IXDET=XKSDET(IXKSHIS)
                        ENDIF
 154                 CONTINUE
                     CALL IPOLHI(IHIS,IXDET,E0)
                  ENDIF
               ENDIF
               CALL WRHIST(IHIS,IXDET)
            ENDIF
 158     CONTINUE
      ENDIF

*     ---WRITE POSTSCRIPT FILES (IOC,XGD,XDD,AGD,ADD)
      IF (LPOST) THEN
CS         DO 161 IION=1,NSHELL
CS            DO 160 IPS=1,NSCROFION(IION)
CS               IF (SCROFION(IION,IPS).GT.NSCRN) THEN
CS                  CALL DRWLDH(1,IION,0,
CS     &                HISTOFION(IION),SCROFION(IION,IPS),1)
CS               ENDIF
CS 160        CONTINUE
CS 161     CONTINUE
CS         DO 164 IIXCH=1,NXCHAR
CS            ISHTAB=SHELLOFXCHAR(IIXCH)
CS            DO 162 IPS=1,NSCROFXCG(ISHTAB)
CS               IF (SCROFXCG(ISHTAB,IPS).GT.NSCRN) THEN
CS                  CALL DRWLDH(2,ISHTAB,IIXCH,
CS     &                HISTOFION(ISHTAB),SCROFXCG(ISHTAB,IPS),1)
CS               ENDIF
CS 162        CONTINUE
CS            DO 163 IPS=1,NSCROFXCD(ISHTAB)
CS               IF (SCROFXCD(ISHTAB,IPS).GT.NSCRN) THEN
CS                  CALL DRWLDH(3,ISHTAB,IIXCH,
CS     &                HISTOFION(ISHTAB),SCROFXCD(ISHTAB,IPS),
CS     &                XDETSCROFXCD(ISHTAB,IPS))
CS               ENDIF
CS 163        CONTINUE
CS 164     CONTINUE
         DO 161 IPS=NSCRN+1,MXIONPM
            ILAST=0
            ILGLIN=ILOGIONTOSCR(IPS)
            DO 160 J=1,NIONTOPM(IPS)
               ISINDX=(J-1)*NDMAPM+IPS
               CALL CHKBND(17,ISINDX,'SESAME1   ','IONTOPM')
CS               IION=IONTOPM(IPS,J)
               IION=IONTOPM(ISINDX)
               CALL CHKBND(5,IION,'SESAME1   ','HISTOFION')
               IF (J.EQ.NIONTOPM(IPS)) ILAST=1
               CALL DRWLDH(1,J,ILAST,IION,0,
     &                HISTOFION(IION),IPS,1,ILGLIN,
     &                VALION,XCABS)
 160        CONTINUE
 161     CONTINUE
         DO 163 IPS=NSCRN+1,MXXCGSCR
            ILAST=0
            ILGLIN=ILOGXCGTOSCR(IPS)
            DO 162 J=1,NXCGTOSCR(IPS)
               IF (J.EQ.NXCGTOSCR(IPS)) ILAST=1
               IXINDX=(J-1)*(NDMASCRN+NDMAPS)+IPS
               CALL CHKBND(21,IXINDX,'SESAME1   ','XCGTOSCR')
CS               IXTAB=XCGTOSCR(IPS,J)
               IXTAB=XCGTOSCR(IXINDX)
               CALL CHKBND(6,IXTAB,'SESAME1   ','SHELLOFXCHAR')
               ISHTAB=SHELLOFXCHAR(IXTAB)
               CALL CHKBND(5,ISHTAB,'SESAME1   ','HISTOFION')
               CALL DRWLDH(2,J,ILAST,ISHTAB,IXTAB,
     &                HISTOFION(ISHTAB),IPS,1,ILGLIN,
     &                VALION,XCABS)
 162        CONTINUE
 163     CONTINUE
         DO 165 IPS=NSCRN+1,MXXCDSCR
            ILAST=0
            ILGLIN=ILOGXCDTOSCR(IPS)
            DO 164 J=1,NXCDTOSCR(IPS)
               IF (J.EQ.NXCDTOSCR(IPS)) ILAST=1
               IXINDX=(J-1)*(NDMASCRN+NDMAPS)+IPS
               CALL CHKBND(21,IXINDX,'SESAME1   ','XCDTOSCR')
CS               IXTAB=XCDTOSCR(IPS,J)
               IXTAB=XCDTOSCR(IXINDX)
               CALL CHKBND(6,IXTAB,'SESAME1   ','SHELLOFXCHAR')
               ISHTAB=SHELLOFXCHAR(IXTAB)
               CALL CHKBND(5,ISHTAB,'SESAME1   ','HISTOFION')
               CALL DRWLDH(3,J,ILAST,ISHTAB,IXTAB,
cs     &                HISTOFION(ISHTAB),IPS,XDETSCR(IPS,J),ILGLIN,
     &                HISTOFION(ISHTAB),IPS,XDETSCR(IXINDX),ILGLIN,
     &                VALION,XCABS)
 164        CONTINUE
 165     CONTINUE
      	 DO 168 IAUG = 1,NAUGER
            DO 166 IAUG2=1,NADDLOC(IAUG)
               IF (NADDLOC(IAUG).GT.NSCRN) THEN
                  CALL DRWAUG(IAUG,IAUG2,0)
               ENDIF
 166        CONTINUE
            DO 167 IAUG2=1,NAGDLOC(IAUG)
               IF (NAGDLOC(IAUG).GT.NSCRN) THEN
                  CALL DRWAUG(IAUG,IAUG2,1)
               ENDIF
 167        CONTINUE
 168     CONTINUE
      ENDIF

*     ---WRITE BREMSSTRAHLUNG INFORMATION TO ASCII FILE
      IF (LXCONT.AND.(NXCONT.GT.0)) THEN
         CDUMMY='    '//CBL//CBL//CBL//CBL//CBL//CBL
         CDUMMY(1:IEND(JOB)+4)=JOB(1:IEND(JOB))//'.BRM'
         CALL WRXCONT(CDUMMY)
      ENDIF

*     ---DRAW GEOMETRY AGAIN
      IF (LLOC) THEN
         IF (LSCRN) THEN
            KLOC=1
         ELSE
            KLOC=NSCL+1
         ENDIF
         DO 169 ILOC = KLOC,NLOC
            CALL F_OUTPUTTO(NXLOC(ILOC),NS)
            IF (LGRID.AND.LGRD.AND.(ILOC.GT.NSCL))
     &         CALL DRWGRD (ILOC,NS)
            CALL DRWGEO (
     I                   ILOC, NR, IENDIX, ILINES, PCOORD, IQUAD)
      	    CALL DRWAXS(ILOC)
 169     CONTINUE
*        DRAW THE LEGEND FOR THE COLORED TRAJECTORIES
         IF (LSCRN.AND.LCOLTRJ) THEN
            CALL COLLEG(E0,EF)
         ENDIF
      ENDIF

*     WRITE END OF SIMULATION INFORMATION TO OUTPUT FILE
      CALL WROUT(
     I            3,IDUMMY)

***   OUTPUT POLAR DISTRIBUTION AND ENERGY DISTRIBUTION


CAP TEST ESTAT FOR HIGH ENERGY SECONDARIES
CS      CALL EION(1,1,1.0,10)

*** OUTPUT IONISATION STATISTIC
CS      CALL IONSTAT(1.D0,1.D0,1.D0,1.D0,1.D0,1)
CS      CALL SINGSTAT(1,1.D0,1.D0,1.D0,1.D0,1.D0,1)       

CHW CLOSE PS FILES IF OPEN

      IF (LPOST) THEN

         DO 1200 IPS=1,NPS
            CALL F_CLOSEDEVICE(NXLOC(IPS+NSCL),NS)
1200     CONTINUE

      ENDIF

CHW CLOSE X-SCREENS AFTER PROMPT      

      IF (LSCRN.OR.LSTATW) THEN

         CALL STATXT
     &      (' END OF SIMULATION - THANKS FOR USING SeSAME')

	 WRITE (*,*) ' '
	 WRITE (*,*) ' '
	 WRITE (*,*)
     1        'HIT <RETURN> WHEN YOU ARE DONE ADMIRING SeSAME'
	 READ  (*,'(A1)') CEND
	 WRITE (*,*) ' '
	 WRITE (*,*) ' '

         IF (LSCRN) THEN
            DO 1210 IHIS = 1,NSCH
               CALL F_CLOSEDEVICE(NXHIS(IHIS),NS)
1210        CONTINUE

            DO 1220 ISCL = 1,NSCL
               CALL F_CLOSEDEVICE(NXLOC(ISCL),NS)
1220        CONTINUE        
         ENDIF

      ENDIF

c      IF (NXCHAR.GT.0) THEN
c        FCT=6.24219725D9*CURRENT*DSOLIDA(0)/DBLE(NETRN)
c        OPEN(51,FILE='XPEAK.DAT',STATUS='OLD')
c1500    READ(51,'(A)',END=1501)BUFFER
c        GOTO 1500
c1501    CONTINUE
c        IF (NXCHAR.EQ.1)
c     &  WRITE(51,'(F8.2,3F15.4)')E0/1000,
c     &                           XDETOFXCHAR(2)*FCT
c        IF (NXCHAR.EQ.2)
c     &  WRITE(51,'(F8.2,3F15.4)')E0/1000,
c     &                           XDETOFXCHAR(2)*FCT,
c     &                           XDETOFXCHAR(4)*FCT
c        IF (NXCHAR.EQ.3)
c     &  WRITE(51,'(F8.2,3F15.4)')E0/1000,
c     &                           XDETOFXCHAR(2)*FCT,
c     &                           XDETOFXCHAR(4)*FCT,
c     &                           XDETOFXCHAR(6)*FCT
c        IF (NXCHAR.EQ.4)
c     &  WRITE(51,'(F8.2,3F15.4)')E0/1000,
c     &                           XDETOFXCHAR(2)*FCT,
c     &                           XDETOFXCHAR(4)*FCT,
c     &                           XDETOFXCHAR(6)*FCT,
c     &                           XDETOFXCHAR(8)*FCT
c        IF (NXCHAR.EQ.5)
c     &  WRITE(51,'(F8.2,3F15.4)')E0/1000,
c     &                           XDETOFXCHAR(2)*FCT,
c     &                           XDETOFXCHAR(4)*FCT,
c     &                           XDETOFXCHAR(6)*FCT,
c     &                           XDETOFXCHAR(8)*FCT,
c     &                           XDETOFXCHAR(10)*FCT
c        IF (NXCHAR.EQ.6)
c     &  WRITE(51,'(F8.2,3F15.4)')E0/1000,
c     &                           XDETOFXCHAR(2)*FCT,
c     &                           XDETOFXCHAR(4)*FCT,
c     &                           XDETOFXCHAR(6)*FCT,
c     &                           XDETOFXCHAR(8)*FCT,
c     &                           XDETOFXCHAR(10)*FCT,
c     &                           XDETOFXCHAR(12)*FCT
c        CLOSE(51)
c      ENDIF

      RETURN
      END

