c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      SUBROUTINE TAKEDI(
     I                  N,VALUE,R,
     O                  INDX,IERR )

***   TAKEDI - DETERMINE INDEX OF A DISCRETE DISTRIBUTION ACCORDING TO R
*
**    ARGUMENTS
*
*     N      - NUMBER OF VALUES
*     VALUE  - DISCRETE VALUES (ACCUMULATED)
*     R      - RANDUM NUMBER
*     INDX   - INDEX ACCORDING TO RANDOM NUMBER
*     IERR   - ERROR FLAG
*
**    AUTHOR:  C. SCHIEBL  16-JUN-1994
*
      INCLUDE 'TYPE.INC'
CHW      INCLUDE 'GLOBAL.INC'

      DIMENSION VALUE(N)

**    START OF EXECUTABLE CODE
*     ************************

      SUM=0
      INDX=0
      IERR=0

 100  CONTINUE
      RCOMP=R*VALUE(N)
 110  INDX=INDX+1
      IF (INDX.GT.N) THEN
         IERR=1
         GOTO 999
      ENDIF
      IF (VALUE(INDX).LE.RCOMP) GOTO 110

 999  RETURN
      END

