c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
*last modification: 05-Nov-1996

      SUBROUTINE WRPMHI (J)

*     WRPMHI - WRITES HISTOGRAMS TO POSTMINI SAVE FILES
*
*     REMARKS
*
*     J ... HISTOGRAM INDEX
*
*     1) NO REMARKS PRESENTLY
*
*     AUTHOR:  C.SCHIEBL   MARCH 1994

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'FILE.INC'

      CHARACTER*70 CUSTXT,CTITLE
      CHARACTER*10 CBL
      DATA CBL /'          '/


**    START OF EXECUTABLE CODE
*     ************************

      CTITLE='SESAME - 2D HISTOGRAM: '//CVALUE(J)//'    '//CBL//CBL
     &       //CBL//CBL
      CUSTXT='SESAME - 2D HISTOGRAM: '//CVALUE(J)//'    '//CBL//CBL
     &       //CBL//CBL

*     OPEN PROMIS SAVE FILE
      OPEN (NSAVE,FILE=CHFILE(J),STATUS='UNKNOWN',FORM='UNFORMATTED')

      IFRST=IVBEG(J)-1
      VALLO=VBNDLO
      VALUP=VBNDUP
*     WRITE THE CONCENTRATION TO THE OUTPUT FILE
      WRITE (NSAVE) CTITLE
      WRITE (NSAVE) CUSTXT
      WRITE (NSAVE) 1, NVAL(J,1), NVAL(J,2)
      WRITE (NSAVE) 0
      WRITE (NSAVE) .FALSE.
      WRITE (NSAVE) 1
      WRITE (NSAVE) VALLO
      WRITE (NSAVE) VALUP
      WRITE (NSAVE) (VALMIN(J,1)+(IX-0.5)*VDELT(J,1), IX=1,NVAL(J,1))
      WRITE (NSAVE) (VALMIN(J,2)+(IY-0.5)*VDELT(J,2), IY=1,NVAL(J,2))
      DO 90 IY=1, NVAL(J,2)
         WRITE (NSAVE)
     &         (VALHIS(IFRST+(IY-1)*NVAL(J,1)+IX), IX=1,NVAL(J,1))
 90   CONTINUE
      N=IFRST+(NVAL(J,2)-1)*NVAL(J,1)+NVAL(J,1)
      CALL CHKBND (8,N,'WRPMHI','VALHIS')

      CLOSE (NSAVE)

      RETURN
      END
