c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
**    /INIT/
      LOGICAL LIACT,LTEST
      LOGICAL LUSEBK,LXRAY,LXCHAR,LXCONT
      LOGICAL LEBACK,LESEC,LETRAN,LEAUG,LIODIS

      COMMON /INITL/ LUSEBK,LXRAY,LXCHAR,LXCONT,LEBACK,
     +               LESEC,LETRAN,LEAUG,LIODIS,LIACT,LTEST

      CHARACTER*70 CUSTXT,USEBK,BCKLD,FINSTR,FDETCT,FMYDEF
      CHARACTER*30 JOB
      CHARACTER*10 UNITS,CUNITS
      CHARACTER*3  TECHQU
      CHARACTER*2  SIGNAL(NSIG)

      COMMON /INITC/ CUSTXT,USEBK,BCKLD,FINSTR,FDETCT,FMYDEF,JOB,
     +               UNITS,CUNITS,TECHQU,SIGNAL

      COMMON /INITR/ DUNITS

**    /ETRNS/
      LOGICAL LONED
      COMMON /ETRNL/ LONED
      COMMON /ETRNI/ NETRN,MRAND,IARAND,IBRAND,IRAND
      COMMON /ETRNR/ E0,EF

**    /EBEAM/
      LOGICAL SCAN
      COMMON /EBEAML/ SCAN
      COMMON /EBEAMR/ ESTD,DIVERG,SPSIZE,ZFOCUS

**    /TARGET/
      CHARACTER*120 ATOM
      CHARACTER*70  ATMAT(MAXREG),CGFILE
      CHARACTER*2   CATOM(MAXELE)
      COMMON /TARGC/ ATMAT,ATOM,CGFILE,CATOM
      COMMON /LAYERI/ N2,NR,ISTRUC(NRM),ILINES(3*NPTM-6),IENDIX(NRM),
     1                NSCORD,NATOM,ISGMNT(NRM),NSGMNT
      COMMON /LAYERR/ Z2(N2M),ANUM(N2M),PROB(N2M,NRM),PROBS(N2M,NRM),
     1                DENS(NRM),PCOORD(2*NPTM),XSCALE,
     2                SCORDX(NPTM),SCORDZ(NPTM)

**    /MODEL/
      CHARACTER*64 FAUGER
      CHARACTER*3 MODR(NRM)
      CHARACTER*3 IONCRS,BREMSCRS,STOPP
      CHARACTER*40 ION(MAXELE)
      CHARACTER*50 XCHAR(MAXELE)
      COMMON /MODELC/ MODR,FAUGER,ION,XCHAR,IONCRS,BREMSCRS,STOPP

      INTEGER NAHISL,NAHISV
      COMMON /MODELI/ NAHISL,NAHISV

      DOUBLE PRECISION AUGMUL,AHISV
      COMMON /MODELR/ AUGMUL,AHISV

      LOGICAL LELATR(MAXREG),LPOUCH,LGRYZ,LCASNATI,LBETHE
      LOGICAL LWIEDKIRK,LKQP,LPTOB,LBREMS
      COMMON /MODELL/ LELATR,LPOUCH,LGRYZ,LCASNATI,LBETHE,
     +                LWIEDKIRK,LKQP,LPTOB,LBREMS

**    /MSETUP/
      DOUBLE PRECISION MAGNI,EDT(0:MAXEDET,3,3)
      DOUBLE PRECISION TAKOFF(0:MAXXDET),TAKOFR(0:MAXXDET)
      DOUBLE PRECISION COSTAK(0:MAXXDET),SINTAK(0:MAXXDET)
      DOUBLE PRECISION XDEROT(0:MAXXDET),DEROTR(0:MAXXDET)
      DOUBLE PRECISION COSXDER(0:MAXXDET),SINXDER(0:MAXXDET)
      DOUBLE PRECISION EDPHI(0:MAXEDET),EDTHET(0:MAXEDET)
      DOUBLE PRECISION DTAKOFF(0:MAXXDET),DXDEROT(0:MAXXDET)
      DOUBLE PRECISION DEDPHI(0:MAXEDET),DEDTHET(0:MAXEDET)
      DOUBLE PRECISION MTIME,CURRENT
      COMMON /SETUPR/ MAGNI,EBTILT,EBROT,XESPOT,XRANGE,
     +                XEFRST,XELAST,XPREF,TAKOFR,COSTAK,SINTAK,
     +                DEROTR,COSXDER,SINXDER,EBTLTR,EBROTR,
     +                EDT,SCANANG,DTAKOFF,DXDEROT,
     +                DEDPHI,DEDTHET,MTIME,CURRENT

**    /INSTR/
      COMMON /INSTRI/ NLSCP
      COMMON /INSTRR/ XPCRT,XLSCP

**    /DETECT/
      CHARACTER*70 XFDEFF(0:MAXXDET),XLAYMAT(0:MAXXDET,MXDLAY)
      CHARACTER*70 FEDTRN(0:MAXEDET)
      CHARACTER*70 DXFDEFF(0:MAXXDET),DFEDTRN(0:MAXEDET)
      CHARACTER*2  XDTYPE(0:MAXXDET),DXDTYPE(0:MAXXDET)
      COMMON /DETCTC/ XLAYMAT,DXFDEFF,DFEDTRN,DXDTYPE

      DOUBLE PRECISION ESCFAC
      DOUBLE PRECISION XLAYTH(0:MAXXDET,MXDLAY)
      DOUBLE PRECISION XLAYDN(0:MAXXDET,MXDLAY)
      DOUBLE PRECISION XLAYAF(0:MAXXDET,MXDLAY,10)
      DOUBLE PRECISION EDTHMN(0:MAXEDET),EDTHMX(0:MAXEDET)
      DOUBLE PRECISION EDTRN(0:MAXEDET,2,MAXEDTRN)
      DOUBLE PRECISION DEDTHMN(0:MAXEDET),DEDTHMX(0:MAXEDET)
      DOUBLE PRECISION EDACAN(0:MAXEDET)
      DOUBLE PRECISION ELDETWIN(0:MAXEDET,2)
      DOUBLE PRECISION SOLIDA(0:MAXXDET),DSOLIDA(0:MAXXDET)
      DOUBLE PRECISION FWHM(0:MAXXDET),DFWHM(0:MAXXDET)
      DOUBLE PRECISION ENFWHM(0:MAXXDET),DENFWHM(0:MAXXDET)
      COMMON /DETCTR/ XLAYTH,XLAYDN,XLAYAF,
     .                EDTRN,ELDETWIN,EDACAN,DEDTHMN,DEDTHMX,
     .                DSOLIDA,DFWHM,DENFWHM,ESCFAC

      INTEGER NXDET,NEDET,NEDTRN(0:MAXEDET),NDLAY(0:MAXXDET)
      INTEGER LAYXEL(0:MAXXDET,MXDLAY,10),NXLAYMAT(0:MAXXDET,MXDLAY)
      COMMON /DETCTI/ LAYXEL,NXLAYMAT,NDLAY,NXDET,NEDET,NEDTRN

      EQUIVALENCE (TAKOFF(0),DTAKOFF(0))
      EQUIVALENCE (XDEROT(0),DXDEROT(0))
      EQUIVALENCE (XFDEFF(0),DXFDEFF(0))
      EQUIVALENCE (XDTYPE(0),DXDTYPE(0))
      EQUIVALENCE (SOLIDA(0),DSOLIDA(0))
      EQUIVALENCE (FWHM(0),DFWHM(0))
      EQUIVALENCE (ENFWHM(0),DENFWHM(0))
      EQUIVALENCE (EDPHI(0),DEDPHI(0))
      EQUIVALENCE (EDTHET(0),DEDTHET(0))
      EQUIVALENCE (EDTHET(0),DEDTHET(0))
      EQUIVALENCE (EDTHMN(0),DEDTHMN(0))
      EQUIVALENCE (EDTHMX(0),DEDTHMX(0))
      EQUIVALENCE (FEDTRN(0),DFEDTRN(0))

**    /OUTPUT/
      LOGICAL LSCRN,LSCRN1,LSTATW,LSCDEF,LQUAD,LCOLTRJ
      LOGICAL LTRAJ,LTRA,LION
      LOGICAL LETRBK,LBCKSC,LETAB,LPOI,LINT
      LOGICAL LINIABS,LGRAY,LGRD,LAUTOG
      COMMON /OUTPL/ LQUAD,LTRAJ,LTRA,LION,LETAB,LPOI,LINT,LBCKSC,
     &		     LETRBK,LINIABS,LSCRN,LSCRN1,LSTATW,LSCDEF,
     &               LGRAY,LGRID,LGRD,LAUTOG,LCOLTRJ

      CHARACTER*70 FETRBK,FPHI,FETAB
      CHARACTER*70 SCREEN(0:2*MAXSCR),POST(3*MAXPST)
      CHARACTER*70 PMSAV(MAXSAV),HIST(MAXHIS)
      COMMON /OUTPC/ FETRBK,FPHI,FETAB,SCREEN,POST,PMSAV,HIST

      COMMON /OUTPI/ NETRBK,NSCRUP,IQUAD,NSCXSI,NSCYSI,
     &               NPSXSI,NPSYSI,MINICOL,MAXICOL,MNCOLPAL,
     &               NXGRID,NYGRID,NZGRID

      COMMON /OUTPR/ DENSUM,DEESUM

**    /GRID/
      CHARACTER*70  CGRDFL
      DOUBLE PRECISION WGTGRD(1)
      POINTER (P2WGTGRD,WGTGRD)
      DOUBLE PRECISION XGRIDL(1)
      POINTER (P2XGRIDL,XGRIDL)
      DOUBLE PRECISION ZGRIDL(1)
      POINTER (P2ZGRIDL,ZGRIDL)
      DOUBLE PRECISION YGRIDL(1)
      POINTER (P2YGRIDL,YGRIDL)
      COMMON /GRIDC/ CGRDFL      
      COMMON /GRIDI/ NGRIDX,NGRIDZ,NGRIDY
CS      COMMON /GRIDR/ XGRIDL(NXM),ZGRIDL(NZM),YGRIDL(NYM),WGTGRD(NXM,NZM)
      COMMON /GRIDP / P2XGRIDL,P2ZGRIDL,P2YGRIDL,P2WGTGRD

***   DESCRIPTION OF PARAMETERS AND COMMON BLOCKS
*
**    /INIT/ INITIALIZATION
*
*     CUSTXT - USER SUPPLIED TEXT
*     USEBK  - USE A BACKUP FILE (CONTAINS THE BACKUP FILE NAME)
*     FINSTR - FILE NAME FOR INSTRUMENT SPECIFIC PARAMETERS
*     FDETCT - FILE NAME FOR DETECTOR SPECIFIC PARAMETERS
*     FMYDEF - FILE NAME FOR USER SPECIFIC PARAMETERS
*     JOB    - JOB NAME
*     TECHQU - MEASUREMENT TECHNIQUE (EMP,SEM,TEM,AES)
*     SIGNAL - SIGNAL OF INTEREST (XR,SE,BE,TE,AE)
*     UNITS  - UNITS OF LENGTH
*     CUNITS - FULL NAME OF UNITS OF LENGTH
*     NUNITS - MULTIPLICATION FACTOR TO TRANSFROM FROM UNITS TO NGSTROM
*     LUSEBK - IF .TRUE. USE BACKUP FILE
*     LXRAY  - IF .TRUE. SIMULATE CHAR. AND CONT. X-RAYS
*     LXCHAR - IF .TRUE. SIMULATE CHARACTERISTIC X-RAYS
*     LXCONT - IF .TRUE. SIMULATE CONTINOUS X-RAYS
*     LEBACK - IF .TRUE. SIMULATE BACKSCATTERED ELECTRONS
*     LESEC  - IF .TRUE. SIMULATE SECONDARY ELECTRONS
*     LETRAN - IF .TRUE. SIMULATE TRANSMITTED ELECTRONS
*     LEAUG  - IF .TRUE. SIMULATE AUGER ELECTRONS
*     LIODIS - IF .TRUE. SIMULATE IONISATION DISTRIBUTION
*
**    /ETRNS/ PROPERTIES OF THE ELECTRONS
*
*     NETRN  - NUMBER OF ELECTRONS
*     MRAND  - COMPONENT OF THE SEED OF THE RANDOM NUMBER GENERATOR
*     IARAND - COMPONENT OF THE SEED OF THE RANDOM NUMBER GENERATOR
*     IBRAND - COMPONENT OF THE SEED OF THE RANDOM NUMBER GENERATOR
*     IRAND  - COMPONENT OF THE SEED OF THE RANDOM NUMBER GENERATOR
*     E0     - INITIAL ENERGY OF THE ELECTRONS (EV)
*     EF     - CUTOFF ENERGY FOR ELECTRON TRAJECTORIES (EV)
*     LONED  - not needed in future (aus INIT und SESAME raus)
*
**    /EBEAM/ PROPERTIES OF THE ELECTRON BEAM
*
*     SCAN   - SCANNING IF TRUE
*     ESTD   - STANDARD DEVIATION OF ELECTRON ENERGY
*     DIVERG - BEAM DIVERGENCE (DEGREE)
*     SPSIZE - SPOT SIZE OF ELECTRON BEAM
*     ZFOCUS - Z COORDINATE OF BEAM FOCUS AT POSITION XESPOT
*
**    /TARGET/ PROPERTIES OF THE TARGET
*
*     N2M    - MAXIMUM NUMBER OF TARGET ATOMS
*     N2     - NUMBER OF TARGET ATOMS
*     Z2     - ATOMIC NUMBER OF THE TARGET ATOMS
*     NRM    - MAXIMUM NUMBER OF REGIONS (LAYERS)
*     NPTM   - MAXIMUM NUMBER OF POINTS
*     NR     - NUMBER OF REGIONS (LAYERS)
*     ISTRUC - STRUCTURE OF THE LAYER
*              ISTRUC=1: CRYSTALLINE
*              ISTRUC=2: AMORPHOUS
*     NSGMNT - TOTAL NUMBER OF SEGMENTS (=MATERIALS) IN SIMULATION
*     ISGMNT - SEGMENT (= MATERIAL) OF REGION
*     ILINES - LINES OF THE GEOMETRY
*     IENDIX - ENINDICES OF THE LINES DEFINING A FACE
*     PROB   - PROBABILITY TO ENCOUNTER ATOM I2 IN LAYER IR
*     PROBS  - SUM OF ALL PROB WITH INDICES .LE. I2
*     DENS   - DENSITY (g/cm)
*     PCOORD - COORDINATES OF THE POINTS
*     SCORDX - X COORDINATES OF SURFACE POINTS
*     SCORDZ - Z      "       "   "       "
*     NSCORD - NUMBER OF SURFACE POINTS
*     CGFILE - GEOMETRY FILE NAME
*     CATOM  - CHEMICAL ABBREVIATIONS OF SPECIFIED TARGET ATOMS (ATOM IN
*              &TARGET)
*     ANUM   - ATOMIC NUMBERS OF SPECIFIED TARGET ATOMS (ATOM IN &TARGET)
*
**    /MODEL/ PROPERTIES OF THE MODEL(S)
*
*     FAUGER - AUGER ELECTRON FILE NAME
*     MODR   - MODEL IN REGION (HYB,SIN,DIR)
*     ION  - SHELLS TAKEN INTO ACCOUNT FOR IONIZATION
*     XCHAR  - CHAR. X-RAY TAKEN INTO ACCOUNT     
*     AUGMUL - MULTIPLICATION FACTOR IN AUGER SIMULATION
*     NAHISL - # OF LATERAL INTERVALLS FOR AGD/ADD
*     NAHISV - # OF VERTICAL    "       "     "
*     AHISV  - MAXIMUM DEPTH FOR AUGER GENERATION SIMULATION
*
**    /MSETUP/ PROPERTIES OF THE MEASURMENT SETUP
*
*     MAGNI  - MAGNEFICATION
*     TAKOFF - DETECTOR TAKE OF ANGLE (DEG)
*     XDEROT  - DETECTOR ROTATION ANGLE (DEG)
*     EBTILT - ELECTRON BEAM TILT ANGLE (DEG)
*     EBROT  - ELECTRON BEAM ROTATION ANGLE (DEG)
*     TAKOFR - DETECTOR TAKE-OFF ANGLE (RAD)
*     COSTAK - COSIN OF TAKE-OFF ANGLE
*     SINTAK - SINE OF TAKE-OFF ANGLE
*     DEROTR - DETECTOR ROTATION ANGLE (RAD)
*     COSXDER- COSIN OF DETECTOR AZIMUTHAL ANGLE
*     SINXDER- SINE OF DETECTOR AZIMUTHAL ANGLE
*     EBTLTR - ELECTRON BEAM TILT ANGLE (RAD)
*     EBROTR - ELECTRON BEAM ROTATION ANGLE (RAD)
*     XESPOT - LATERAL ELECTRON IMPACT POSITION
*     XRANGE - LATERAL SCANNING AREA
*     SCANANG- ANGLE BETWEEN X-AXIS AND SCAN DIRECTION
*
**    /INSTR/ PROPERTIES OF THE ANALYSIS INSTRUMENT
*
*     NLSCP  - NUMBER OF LATERAL SCAN POSITIONS
*     XPCRT  - PIXEL DISTANCE ON CRT
*
**    /DETECT/ PROPERTIES OF THE DETECTOR
*
*     XFDEFF - FILE NAME FOR DETECTOR EFFICIENCY
*     XLAYTH - THICKNESS OF X-RAY DETECTOR LAYERS
*     XLAYDN - DENSITY OF X-RAY DETECTOR LAYERS
*     XLAYMAT- MATERIAL (ELEMENTS AND ATOMIC FRACTIONS) IN X-RAY DETECTOR LAYERS
*     XLAYAF - ATOMIC FRACTION OF X-RAY DETECTOR LAYERS
*     EDEFF  - FILENAME OF ELECTRON DETECTOR EFFICIENCY
*     EDTRN  - ARRAY OF ELECTRON DETECTOR TRANSMISSION
*     NEDTRN - SIZE OF ARRAY EDTRN
*     EDTHMN,EDTHMX - POLAR RANGE OF DETECTOR ACCEPTANCE 
*     EDTHET - POLAR ANGLE OF DETECTOR POSITION
*     EDACAN - SOLID ANGLE OF ACCEPTANCE OF DETECTOR
*     ELDETWIN - ELECTRON DETECTOR ENERGY WINDOW
*     EDPHI  - PHI    "     "    "         "
*     EDT    - TRANSFORMATION MATRIX FOR COORD SYSTEM OF DETECTOR


 
**    /OUTPUT/ OUTPUT PROPERTIES
*     LTRAJ  - IF .TRUE.: OUTPUT OF TRAJECTORIES ON THE SCREEN
*     LION   - IF .TRUE.: OUTPUT OF IONIZATION ON THE SCREEN (=LSCL(6))
*     LPOI   - IF .TRUE.: OUTPUT OF ENDPOINTS
*     LTRA   - IF .TRUE.: OUTPUT OF TRAJECTORIES
*     LINT   - IF .TRUE.: OUTPUT OF INTERACTION HISTORY
*     LETAB  - IF .TRUE.: STARTING ELECTRON PROPERTIES FROM FILE
*     NETRBK - NUMBER OF ELECTRONS AFTER WHICH A BACKUP IS PERFORMED
*     NSCRUP - NUMBER OF ELECTRONS FOR SCREEN UPDATE
*     MINICOL- MAP COLORS ORIGINALLY BETWEEN MINICOL AND MAXICOL TO 
*     MAXICOL- MNCOLPAL TO NPALET
*     MNCOLPAL-TAKE ONLY COLORS BETWEEN MNCOLPAL AND NPALET OF COLOR PALETTE 
*     IQUAD  - IF 1: QUADTREE IS DRAWN IN THE WINDOW
*     FETRBK - BACKUP FILE NAME
*     FPHI   - PHI(X,Z) FILE NAME
*     FETAB  - TABULATED ELECTRON'S FILE NAME
*     SCREEN - DATA FOR VISUALIZATION ON SCREEN
*     POST   - DATA FOR OUTPUT TO POSTSCRIPT FILE
*     PMSAV  - DATA FOR OUTPUT TO POSTMINI SAV FILE
*     HIST   - DATA FOR OUTPUT TO HISTOGRAM FILE
*     DENSUM - SUM OF NUCLEAR ENERGY LOSSES SINCE START OF TRAJECTORY
*     DEESUM - SUM OF ELECTRONIC ENERGY LOSSES SINCE START OF TRAJECTORY
*
**    /GRID/ VARIABLES FOR THE GRID (COMPARE PROMIS!)
*
*     NXM    - MAXIMUM NUMBER OF GRIDLINES X
*     NZM    - MAXIMUM NUMBER OF GRIDLINES Z
*     NYM    - MAXIMUM NUMBER OF GRIDLINES Y
*     CGRDFL - NAME OF GRIDFILE
*     NGRIDX - ACTUAL NUMBER OF GRIDLINES X
*     NGRIDZ - ACTUAL NUMBER OF GRIDLINES Z
*     NGRIDY - ACTUAL NUMBER OF GRIDLINES Y
*     XGRIDL - GRIDLINES X
*     ZGRIDL - GRIDLINES Z
*     YGRIDL - GRIDLINES Y






