c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      PROGRAM AS2BIN

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

***   WRSAVE - CONVERTS THE ASCII FILE TO A BINARY PROMIS LIKE OUTPUT.
*
**    AUTHOR:  H.STIPPEL   07-MAR-1994
*
      PARAMETER    (NLXM = 100, NLZM = 100)
      CHARACTER*70 CTITLE, CUSTXT
      LOGICAL      LINEAR
      DIMENSION    XGRIDL(NLXM), ZGRIDL(NLZM)
      DIMENSION    W(NLXM,NLZM)

**    START OF EXECUTABLE CODE
*     ************************

*     READ THE CONCENTRATION FROM THE FILE
      OPEN (36,FILE='PROMIS.ASC',STATUS='UNKNOWN',FORM='FORMATTED')
      READ (36,'(A)') CTITLE
      READ (36,'(A)') CUSTXT
      READ (36,*) NEQU, NGRIDZ, NGRIDX
      READ (36,*) IZ1
      READ (36,*) LINEAR
      READ (36,*) INTMOD
      READ (36,*) VBNDLO
      READ (36,*) VBNDUP
      READ (36,*) (ZGRIDL(IZ), IZ=1,NGRIDZ)
      READ (36,*) (XGRIDL(IX), IX=1,NGRIDX)
      DO 10 IZ=1, NGRIDZ
         READ (36,*) (W(IX,IZ), IX=1,NGRIDX)
 10   CONTINUE
      CLOSE (36)

*     WRITE THE CONCENTRATION TO AN ASCII FILE
      OPEN (35,FILE='PROMIS.SAV',STATUS='UNKNOWN',FORM='UNFORMATTED')
      WRITE (35) CTITLE
      WRITE (35) CUSTXT
      WRITE (35) NEQU, NGRIDZ, NGRIDX
      WRITE (35) IZ1
      WRITE (35) LINEAR
      WRITE (35) INTMOD
      WRITE (35) VBNDLO
      WRITE (35) VBNDUP
      WRITE (35) (ZGRIDL(IZ), IZ=1,NGRIDZ)
      WRITE (35) (XGRIDL(IX), IX=1,NGRIDX)
      DO 20 IZ=1, NGRIDZ
         WRITE (35) (W(IX,IZ), IX=1,NGRIDX)
 20   CONTINUE
      CLOSE (35)

      STOP
      END
