c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      PROGRAM BIN2AS

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

***   WRSAVE - CONVERTS THE BINARY PROMIS LIKE OUTPUT FROM IMSIL2D
*              TO AN ASCII FILE.
*
**    AUTHOR:  H.STIPPEL   07-MAR-1994
*
      PARAMETER    (NLXM = 100, NLZM = 100)
      CHARACTER*70 CTITLE, CUSTXT
      LOGICAL      LINEAR
      DIMENSION    XGRIDL(NLXM), ZGRIDL(NLZM)
      DIMENSION    W(NLXM,NLZM)

**    START OF EXECUTABLE CODE
*     ************************

*     READ THE CONCENTRATION FROM THE FILE
      OPEN (35,FILE='PROMIS.SAV',STATUS='UNKNOWN',FORM='UNFORMATTED')
      READ (35) CTITLE
      READ (35) CUSTXT
      READ (35) NEQU, NGRIDZ, NGRIDX
      READ (35) IZ1
      READ (35) LINEAR
      READ (35) INTMOD
      READ (35) VBNDLO
      READ (35) VBNDUP
      READ (35) (ZGRIDL(IZ), IZ=1,NGRIDZ)
      READ (35) (XGRIDL(IX), IX=1,NGRIDX)
      DO 10 IZ=1, NGRIDZ
         READ (35) (W(IX,IZ), IX=1,NGRIDX)
 10   CONTINUE
      CLOSE (35)

*     WRITE THE CONCENTRATION TO AN ASCII FILE
      OPEN (36,FILE='PROMIS.ASC',STATUS='UNKNOWN',FORM='FORMATTED')
      WRITE (36,*) CTITLE
      WRITE (36,*) CUSTXT
      WRITE (36,*) NEQU, NGRIDZ, NGRIDX
      WRITE (36,*) IZ1
      WRITE (36,*) LINEAR
      WRITE (36,*) INTMOD
      WRITE (36,*) VBNDLO
      WRITE (36,*) VBNDUP
      WRITE (36,*) (ZGRIDL(IZ), IZ=1,NGRIDZ)
      WRITE (36,*) (XGRIDL(IX), IX=1,NGRIDX)
      DO 20 IZ=1, NGRIDZ
         WRITE (36,*) (W(IX,IZ), IX=1,NGRIDX)
 20   CONTINUE
      CLOSE (36)

      STOP
      END
