c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
*******************************************************************************
 
      SUBROUTINE FIND (
     I                 STRING,TOKEN,ISTART,LIMIT,
     O                 IFIPOS,
     E                 IFOUND                     )
 
 
      INCLUDE 'TYPE.INC'
 
****  FIND - SEARCH FOR THE FIRST APPEARENCE OF A SINGLE CHARACTER (TOKEN)
*            IN A STRING (STRING) BETWEEN ISTART AND LIMIT
*
*     CHRISTIAN SCHIEBL
*     CEC-VIENNA
*     DECEMBER 1990
*
*     INPUT PARAMETERS:
*
*         STRING.....STRING OF INVESTIGATION
*         TOKEN......A SINGLE CHARACTER WHICH IS SEARCHED IN STRING
*         ISTART.....START POSITION FOR SEARCH
*         LIMIT......END POSITION FOR SEARCH
*
*     OUTPUT PARAMETERS:
*
*         IFIPOS.....POSITION IN STRING WHERE TOKEN MATCHES THE FIRST TIME
*         IFOUND.....SEARCH SUCCESS (1=YES,0=NO)
*
 
      INTEGER      YES,NO
      INTEGER      LIMIT
 
      CHARACTER*80 STRING
      CHARACTER*1  TOKEN
 
      PARAMETER (YES = 1, NO = 0)
 
***** START OF EXECUTABLE CODE *****
*     ========================
*
      IFIPOS = 0
 
      I = ISTART
 10   IF (STRING(I:I).NE.TOKEN) THEN
          IF (I.LT.LIMIT) THEN
              I = I+1
              GOTO 10
          ELSE
              IFOUND = NO
          ENDIF
      ELSE
          IFOUND = YES
          IFIPOS = I
      ENDIF
 
      RETURN
      END
 
*******************************************************************************
