c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
*       ****************************************************************
 
        FUNCTION JPOT (Z)
 
*       JPOT - MEAN IONIZATION POTENTIAL [C. ZELLER ACCORDING TO RUSTE
*              AND CANTOIS 1975] [eV]
*
*	AUTHOR: C. SCHIEBL, JUNE 1994
*               CEC-VIENNA
*               DIGITAL EQUIPMENT CORPORATION

        INTEGER Z
        DOUBLE PRECISION  JPOT,ZZ

*** START OF EXECUTABLE CODE
*
        ZZ = DBLE(Z)

CHWAP        JPOT = (10.04+8.25*DEXP(-ZZ/11.22))*0.001*ZZ
CHWAP        JPOT = JPOT/1000
        JPOT = (10.04+8.25*DEXP(-ZZ/11.22))*ZZ
        RETURN
        END

*       ****************************************************************

