c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
***   ZZZDAT - GET DATE AND TIME
***   ZZZSEC - GET CPU-TIME SINCE START OF JOB
*
*     S. Selberherr   1987   (vax vms version)
*     W. Juengling    1987   (ultrix  version)
*        (AT&T)
*     M. Stiftinger   1991   (hp 9000 version)
*     C. Fischer      1991
*

**    Dec stations ultrix
**    START OF EXECUTABLE CODE

#ifndef OPERATING_SYSTEM_RECOGNIZED
#ifdef ultrix
#define OPERATING_SYSTEM_RECOGNIZED

      SUBROUTINE ZZZDAT (DATTIM)
#include "TYPE.INC"
      CHARACTER DATTIM*20,F*24
      REAL ETIME,TIME(2)
      CALL FDATE(F)
      DATTIM=' '//F(9:10)//'-'//F(5:7)//'-'//F(23:24)//' '//
     ,       F(12:19)//' '
      RETURN
      ENTRY ZZZSEC (CPUTIM)
      CPUTIM=ETIME(TIME)
      CPUTIM=TIME(1)
      END
#endif /* ultrix */
#endif


**    VAX VMS

#ifndef OPERATING_SYSTEM_RECOGNIZED
#ifdef vms
#define OPERATING_SYSTEM_RECOGNIZED

      SUBROUTINE ZZZDAT (DATTIM)
#include "TYPE.INC"
      CHARACTER DATTIM*20,CDATE*9,CTIME*8
      LOGICAL LINITM
      SAVE LINITM
      DATA LINITM /.TRUE./
      CALL DATE (CDATE)
      CALL TIME (CTIME)
      DATTIM=' '//CDATE//' '//CTIME//' '
      RETURN
      ENTRY ZZZSEC (CPUTIM)
      IF (LINITM) THEN
         LINITM=.FALSE.
         CALL LIB$INIT_TIMER
         CPUTIM=0
      ELSE
         CALL LIB$STAT_TIMER (2,ISEC)
         CPUTIM=ISEC*0.01
      ENDIF
      END
#endif /* vms */
#endif


**    Dummy version

#ifndef OPERATING_SYSTEM_RECOGNIZED

      SUBROUTINE ZZZDAT (DATTIM)
#include "TYPE.INC"
      CHARACTER*20 DATTIM
      DATTIM=' YE/MO/DA  HO:MI:SE '
      RETURN
      ENTRY ZZZSEC (CPUTIM)
      CPUTIM=0
      END
#endif /* dummy version */
