/*****************************************************************************/
/*     Copyright (c) 2000, Compaq Computer Corporation                       */
/*                                                                           */
/*  See the file "license.terms" for information on usage and redistribution */
/*  of this file, and for a DISCLAIMER OF ALL WARRANTIES.                    */
/*****************************************************************************/
#include <stdio.h>
#include <string.h>

#ifdef ultrix
#include <netdnet/dn.h>

void zzznod_ (char *name, long namlen)
{
   int i;
   
   strcpy (name, getnodename());
   for (i = strlen(name); i < namlen; i++)
      name[i] = ' ';
}
#endif

#ifdef __hpux
#include <unistd.h>

void zzznod (char *name, long namlen)
{
   int i;
   size_t size;
   
   size = namlen;
   gethostname (name, size);
   for (i = strlen(name); i < namlen; i++)
      name[i] = ' ';
}
#endif

#ifdef __osf__

void zzznod_ (char *name, long namlen)
{
   int i;
   size_t size;
   
   size = namlen;
   gethostname (name, size);
   for (i = strlen(name); i < namlen; i++)
      name[i] = ' ';
}
#endif


#ifndef ultrix
#ifndef __hpux
#ifndef __osf
void zzznod (char *name, long namlen)
{
   strcpy (name, "Some Machine   ");
}
#endif
#endif
#endif
